/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will certainly be overwritten.
 */

/* 
 * (C) 2001 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#ifdef WIN32
#include "wincommon.h"
#else
#include <unistd.h>
#include <sys/time.h>
#endif
#include <fcntl.h>

#include "state-machine.h"
#include "client-state-machine.h"
#include "job-time-mgr.h"

/*
 * now included from client-steate-machine.h
 */
#if 0
extern job_context_id pint_client_sm_context;
#endif


static PINT_sm_action job_timer_do_work(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_do_work;
static struct PINT_tran_tbl_s ST_do_work_trtbl[];

static PINT_sm_action job_timer_error(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_error;
static struct PINT_tran_tbl_s ST_error_trtbl[];

struct PINT_state_machine_s pvfs2_client_job_timer_sm = {
	.name = "pvfs2_client_job_timer_sm",
	.first_state = &ST_do_work
};

static struct PINT_state_s ST_do_work = {
	 .state_name = "do_work" ,
	 .parent_machine = &pvfs2_client_job_timer_sm ,
	 .flag = SM_RUN ,
	 .action.func = job_timer_do_work ,
	 .pjtbl = NULL ,
	 .trtbl = ST_do_work_trtbl 
};

static struct PINT_tran_tbl_s ST_do_work_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_do_work },
	{ .return_value = -1 ,
	 .next_state = &ST_error }
};

static struct PINT_state_s ST_error = {
	 .state_name = "error" ,
	 .parent_machine = &pvfs2_client_job_timer_sm ,
	 .flag = SM_RUN ,
	 .action.func = job_timer_error ,
	 .pjtbl = NULL ,
	 .trtbl = ST_error_trtbl 
};

static struct PINT_tran_tbl_s ST_error_trtbl[] = {
	{ .return_value = -1 ,

	 .flag = SM_TERM }
};

#ifndef WIN32
# 46 "src/client/sysint/client-job-timer.sm"
#endif


/* job_timer_error()
 *
 * cleans up any resources consumed by this state machine and ends
 * execution of the machine
 */
static PINT_sm_action job_timer_error(
    struct PINT_smcb *smcb, job_status_s* js_p)
{
    gossip_debug(GOSSIP_CLIENT_DEBUG,
                 "job timer state: job_timer_error\n");
    gossip_err("Error: stopping client job timer.\n");

    PINT_SET_OP_COMPLETE;
    return SM_ACTION_TERMINATE;
}

/* job_timer_do_work()
 *
 * resets counters, updates metrices, etc- this is intended to be
 * called repeatedly on a regular interval
 */
static PINT_sm_action job_timer_do_work(
    struct PINT_smcb *smcb, job_status_s* js_p)
{
    int ret = -1;
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

#if 0
    gossip_debug(GOSSIP_CLIENT_DEBUG,
                 "job timer state: job_timer_do_work\n");
#endif

    /* look for expired jobs */
    ret = job_time_mgr_expire();
    if (ret < 0)
    {
        js_p->error_code = ret;
        return SM_ACTION_COMPLETE;
    }
        
    /* post another timer */
    return job_req_sched_post_timer(
        1000, smcb, 0, js_p, &sm_p->u.job_timer.job_id, pint_client_sm_context);
}

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */
