/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will certainly be overwritten.
 */

/* 
 * (C) 2003 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */

/** \file
 *  \ingroup mgmtint
 *
 *  PVFS2 management interface routines for creating directory entries
 *  that point to specific existing objects.  These are used primarily
 *  for file system repair purposes.
 */

#include <string.h>
#include <assert.h>

#include "client-state-machine.h"
#include "pvfs2-debug.h"
#include "job.h"
#include "gossip.h"
#include "str-utils.h"
#include "pint-cached-config.h"
#include "PINT-reqproto-encode.h"
#include "pvfs2-internal.h"
#include "dist-dir-utils.h"

/*
 * Now included from client-state-machine.h
 */
#if 0
extern job_context_id pint_client_sm_context;
#endif

static int mgmt_create_dirent_comp_fn(
    void *v_p, struct PVFS_server_resp *resp_p, int i);


static PINT_sm_action mgmt_create_dirent_init(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_init;
static struct PINT_tran_tbl_s ST_init_trtbl[];
static struct PINT_state_s ST_create_dirent_get_capability;
static struct PINT_tran_tbl_s ST_create_dirent_get_capability_trtbl[];

static PINT_sm_action mgmt_create_dirent_setup_msgpair(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_create_dirent_setup_msgpair;
static struct PINT_tran_tbl_s ST_create_dirent_setup_msgpair_trtbl[];
static struct PINT_state_s ST_create_dirent_xfer_msgpair;
static struct PINT_tran_tbl_s ST_create_dirent_xfer_msgpair_trtbl[];

static PINT_sm_action mgmt_create_dirent_retry_or_fail(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_create_dirent_retry_or_fail;
static struct PINT_tran_tbl_s ST_create_dirent_retry_or_fail_trtbl[];

static PINT_sm_action mgmt_create_dirent_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_cleanup;
static struct PINT_tran_tbl_s ST_cleanup_trtbl[];

struct PINT_state_machine_s pvfs2_client_mgmt_create_dirent_sm = {
	.name = "pvfs2_client_mgmt_create_dirent_sm",
	.first_state = &ST_init
};

static struct PINT_state_s ST_init = {
	 .state_name = "init" ,
	 .parent_machine = &pvfs2_client_mgmt_create_dirent_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_dirent_init ,
	 .pjtbl = NULL ,
	 .trtbl = ST_init_trtbl 
};

static struct PINT_tran_tbl_s ST_init_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_create_dirent_get_capability }
};

static struct PINT_state_s ST_create_dirent_get_capability = {
	 .state_name = "create_dirent_get_capability" ,
	 .parent_machine = &pvfs2_client_mgmt_create_dirent_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_client_getattr_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_create_dirent_get_capability_trtbl 
};

static struct PINT_tran_tbl_s ST_create_dirent_get_capability_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_create_dirent_setup_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_create_dirent_setup_msgpair = {
	 .state_name = "create_dirent_setup_msgpair" ,
	 .parent_machine = &pvfs2_client_mgmt_create_dirent_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_dirent_setup_msgpair ,
	 .pjtbl = NULL ,
	 .trtbl = ST_create_dirent_setup_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_create_dirent_setup_msgpair_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_create_dirent_xfer_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_create_dirent_xfer_msgpair = {
	 .state_name = "create_dirent_xfer_msgpair" ,
	 .parent_machine = &pvfs2_client_mgmt_create_dirent_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_msgpairarray_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_create_dirent_xfer_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_create_dirent_xfer_msgpair_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_cleanup },
	{ .return_value = -1 ,
	 .next_state = &ST_create_dirent_retry_or_fail }
};

static struct PINT_state_s ST_create_dirent_retry_or_fail = {
	 .state_name = "create_dirent_retry_or_fail" ,
	 .parent_machine = &pvfs2_client_mgmt_create_dirent_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_dirent_retry_or_fail ,
	 .pjtbl = NULL ,
	 .trtbl = ST_create_dirent_retry_or_fail_trtbl 
};

static struct PINT_tran_tbl_s ST_create_dirent_retry_or_fail_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_create_dirent_get_capability },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_cleanup = {
	 .state_name = "cleanup" ,
	 .parent_machine = &pvfs2_client_mgmt_create_dirent_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_dirent_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_cleanup_trtbl[] = {
	{ .return_value = -1 ,

	 .flag = SM_TERM }
};

#ifndef WIN32
# 82 "src/client/sysint/mgmt-create-dirent.sm"
#endif


/** Initiate creation of a directory entry pointing to a specific object.
 */
PVFS_error PVFS_imgmt_create_dirent(
    PVFS_object_ref parent_ref,
    char *entry,
    PVFS_handle entry_handle,
    const PVFS_credential *credential,
    PVFS_mgmt_op_id *op_id,
    PVFS_hint hints,
    void *user_ptr)
{
    PVFS_error ret = -PVFS_EINVAL;
    PINT_smcb *smcb = NULL;
    PINT_client_sm *sm_p = NULL;

    gossip_debug(GOSSIP_CLIENT_DEBUG,
                 "PVFS_imgmt_create_dirent entered\n");

    if ((parent_ref.handle == PVFS_HANDLE_NULL) ||
        (parent_ref.fs_id == PVFS_FS_ID_NULL) ||
        (entry_handle == PVFS_HANDLE_NULL) || !entry)
    {
        gossip_err("invalid (NULL) required argument\n");
        return ret;
    }

    PINT_smcb_alloc(&smcb, PVFS_MGMT_CREATE_DIRENT,
             sizeof(struct PINT_client_sm),
             client_op_state_get_machine,
             client_state_machine_terminate,
             pint_client_sm_context);
    if (smcb == NULL)
    {
        return -PVFS_ENOMEM;
    }
    sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    PINT_init_msgarray_params(sm_p, parent_ref.fs_id);
    PINT_init_sysint_credential(sm_p->cred_p, credential);
    sm_p->parent_ref = parent_ref;
    sm_p->u.mgmt_create_dirent.entry = entry;
    sm_p->u.mgmt_create_dirent.entry_handle = entry_handle;
    sm_p->u.mgmt_create_dirent.retry_count = 0;
    PVFS_hint_copy(hints, &sm_p->hints);

    gossip_debug(
        GOSSIP_CLIENT_DEBUG, "Trying to create dirent %s under %llu,%d\n",
        sm_p->u.mgmt_create_dirent.entry, llu(parent_ref.handle),
        parent_ref.fs_id);

    return PINT_client_state_machine_post(
        smcb,  op_id, user_ptr);
}

/** Create a directory entry pointing to a specific object.
 */
PVFS_error PVFS_mgmt_create_dirent(
    PVFS_object_ref parent_ref,
    char *entry,
    PVFS_handle entry_handle,
    const PVFS_credential *credential,
    PVFS_hint hints)
{
    PVFS_error ret = -PVFS_EINVAL, error = 0;
    PVFS_mgmt_op_id op_id;

    gossip_debug(GOSSIP_CLIENT_DEBUG,
                 "PVFS_mgmt_create_dirent entered\n");

    ret = PVFS_imgmt_create_dirent(
        parent_ref, entry, entry_handle, credential, &op_id, hints, NULL);
    if (ret)
    {
        PVFS_perror_gossip("PVFS_imgmt_create_dirent call", ret);
        error = ret;
    }
    else
    {
        ret = PVFS_mgmt_wait(op_id, "create_dirent", &error);
        if (ret)
        {
            PVFS_perror_gossip("PVFS_mgmt_wait call", ret);
            error = ret;
        }
    }

    PINT_mgmt_release(op_id);
    return error;
}

/****************************************************************/

static int mgmt_create_dirent_init(
    struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    gossip_debug(GOSSIP_CLIENT_DEBUG, "mgmt_create_dirent_init called\n");

    PINT_SM_GETATTR_STATE_CLEAR(sm_p->getattr);

    PINT_SM_GETATTR_STATE_FILL(
        sm_p->getattr,
        sm_p->parent_ref,
        PVFS_ATTR_COMMON_ALL|PVFS_ATTR_DIR_HINT|
            PVFS_ATTR_CAPABILITY|PVFS_ATTR_DISTDIR_ATTR,
        PVFS_TYPE_DIRECTORY,
        0);

    assert(js_p->error_code == 0);
    return SM_ACTION_COMPLETE;
}

static int mgmt_create_dirent_setup_msgpair(
    struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    PINT_sm_msgpair_state *msg_p = NULL;
    PVFS_dist_dir_hash_type dirdata_hash;
    int dirdata_server_index;

    js_p->error_code = 0;

    /* find the hash value and the dist dir bucket */
    dirdata_hash = PINT_encrypt_dirdata(sm_p->u.mgmt_create_dirent.entry);
    gossip_debug(GOSSIP_CLIENT_DEBUG, " encrypt dirent %s into hash value %llu.\n",
            sm_p->u.mgmt_create_dirent.entry,
            llu(dirdata_hash));

    dirdata_server_index =
        PINT_find_dist_dir_bucket(dirdata_hash,
            &sm_p->getattr.attr.dist_dir_attr,
            sm_p->getattr.attr.dist_dir_bitmap);
    gossip_debug(GOSSIP_CLIENT_DEBUG, " selecting bucket No.%d from dist_dir_bitmap.\n",
            dirdata_server_index);

    PINT_msgpair_init(&sm_p->msgarray_op);
    msg_p = &sm_p->msgarray_op.msgpair;

    gossip_debug(
        GOSSIP_CLIENT_DEBUG, " creating dirent entry %s with "
        "handle %llu under parent %llu,%d\n",
        sm_p->u.mgmt_create_dirent.entry,
        llu(sm_p->u.mgmt_create_dirent.entry_handle),
        llu(sm_p->parent_ref.handle), sm_p->parent_ref.fs_id);

    /* TODO: Need to call PINT_free_object_attr? */
    PINT_SERVREQ_CRDIRENT_FILL(
        msg_p->req,
        sm_p->getattr.attr.capability,
        *sm_p->cred_p,
        sm_p->u.mgmt_create_dirent.entry,
        sm_p->u.mgmt_create_dirent.entry_handle,
        sm_p->parent_ref.handle,
        sm_p->getattr.attr.dirdata_handles[dirdata_server_index],
        sm_p->parent_ref.fs_id,
        sm_p->hints);

    msg_p->fs_id = sm_p->parent_ref.fs_id;
    /* send to dirdata server */
    msg_p->handle =
        sm_p->getattr.attr.dirdata_handles[dirdata_server_index];
    msg_p->retry_flag = PVFS_MSGPAIR_NO_RETRY;
    msg_p->comp_fn = mgmt_create_dirent_comp_fn;

    ret = PINT_cached_config_map_to_server(
        &msg_p->svr_addr, msg_p->handle, msg_p->fs_id);

    if (ret)
    {
        gossip_err("Failed to map server address\n");
	js_p->error_code = ret;
    }

    PINT_sm_push_frame(smcb, 0, &sm_p->msgarray_op);
    return SM_ACTION_COMPLETE;
}

static int mgmt_create_dirent_comp_fn(
    void *v_p, struct PVFS_server_resp *resp_p, int index)
{
    PINT_smcb *smcb = v_p;
#ifdef WIN32
    PINT_client_sm *sm_p =
        PINT_sm_frame(smcb, PINT_MSGPAIR_PARENT_SM);
#else
    PINT_client_sm *sm_p __attribute__((unused)) =
        PINT_sm_frame(smcb, PINT_MSGPAIR_PARENT_SM);
#endif
    assert(resp_p->op == PVFS_SERV_CRDIRENT);

    if (resp_p->status == 0)
    {
        gossip_debug(
            GOSSIP_CLIENT_DEBUG,
            "  mgmt_create_dirent_comp_fn: dirent %s under %llu,%d "
            "created\n", sm_p->u.mgmt_create_dirent.entry,
            llu(sm_p->parent_ref.handle), sm_p->parent_ref.fs_id);
    }
    return resp_p->status;
}

static PINT_sm_action mgmt_create_dirent_retry_or_fail(
        struct PINT_smcb *smcb, job_status_s *js_p)
{       
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    
    /* if need to retry. clear the error_code and setup getattr. */
    if(js_p->error_code == -PVFS_EAGAIN &&
       sm_p->u.mgmt_create_dirent.retry_count < sm_p->msgarray_op.params.retry_limit)
    {
        sm_p->u.mgmt_create_dirent.retry_count++;

        gossip_debug(GOSSIP_CLIENT_DEBUG,
           "mgmt-create-dirent: received -PVFS_EAGAIN,"
           " will retry getattr and mgmt-create-dirent (attempt number %d).\n",
           sm_p->u.mgmt_create_dirent.retry_count);
 
        /* setup getattr */
        PINT_SM_GETATTR_STATE_CLEAR(sm_p->getattr);
        /* clear acache content */
        PINT_acache_invalidate(sm_p->parent_ref);
        
        PINT_SM_GETATTR_STATE_FILL(
                sm_p->getattr,
                sm_p->parent_ref,
                PVFS_ATTR_COMMON_ALL|PVFS_ATTR_DIR_HINT|
                    PVFS_ATTR_CAPABILITY|PVFS_ATTR_DISTDIR_ATTR,
                PVFS_TYPE_DIRECTORY,
                0);
                
        js_p->error_code = 0;
        return SM_ACTION_COMPLETE;
    }   
    
    PVFS_perror_gossip("mgmt-create-dirent failed", js_p->error_code);
    return SM_ACTION_COMPLETE;
}   

static PINT_sm_action mgmt_create_dirent_cleanup(
    struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    gossip_debug(GOSSIP_CLIENT_DEBUG,
                 "mgmt_create_dirent_cleanup called\n");

    PINT_SM_GETATTR_STATE_CLEAR(sm_p->getattr);
    
    sm_p->error_code = js_p->error_code;

    PINT_SET_OP_COMPLETE;
    return SM_ACTION_TERMINATE;
}

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */
