/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will certainly be overwritten.
 */

/* 
 * (C) 2001 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#ifndef WIN32
#include <unistd.h>
#include <sys/time.h>
#endif
#include <fcntl.h>

#include "client-state-machine.h"
#include "pint-perf-counter.h"

/*
 * Now included from client-state-machine.h
 */
#if 0
extern job_context_id pint_client_sm_context;
#endif

enum{ STOP_TIMER=15 };


static PINT_sm_action perf_count_timer_do_work(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_do_work;
static struct PINT_tran_tbl_s ST_do_work_trtbl[];

static PINT_sm_action perf_count_timer_stop(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_stop_timer;
static struct PINT_tran_tbl_s ST_stop_timer_trtbl[];

static PINT_sm_action perf_count_timer_error(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_error;
static struct PINT_tran_tbl_s ST_error_trtbl[];

struct PINT_state_machine_s pvfs2_client_perf_count_timer_sm = {
	.name = "pvfs2_client_perf_count_timer_sm",
	.first_state = &ST_do_work
};

static struct PINT_state_s ST_do_work = {
	 .state_name = "do_work" ,
	 .parent_machine = &pvfs2_client_perf_count_timer_sm ,
	 .flag = SM_RUN ,
	 .action.func = perf_count_timer_do_work ,
	 .pjtbl = NULL ,
	 .trtbl = ST_do_work_trtbl 
};

static struct PINT_tran_tbl_s ST_do_work_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_do_work },
	{ .return_value = STOP_TIMER ,
	 .next_state = &ST_stop_timer },
	{ .return_value = -1 ,
	 .next_state = &ST_error }
};

static struct PINT_state_s ST_stop_timer = {
	 .state_name = "stop_timer" ,
	 .parent_machine = &pvfs2_client_perf_count_timer_sm ,
	 .flag = SM_RUN ,
	 .action.func = perf_count_timer_stop ,
	 .pjtbl = NULL ,
	 .trtbl = ST_stop_timer_trtbl 
};

static struct PINT_tran_tbl_s ST_stop_timer_trtbl[] = {
	{ .return_value = -1 ,

	 .flag = SM_TERM }
};

static struct PINT_state_s ST_error = {
	 .state_name = "error" ,
	 .parent_machine = &pvfs2_client_perf_count_timer_sm ,
	 .flag = SM_RUN ,
	 .action.func = perf_count_timer_error ,
	 .pjtbl = NULL ,
	 .trtbl = ST_error_trtbl 
};

static struct PINT_tran_tbl_s ST_error_trtbl[] = {
	{ .return_value = -1 ,

	 .flag = SM_TERM }
};

#ifndef WIN32
# 52 "src/client/sysint/perf-count-timer.sm"
#endif


/* perf_count_timer_error()
 *
 * cleans up any resources consumed by this state machine and ends
 * execution of the machine
 */
static PINT_sm_action perf_count_timer_error(struct PINT_smcb *smcb,
                                             job_status_s *js_p)
{
    gossip_debug(GOSSIP_CLIENT_DEBUG,
                 "perf timer state: perf_count_timer_error\n");
    gossip_err("Error: stopping client perf timer.\n");

    PINT_SET_OP_COMPLETE;
    return SM_ACTION_DEFERRED;
}

/* perf_count_timer_stop()
 *
 * cleans up any resources consumed by this state machine and ends
 * execution of the machine
 */
static PINT_sm_action perf_count_timer_stop(struct PINT_smcb *smcb,
                                            job_status_s *js_p)
{
    gossip_debug(GOSSIP_CLIENT_DEBUG,
                 "perf timer state: perf_count_timer_stop\n");

    PINT_SET_OP_COMPLETE;
    return SM_ACTION_TERMINATE;
}

/* perf_count_timer_do_work()
 *
 * periodically resets performance counters
 */
static PINT_sm_action perf_count_timer_do_work(struct PINT_smcb *smcb,
                                               job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    job_id_t tmp_id;
    uint64_t current_mask = 0;
    int current_debug_on = 0;
    char* tmp_text;
    char* ptr;
    char* token;
    char delim[] = "\n";

#if 0
    gossip_debug(GOSSIP_CLIENT_DEBUG,
                 "perf count timer state: perf_count_timer_do_work\n");
#endif
    
    /* log current statistics if the gossip mask permits */
    gossip_get_debug_mask(&current_debug_on, &current_mask);
    if(current_mask & GOSSIP_PERFCOUNTER_DEBUG)
    {
        tmp_text = PINT_perf_generate_text(sm_p->u.perf_count_timer.pc, 4096);
        if(tmp_text)
        {
#ifdef WIN32
            token = strtok(tmp_text, delim);  /* thread-safe */
#else
            token = strtok_r(tmp_text, delim, &ptr);
#endif
            while(token)
            {
                gossip_perf_log("%s\n", token);
#ifdef WIN32
                token = strtok(NULL, delim);
#else
                token = strtok_r(NULL, delim, &ptr);
#endif
            }
            free(tmp_text);
        }
    }
 
    /* NOTE: tpc is not used in the client yet, but this function does
     * nothing if passed a NULL pointer so this should be perfectly safe
     * to do.
     */
    PINT_perf_rollover(sm_p->u.perf_count_timer.pc);
    PINT_perf_rollover(sm_p->u.perf_count_timer.tpc);

    if (!sm_p->u.perf_count_timer.pc->running)
    {
        return STOP_TIMER;
    }
        
    /* post another timer */
    return job_req_sched_post_timer(sm_p->u.perf_count_timer.pc->interval, 
                                    smcb,
                                    0,
                                    js_p,
                                    &tmp_id,
                                    pint_client_sm_context);
}

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */
