/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will certainly be overwritten.
 */

/* 
 * (C) 2003 Clemson University and The University of Chicago 
 *
 * Changes by Acxiom Corporation to add setgid support
 * Copyright  Acxiom Corporation, 2005.
 *
 * See COPYING in top-level directory.
 */

/** \file
 *  \ingroup sysint
 *
 *  PVFS2 system interface routines for creating a new directory.
 */

#include <string.h>
#include <assert.h>

#include "client-state-machine.h"
#include "pvfs2-debug.h"
#include "job.h"
#include "gossip.h"
#include "str-utils.h"
#include "pint-cached-config.h"
#include "PINT-reqproto-encode.h"
#include "pint-util.h"
#include "ncache.h"
#include "pvfs2-internal.h"
#include "pvfs2-dist-simple-stripe.h"
#include "dist-dir-utils.h"
#include "client-capcache.h"

/*
 * Now included from client-state-machine.h
 */
#if 0
extern job_context_id pint_client_sm_context;
#endif

enum
{
    MKDIR_RETRY = 180,
    MKDIR_SKIP_EATTR = 181,
    CRDIRENT_RETRY = 182
};

static int mkdir_msg_comp_fn(
    void *v_p, struct PVFS_server_resp *resp_p, int index);
static int mkdir_crdirent_comp_fn(
    void *v_p, struct PVFS_server_resp *resp_p, int index);
static int mkdir_delete_handle_comp_fn(
    void *v_p, struct PVFS_server_resp *resp_p, int index);


static PINT_sm_action mkdir_init(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_init;
static struct PINT_tran_tbl_s ST_init_trtbl[];
static struct PINT_state_s ST_parent_getattr;
static struct PINT_tran_tbl_s ST_parent_getattr_trtbl[];

static PINT_sm_action mkdir_parent_getattr_inspect(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_parent_getattr_inspect;
static struct PINT_tran_tbl_s ST_parent_getattr_inspect_trtbl[];

static PINT_sm_action mkdir_msg_setup_msgpair(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_mkdir_msg_setup_msgpair;
static struct PINT_tran_tbl_s ST_mkdir_msg_setup_msgpair_trtbl[];
static struct PINT_state_s ST_mkdir_msg_xfer_msgpair;
static struct PINT_tran_tbl_s ST_mkdir_msg_xfer_msgpair_trtbl[];

static PINT_sm_action mkdir_msg_failure(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_mkdir_msg_failure;
static struct PINT_tran_tbl_s ST_mkdir_msg_failure_trtbl[];

static PINT_sm_action mkdir_crdirent_setup_msgpair(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_mkdir_crdirent_setup_msgpair;
static struct PINT_tran_tbl_s ST_mkdir_crdirent_setup_msgpair_trtbl[];
static struct PINT_state_s ST_mkdir_crdirent_xfer_msgpair;
static struct PINT_tran_tbl_s ST_mkdir_crdirent_xfer_msgpair_trtbl[];

static PINT_sm_action mkdir_crdirent_failure(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_mkdir_crdirent_failure;
static struct PINT_tran_tbl_s ST_mkdir_crdirent_failure_trtbl[];
static struct PINT_state_s ST_mkdir_crdirent_retry_getattr;
static struct PINT_tran_tbl_s ST_mkdir_crdirent_retry_getattr_trtbl[];

static PINT_sm_action mkdir_delete_handle_setup_msgpair(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_delete_handle_setup_msgpair;
static struct PINT_tran_tbl_s ST_delete_handle_setup_msgpair_trtbl[];
static struct PINT_state_s ST_delete_handle_xfer_msgpair;
static struct PINT_tran_tbl_s ST_delete_handle_xfer_msgpair_trtbl[];

static PINT_sm_action mkdir_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_cleanup;
static struct PINT_tran_tbl_s ST_cleanup_trtbl[];

struct PINT_state_machine_s pvfs2_client_mkdir_sm = {
	.name = "pvfs2_client_mkdir_sm",
	.first_state = &ST_init
};

static struct PINT_state_s ST_init = {
	 .state_name = "init" ,
	 .parent_machine = &pvfs2_client_mkdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mkdir_init ,
	 .pjtbl = NULL ,
	 .trtbl = ST_init_trtbl 
};

static struct PINT_tran_tbl_s ST_init_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_parent_getattr }
};

static struct PINT_state_s ST_parent_getattr = {
	 .state_name = "parent_getattr" ,
	 .parent_machine = &pvfs2_client_mkdir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_client_getattr_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_parent_getattr_trtbl 
};

static struct PINT_tran_tbl_s ST_parent_getattr_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_parent_getattr_inspect },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_parent_getattr_inspect = {
	 .state_name = "parent_getattr_inspect" ,
	 .parent_machine = &pvfs2_client_mkdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mkdir_parent_getattr_inspect ,
	 .pjtbl = NULL ,
	 .trtbl = ST_parent_getattr_inspect_trtbl 
};

static struct PINT_tran_tbl_s ST_parent_getattr_inspect_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_mkdir_msg_setup_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_mkdir_msg_setup_msgpair = {
	 .state_name = "mkdir_msg_setup_msgpair" ,
	 .parent_machine = &pvfs2_client_mkdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mkdir_msg_setup_msgpair ,
	 .pjtbl = NULL ,
	 .trtbl = ST_mkdir_msg_setup_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_mkdir_msg_setup_msgpair_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_mkdir_msg_xfer_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_mkdir_msg_failure }
};

static struct PINT_state_s ST_mkdir_msg_xfer_msgpair = {
	 .state_name = "mkdir_msg_xfer_msgpair" ,
	 .parent_machine = &pvfs2_client_mkdir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_msgpairarray_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_mkdir_msg_xfer_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_mkdir_msg_xfer_msgpair_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_mkdir_crdirent_setup_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_mkdir_msg_failure }
};

static struct PINT_state_s ST_mkdir_msg_failure = {
	 .state_name = "mkdir_msg_failure" ,
	 .parent_machine = &pvfs2_client_mkdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mkdir_msg_failure ,
	 .pjtbl = NULL ,
	 .trtbl = ST_mkdir_msg_failure_trtbl 
};

static struct PINT_tran_tbl_s ST_mkdir_msg_failure_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_mkdir_crdirent_setup_msgpair = {
	 .state_name = "mkdir_crdirent_setup_msgpair" ,
	 .parent_machine = &pvfs2_client_mkdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mkdir_crdirent_setup_msgpair ,
	 .pjtbl = NULL ,
	 .trtbl = ST_mkdir_crdirent_setup_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_mkdir_crdirent_setup_msgpair_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_mkdir_crdirent_xfer_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_mkdir_crdirent_failure }
};

static struct PINT_state_s ST_mkdir_crdirent_xfer_msgpair = {
	 .state_name = "mkdir_crdirent_xfer_msgpair" ,
	 .parent_machine = &pvfs2_client_mkdir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_msgpairarray_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_mkdir_crdirent_xfer_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_mkdir_crdirent_xfer_msgpair_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_cleanup },
	{ .return_value = -1 ,
	 .next_state = &ST_mkdir_crdirent_failure }
};

static struct PINT_state_s ST_mkdir_crdirent_failure = {
	 .state_name = "mkdir_crdirent_failure" ,
	 .parent_machine = &pvfs2_client_mkdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mkdir_crdirent_failure ,
	 .pjtbl = NULL ,
	 .trtbl = ST_mkdir_crdirent_failure_trtbl 
};

static struct PINT_tran_tbl_s ST_mkdir_crdirent_failure_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_mkdir_crdirent_retry_getattr },
	{ .return_value = -1 ,
	 .next_state = &ST_delete_handle_setup_msgpair }
};

static struct PINT_state_s ST_mkdir_crdirent_retry_getattr = {
	 .state_name = "mkdir_crdirent_retry_getattr" ,
	 .parent_machine = &pvfs2_client_mkdir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_client_getattr_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_mkdir_crdirent_retry_getattr_trtbl 
};

static struct PINT_tran_tbl_s ST_mkdir_crdirent_retry_getattr_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_mkdir_crdirent_setup_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_mkdir_crdirent_failure }
};

static struct PINT_state_s ST_delete_handle_setup_msgpair = {
	 .state_name = "delete_handle_setup_msgpair" ,
	 .parent_machine = &pvfs2_client_mkdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mkdir_delete_handle_setup_msgpair ,
	 .pjtbl = NULL ,
	 .trtbl = ST_delete_handle_setup_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_delete_handle_setup_msgpair_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_delete_handle_xfer_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_delete_handle_xfer_msgpair = {
	 .state_name = "delete_handle_xfer_msgpair" ,
	 .parent_machine = &pvfs2_client_mkdir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_msgpairarray_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_delete_handle_xfer_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_delete_handle_xfer_msgpair_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_cleanup = {
	 .state_name = "cleanup" ,
	 .parent_machine = &pvfs2_client_mkdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mkdir_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_cleanup_trtbl[] = {
	{ .return_value = MKDIR_RETRY ,
	 .next_state = &ST_init },
	{ .return_value = -1 ,

	 .flag = SM_TERM }
};

#ifndef WIN32
# 146 "src/client/sysint/sys-mkdir.sm"
#endif


/** Initiate creation of a new directory.
 */
PVFS_error PVFS_isys_mkdir(
    char *object_name,
    PVFS_object_ref parent_ref,
    PVFS_sys_attr attr,
    const PVFS_credential *credential,
    PVFS_sysresp_mkdir *resp,
    PVFS_sys_op_id *op_id,
    PVFS_hint hints,
    void *user_ptr)
{
    PVFS_error ret = -PVFS_EINVAL;
    PINT_smcb *smcb = NULL;
    PINT_client_sm *sm_p = NULL;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "PVFS_isys_mkdir entered\n");

    if ((parent_ref.handle == PVFS_HANDLE_NULL) ||
        (parent_ref.fs_id == PVFS_FS_ID_NULL) ||
        (object_name == NULL) || (resp == NULL))
    {
        gossip_err("invalid (NULL) required argument\n");
        return ret;
    }

    if ((attr.mask & PVFS_ATTR_SYS_ALL_SETABLE) !=
            /* s_op->val_a[k].buffer = &attr->u.dir.hint.dfile_count; */
        PVFS_ATTR_SYS_ALL_SETABLE)
    {
        gossip_lerr("PVFS_isys_mkdir() failure: invalid attributes "
                    "specified\n");
        return ret;
    }

    if ((strlen(object_name) + 1) > PVFS_REQ_LIMIT_SEGMENT_BYTES)
    {
        return -PVFS_ENAMETOOLONG;
    }

    PINT_smcb_alloc(&smcb, PVFS_SYS_MKDIR,
             sizeof(struct PINT_client_sm),
             client_op_state_get_machine,
             client_state_machine_terminate,
             pint_client_sm_context);
    if (smcb == NULL)
    {
        return -PVFS_ENOMEM;
    }
    sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    PINT_init_msgarray_params(sm_p, parent_ref.fs_id);
    PINT_init_sysint_credential(sm_p->cred_p, credential);
    
    sm_p->u.mkdir.object_name = object_name;
    
    PVFS_util_copy_sys_attr(&sm_p->u.mkdir.sys_attr, &attr);

    sm_p->u.mkdir.mkdir_resp = resp;
    sm_p->u.mkdir.stored_error_code = 0;
    sm_p->u.mkdir.retry_count = 0;
    sm_p->object_ref = parent_ref;

    PVFS_hint_copy(hints, &sm_p->hints);
    PVFS_hint_add(&sm_p->hints, PVFS_HINT_HANDLE_NAME, sizeof(PVFS_handle), &parent_ref.handle);

    /* TODO: For now, just use round robin layout. */
    sm_p->u.mkdir.layout.algorithm = PVFS_SYS_LAYOUT_ROUND_ROBIN;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "Creating directory named %s "
                 "under parent handle %llu on fs %d\n", object_name,
                 llu(parent_ref.handle), parent_ref.fs_id);

    return PINT_client_state_machine_post(
        smcb,  op_id, user_ptr);
}

/** Create a new directory.
 */
PVFS_error PVFS_sys_mkdir(
    char *object_name,
    PVFS_object_ref parent_ref,
    PVFS_sys_attr attr,
    const PVFS_credential *credential,
    PVFS_sysresp_mkdir *resp,
    PVFS_hint hints)
{
    PVFS_error ret = -PVFS_EINVAL, error = 0;
    PVFS_sys_op_id op_id;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "PVFS_sys_mkdir entered\n");

    ret = PVFS_isys_mkdir(object_name, parent_ref, attr,
                          credential, resp, &op_id, hints, NULL);
    if (ret)
    {
        PVFS_perror_gossip("PVFS_isys_mkdir call", ret);
        error = ret;
    }
    else if (!ret && op_id != -1)
    {
        ret = PVFS_sys_wait(op_id, "mkdir", &error);
        if (ret)
        {
            PVFS_perror_gossip("PVFS_sys_wait call", ret);
            error = ret;
        }
        PINT_sys_release(op_id);
    }
    return error;
}

/****************************************************************/

static PINT_sm_action mkdir_init(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    job_id_t tmp_id;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir state: init\n");

    assert((js_p->error_code == 0) ||
           (js_p->error_code == MKDIR_RETRY));

    PINT_SM_GETATTR_STATE_FILL(
        sm_p->getattr,
        sm_p->object_ref,
        (PVFS_ATTR_COMMON_ALL|PVFS_ATTR_DIR_HINT|
            PVFS_ATTR_CAPABILITY|PVFS_ATTR_DISTDIR_ATTR), 
        PVFS_TYPE_DIRECTORY,
        0);

    if (js_p->error_code == MKDIR_RETRY)
    {
        js_p->error_code = 0;

        return job_req_sched_post_timer(sm_p->msgarray_op.params.retry_delay,
                                        smcb,
                                        0,
                                        js_p,
                                        &tmp_id,
                                        pint_client_sm_context);
    }

    return SM_ACTION_COMPLETE;
}

static PINT_sm_action mkdir_msg_setup_msgpair(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    PVFS_handle_extent_array meta_handle_extent_array;
    PINT_sm_msgpair_state *msg_p = NULL;
    PVFS_object_attr attr;

    gossip_debug(GOSSIP_CLIENT_DEBUG,
                 "mkdir state: mkdir_msg_setup_msgpair\n");

    js_p->error_code = 0;

    gossip_debug(GOSSIP_CLIENT_DEBUG," mkdir: posting mkdir req, "
            "[distr_dir_servers_initial=%d]\n", sm_p->u.mkdir.distr_dir_servers_initial);

    PINT_msgpair_init(&sm_p->msgarray_op);
    msg_p = &sm_p->msgarray_op.msgpair;

    ret = PINT_cached_config_get_next_meta(sm_p->object_ref.fs_id,
                                           &msg_p->svr_addr,
                                           &meta_handle_extent_array);

    if (ret)
    {
        gossip_err("Failed to map meta server address\n");
        js_p->error_code = ret;
        return SM_ACTION_COMPLETE;
    }
    
    /* initialized attributes with those sent in from user */
    memset(&attr, 0, sizeof(attr));
    PINT_CONVERT_ATTR(&attr, &sm_p->u.mkdir.sys_attr, 0);

    /* check for parent dirhint entries and make new subdir
     * inherit them - the server will create the needed keyval
     * pairs as part of the mkdir request
     */
    if (sm_p->getattr.attr.mask & PVFS_ATTR_DIR_HINT)
    {
        uint32_t mask, pmask;
        mask = attr.mask;
        pmask = sm_p->getattr.attr.mask;
        sm_p->getattr.attr.mask = PVFS_ATTR_DIR_HINT;
        PINT_copy_object_attr(&attr, &sm_p->getattr.attr);
        sm_p->getattr.attr.mask = pmask;
        attr.mask = mask | PVFS_ATTR_DIR_HINT;
    }

    attr.objtype = PVFS_TYPE_DIRECTORY;  
    attr.mask   |= PVFS_ATTR_COMMON_TYPE;         

    PINT_SERVREQ_MKDIR_FILL(msg_p->req,
                            sm_p->getattr.attr.capability,
                            *sm_p->cred_p,
                            sm_p->object_ref.fs_id,
                            meta_handle_extent_array,
                            attr,
                            sm_p->u.mkdir.distr_dir_servers_initial,
                            sm_p->u.mkdir.distr_dir_servers_max,
                            sm_p->u.mkdir.distr_dir_split_size,
                            sm_p->u.mkdir.layout,
                            sm_p->hints);

    msg_p->fs_id = sm_p->object_ref.fs_id;
    msg_p->handle = meta_handle_extent_array.extent_array[0].first;
    msg_p->retry_flag = PVFS_MSGPAIR_NO_RETRY;
    msg_p->comp_fn = mkdir_msg_comp_fn;

    PINT_sm_push_frame(smcb, 0, &sm_p->msgarray_op);
    return SM_ACTION_COMPLETE;
}

static int mkdir_msg_comp_fn(void *v_p,
                             struct PVFS_server_resp *resp_p,
                             int index)
{
    PINT_smcb *smcb = v_p;
    PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_MSGPAIR_PARENT_SM);
    PVFS_object_attr attr;
    
    gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir_msg_comp_fn\n");

    assert(resp_p->op == PVFS_SERV_MKDIR);

    if (resp_p->status != 0)
    {
        return resp_p->status;
    }

    /* otherwise, just stash the newly created meta handle */
    sm_p->u.mkdir.metafile_handle = resp_p->u.mkdir.handle;

    /* also insert entry into attr cache */
    PINT_CONVERT_ATTR(&attr, &sm_p->u.mkdir.sys_attr, 0);

/* WBL - REVIEW this - can we update attr without size array?
 * can we avoid the following invalidation - what at the
 * consequences of being a little out of date?  how much
 * performance do we lose?  Can we pass new timestamps back
 * so we can update cache rather then invalidate?  Is this the right
 * place to invalidate anyway, this is the return of the mkdir not the
 * crdirent, which would have updated the parent's stimestamp.
 */

#if 0 /* Don't cache size_array. */
    PINT_acache_update(sm_p->object_ref, &attr, NULL, NULL);
#endif


    /* invalidate the acache entry for the parent object, since a successful
     * mkdir has now changed the timestamps on the parent's dirdata handle, 
     * invalidating the timestamps stored with the parent.
     */
    PINT_acache_invalidate(sm_p->object_ref);

    gossip_debug(
        GOSSIP_CLIENT_DEBUG, "*** Got newly created dir handle %llu\n",
        llu(sm_p->u.mkdir.metafile_handle));

    return 0;
}

static PINT_sm_action mkdir_msg_failure(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    sm_p->u.mkdir.stored_error_code = js_p->error_code;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir state: mkdir_msg_failure\n");
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action mkdir_crdirent_setup_msgpair(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    PINT_sm_msgpair_state *msg_p = NULL;
    PVFS_dist_dir_hash_type dirdata_hash;
    int dirdata_server_index;

    gossip_debug(GOSSIP_CLIENT_DEBUG,
                 "mkdir state: crdirent_setup_msgpair\n");

    js_p->error_code = 0;

    /* find the hash value and the dist dir bucket */
    dirdata_hash = PINT_encrypt_dirdata(sm_p->u.mkdir.object_name);
    gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir: encrypt dirent %s into hash value %llu.\n",
            sm_p->u.mkdir.object_name,
            llu(dirdata_hash));

    dirdata_server_index =
        PINT_find_dist_dir_bucket(dirdata_hash,
            &sm_p->getattr.attr.dist_dir_attr,
            sm_p->getattr.attr.dist_dir_bitmap);
    gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir: selecting bucket No.%d from dist_dir_bitmap.\n",
            dirdata_server_index);

    gossip_debug(GOSSIP_CLIENT_DEBUG," mkdir: posting crdirent req\n");

    gossip_debug(GOSSIP_CLIENT_DEBUG, "hooking dirent %s (%llu) under "
                 "parent handle %llu, dirdata_handle %llu with server_no=%d\n",
                 sm_p->u.mkdir.object_name,
                 llu(sm_p->u.mkdir.metafile_handle),
                 llu(sm_p->object_ref.handle),
                 llu(sm_p->getattr.attr.dirdata_handles[dirdata_server_index]),
                 dirdata_server_index);

    PINT_msgpair_init(&sm_p->msgarray_op);
    msg_p = &sm_p->msgarray_op.msgpair;

    PINT_SERVREQ_CRDIRENT_FILL(
        msg_p->req,
        sm_p->getattr.attr.capability,
        *sm_p->cred_p,
        sm_p->u.mkdir.object_name,
        sm_p->u.mkdir.metafile_handle,
        sm_p->object_ref.handle,
        sm_p->getattr.attr.dirdata_handles[dirdata_server_index],
        sm_p->object_ref.fs_id,
        sm_p->hints);

    msg_p->fs_id = sm_p->object_ref.fs_id;
    /* send to dirdata server */
    msg_p->handle =
        sm_p->getattr.attr.dirdata_handles[dirdata_server_index];
    msg_p->retry_flag = PVFS_MSGPAIR_NO_RETRY;
    msg_p->comp_fn = mkdir_crdirent_comp_fn;

    ret = PINT_cached_config_map_to_server(
        &msg_p->svr_addr, msg_p->handle,
        sm_p->object_ref.fs_id);

    if (ret)
    {
        gossip_err("Failed to map meta server address\n");
        js_p->error_code = ret;
    }

    PINT_sm_push_frame(smcb, 0, &sm_p->msgarray_op);
    return SM_ACTION_COMPLETE;
}

static int mkdir_crdirent_comp_fn(void *v_p,
                                  struct PVFS_server_resp *resp_p,
                                  int index)
{
    gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir_crdirent_comp_fn\n");

    assert(resp_p->op == PVFS_SERV_CRDIRENT);
    return resp_p->status;
}

static PINT_sm_action mkdir_crdirent_failure(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PVFS_uid local_uid;

    /* if need to retry. clear the error_code and setup getattr. */
    if(js_p->error_code == -PVFS_EAGAIN &&
       sm_p->u.mkdir.retry_count < sm_p->msgarray_op.params.retry_limit)
    {
        sm_p->u.mkdir.retry_count++;

        gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir: received -PVFS_EAGAIN, will retry getattr and crdirent (attempt number %d).\n",
                     sm_p->u.mkdir.retry_count);

        /* clear attributes */
        PINT_SM_GETATTR_STATE_CLEAR(sm_p->getattr);
        /* clear acache content */
        PINT_acache_invalidate(sm_p->object_ref);
        /* clear capcache content */
        local_uid = PINT_HINT_GET_LOCAL_UID(sm_p->hints);

        if (local_uid == (PVFS_uid) -1)
        {
            local_uid = PINT_util_getuid();

            PVFS_hint_add(&sm_p->hints, PVFS_HINT_LOCAL_UID_NAME,
                          sizeof(PVFS_uid), &local_uid);
        }

        PINT_client_capcache_invalidate(sm_p->object_ref, local_uid);

        /* TODO: free cap? */

        /* set up new getattr */
        PINT_SM_GETATTR_STATE_FILL(
                sm_p->getattr,
                sm_p->object_ref,
                PVFS_ATTR_COMMON_ALL|PVFS_ATTR_DIR_HINT|
                    PVFS_ATTR_CAPABILITY|PVFS_ATTR_DISTDIR_ATTR,
                PVFS_TYPE_DIRECTORY,
                0);

        js_p->error_code = 0;
        return SM_ACTION_COMPLETE;
    }

    sm_p->u.mkdir.stored_error_code = js_p->error_code;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir state: crdirent_failure\n");

    PVFS_perror_gossip("mkdir crdirent failed", js_p->error_code);
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action mkdir_delete_handle_setup_msgpair(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    PVFS_BMI_addr_t metafile_server_addr;
    PINT_sm_msgpair_state *msg_p = NULL;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir state: "
                 "delete_handle_setup_msgpair_array\n");

    js_p->error_code = 0;

    PINT_msgpair_init(&sm_p->msgarray_op);
    msg_p = &sm_p->msgarray_op.msgpair;

    ret = PINT_cached_config_map_to_server(
        &metafile_server_addr, sm_p->u.mkdir.metafile_handle,
        sm_p->object_ref.fs_id);

    if (ret)
    {
        gossip_err("Failed to map meta server address\n");
        js_p->error_code = ret;
        return SM_ACTION_COMPLETE;
    }

    PINT_SERVREQ_REMOVE_FILL(
        msg_p->req,
        sm_p->getattr.attr.capability,
        *sm_p->cred_p,
        sm_p->object_ref.fs_id,
        sm_p->u.mkdir.metafile_handle,
        sm_p->hints);

    msg_p->fs_id = sm_p->object_ref.fs_id;
    msg_p->handle = sm_p->u.mkdir.metafile_handle;
    msg_p->retry_flag = PVFS_MSGPAIR_NO_RETRY;
    msg_p->comp_fn = mkdir_delete_handle_comp_fn;
    msg_p->svr_addr = metafile_server_addr;

    gossip_debug(GOSSIP_CLIENT_DEBUG, " Preparing to remove "
                 "directory handle %llu\n", llu(msg_p->handle));

    PINT_sm_push_frame(smcb, 0, &sm_p->msgarray_op);
    return SM_ACTION_COMPLETE;
}

static int mkdir_delete_handle_comp_fn(void *v_p,
                                       struct PVFS_server_resp *resp_p,
                                       int index)
{
    gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir_delete_handle_comp_fn\n");

    assert(resp_p->op == PVFS_SERV_REMOVE);
    return resp_p->status;
}

static PINT_sm_action mkdir_cleanup(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir state: cleanup\n");

    if(sm_p->u.mkdir.val_array)
    {
        if((sm_p->getattr.attr.mask & PVFS_ATTR_DIR_HINT) &&
            (sm_p->getattr.attr.u.dir.hint.dfile_count > 0))
        {
            free(sm_p->u.mkdir.val_array[0].buffer);
        }
        free(sm_p->u.mkdir.val_array);
    }
    if(sm_p->u.mkdir.key_array)
    {
        free(sm_p->u.mkdir.key_array);
    }

    PVFS_util_release_sys_attr(&sm_p->u.mkdir.sys_attr);
    PINT_free_object_attr(&sm_p->getattr.attr);
    
    PINT_SM_GETATTR_STATE_CLEAR(sm_p->getattr);

    sm_p->error_code = (sm_p->u.mkdir.stored_error_code ?
                        sm_p->u.mkdir.stored_error_code :
                        js_p->error_code);

    if (sm_p->error_code == 0)
    {
        PVFS_object_ref directory_ref;

        directory_ref.handle = sm_p->u.mkdir.metafile_handle;
        directory_ref.fs_id = sm_p->object_ref.fs_id;

        sm_p->u.mkdir.mkdir_resp->ref.handle = directory_ref.handle;
        sm_p->u.mkdir.mkdir_resp->ref.fs_id = directory_ref.fs_id;

        /* insert newly created directory handle into the ncache */
        PINT_ncache_update((const char*) sm_p->u.mkdir.object_name, 
                           (const PVFS_object_ref*) &directory_ref, 
                           (const PVFS_object_ref*) &(sm_p->object_ref));
    }
    else if ((PVFS_ERROR_CLASS(-sm_p->error_code) == PVFS_ERROR_BMI) &&
             (sm_p->u.mkdir.retry_count < sm_p->msgarray_op.params.retry_limit))
    {
        sm_p->u.mkdir.stored_error_code = 0;
        sm_p->u.mkdir.retry_count++;

        gossip_debug(GOSSIP_CLIENT_DEBUG, "Retrying mkdir operation "
                     "(attempt number %d)\n", sm_p->u.mkdir.retry_count);

        js_p->error_code = MKDIR_RETRY;
        return SM_ACTION_COMPLETE;
    }
    else
    {
        PINT_acache_invalidate(sm_p->object_ref);
        PVFS_perror_gossip("mkdir failed with error", sm_p->error_code);
    }

    PINT_SET_OP_COMPLETE;
    return SM_ACTION_TERMINATE;
}

/** looks at the attributes of the parent directory and decides if it impacts
 *  the mkdir in any way
 */
static PINT_sm_action mkdir_parent_getattr_inspect(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PVFS_object_attr *attr = NULL;
    int i;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir state: parent_getattr_inspect\n");

    attr = &sm_p->getattr.attr;
    assert(attr);

    /* !!! change later */
    gossip_debug(GOSSIP_CLIENT_DEBUG,
        "parent owner: %d, group: %d, perms: %d, dirdata_server_count: %d\n",
        (int)attr->owner, (int)attr->group, (int)attr->perms,
        attr->dist_dir_attr.num_servers);
    for (i = 0; i < attr->dist_dir_attr.num_servers; i++)
    {
        gossip_debug(GOSSIP_CLIENT_DEBUG,
                     "                           dirdata_handle[%d] = %llu\n",
                     i, llu(attr->dirdata_handles[i]));
    }

    /* do we have a setgid bit? */
    if(attr->perms & PVFS_G_SGID)
    {
        gossip_debug(GOSSIP_CLIENT_DEBUG, "parent has setgid bit set.\n");
        gossip_debug(GOSSIP_CLIENT_DEBUG, " - modifying requested attr for new file.\n");
        sm_p->u.mkdir.sys_attr.group = attr->group;
        sm_p->u.mkdir.sys_attr.perms |= PVFS_G_SGID;
        /* note that permission checking is left to server even in this case */
    }

    /* set value of num_dirent_files,
     * not considering parent_# since it doesn't have direct relation.
     * here, if user has inputs, send it, otherwise, send 0. 
     * on server side, if met 0, use config_file data, otherwise use user set value   */

    /* get command line value of NumDirdata from sys_attr */
    sm_p->u.mkdir.distr_dir_servers_initial =
                    sm_p->u.mkdir.sys_attr.distr_dir_servers_initial;
    sm_p->u.mkdir.distr_dir_servers_max = 
                    sm_p->u.mkdir.sys_attr.distr_dir_servers_max;
    sm_p->u.mkdir.distr_dir_split_size =
                    sm_p->u.mkdir.sys_attr.distr_dir_split_size;


    /* note: if select less # of dirdata servers, need to modify getattr, etc. to contact only active servers, not all dirdata servers */

    return SM_ACTION_COMPLETE;
}

#if 0
static PINT_sm_action mkdir_seteattr_setup_msgpair(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int eattr_count = 0;
    int cur_index = 0;
    PINT_sm_msgpair_state *msg_p = NULL;
    int ret = -PVFS_EINVAL;

    /* NOTE: any memory allocated here will be free'd in the cleanup function */

    gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir state: seteattr_setup_msgpair\n");
    
    /* don't set any hint attributes if the parent doesn't have them */
    if(!(sm_p->getattr.attr.mask & PVFS_ATTR_DIR_HINT))
    {
        gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir state: skipping seteattr\n");
        js_p->error_code = MKDIR_SKIP_EATTR;
        return SM_ACTION_COMPLETE;
    }

    /* count how many hints we acquired */
    if(sm_p->getattr.attr.u.dir.hint.dfile_count > 0)
    {
                    eattr_count++;
    }
    if(sm_p->getattr.attr.u.dir.hint.dist_name != NULL)
    {
                    eattr_count++;
    }
    if(sm_p->getattr.attr.u.dir.hint.dist_params != NULL)
    {
                    eattr_count++;
    }

    if(eattr_count == 0)
    {
        /* nothing to inherit */
        js_p->error_code = MKDIR_SKIP_EATTR;
        return SM_ACTION_COMPLETE;
    }

    sm_p->u.mkdir.key_array = (PVFS_ds_keyval*)calloc(eattr_count,
        sizeof(PVFS_ds_keyval));
    if(!sm_p->u.mkdir.key_array)
    {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }

    sm_p->u.mkdir.val_array = (PVFS_ds_keyval*)calloc(eattr_count,
        sizeof(PVFS_ds_keyval));
    if(!sm_p->u.mkdir.val_array)
    {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }

    if(sm_p->getattr.attr.u.dir.hint.dfile_count > 0)
    {
        gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir: setting num_dfiles\n");
        sm_p->u.mkdir.key_array[cur_index].buffer = "user.pvfs2.num_dfiles";
        sm_p->u.mkdir.key_array[cur_index].buffer_sz = 
            strlen("user.pvfs2.num_dfiles") + 1;

        sm_p->u.mkdir.val_array[cur_index].buffer = calloc(1, 16);
        if(!sm_p->u.mkdir.val_array[cur_index].buffer)
        {
            js_p->error_code = -PVFS_ENOMEM;
            return SM_ACTION_COMPLETE;
        }
#ifdef WIN32
        _snprintf((char*)sm_p->u.mkdir.val_array[cur_index].buffer,
            16, "%d", sm_p->getattr.attr.u.dir.hint.dfile_count);
#else
        snprintf((char*)sm_p->u.mkdir.val_array[cur_index].buffer,
            16, "%d", sm_p->getattr.attr.u.dir.hint.dfile_count);
#endif
        sm_p->u.mkdir.val_array[cur_index].buffer_sz = 
            strlen((char*)sm_p->u.mkdir.val_array[cur_index].buffer) + 1;

        cur_index++;
    }
    if(sm_p->getattr.attr.u.dir.hint.dist_name != NULL)
    {
        gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir: setting dist_name\n");
        sm_p->u.mkdir.key_array[cur_index].buffer = "user.pvfs2.dist_name";
        sm_p->u.mkdir.key_array[cur_index].buffer_sz = 
            strlen("user.pvfs2.dist_name") + 1;
        sm_p->u.mkdir.val_array[cur_index].buffer =
            sm_p->getattr.attr.u.dir.hint.dist_name;
        sm_p->u.mkdir.val_array[cur_index].buffer_sz =
            sm_p->getattr.attr.u.dir.hint.dist_name_len;

        cur_index++;
    }
    if(sm_p->getattr.attr.u.dir.hint.dist_params != NULL)
    {
        gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir: setting dist_params\n");
        sm_p->u.mkdir.key_array[cur_index].buffer = "user.pvfs2.dist_params";
        sm_p->u.mkdir.key_array[cur_index].buffer_sz = 
            strlen("user.pvfs2.dist_params") + 1;

        sm_p->u.mkdir.val_array[cur_index].buffer = 
            sm_p->getattr.attr.u.dir.hint.dist_params;
        sm_p->u.mkdir.val_array[cur_index].buffer_sz = 
            sm_p->getattr.attr.u.dir.hint.dist_params_len;

        cur_index++;
    }

    PINT_msgpair_init(&sm_p->msgarray_op);
    msg_p = &sm_p->msgarray_op.msgpair;

    PINT_SERVREQ_SETEATTR_FILL(
            msg_p->req,
            sm_p->getattr.attr.capability,
            sm_p->object_ref.fs_id,
            sm_p->u.mkdir.metafile_handle,
            0,
            eattr_count,
            sm_p->u.mkdir.key_array,
            sm_p->u.mkdir.val_array,
            sm_p->hints);

    msg_p->fs_id = sm_p->object_ref.fs_id;
    msg_p->handle = sm_p->u.mkdir.metafile_handle;
    msg_p->retry_flag = PVFS_MSGPAIR_RETRY;
    /* NOTE: no comp_fn needed. */

    ret = PINT_cached_config_map_to_server(
            &msg_p->svr_addr,
            msg_p->handle,
            msg_p->fs_id);
    if (ret)
    {
        gossip_err("Failed to map meta server address\n");
        js_p->error_code = ret;
    }
    else
    {
        js_p->error_code = 0;
    }

    PINT_sm_push_frame(smcb, 0, &sm_p->msgarray_op);
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action mkdir_seteattr_failure(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    sm_p->u.mkdir.stored_error_code = js_p->error_code;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "mkdir state: mkdir_seteattr_failure\n");

    PVFS_perror_gossip("mkdir seteattr failed", js_p->error_code);
    return SM_ACTION_COMPLETE;
}
#endif

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */
