/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will certainly be overwritten.
 */

/* 
 * (C) 2003 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */

/** \file
 *  \ingroup sysint
 *
 *  PVFS2 system interface routines for reading entries from a directory.
 */
#include <string.h>
#include <assert.h>

#include "client-state-machine.h"
#include "pvfs2-debug.h"
#include "job.h"
#include "gossip.h"
#include "str-utils.h"
#include "pint-cached-config.h"
#include "PINT-reqproto-encode.h"
#include "ncache.h"
#include "pint-util.h"
#include "pvfs2-internal.h"

/*
 * Now included from client-state-machine.h
 */
#if 0
extern job_context_id pint_client_sm_context;
#endif

enum
{
    READDIR_DONE = 2,
    NO_PARTIAL_READ,
};

static int readdir_msg_comp_fn(
    void *v_p, struct PVFS_server_resp *resp_p, int index);


static PINT_sm_action readdir_init(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_init;
static struct PINT_tran_tbl_s ST_init_trtbl[];
static struct PINT_state_s ST_readdir_getattr;
static struct PINT_tran_tbl_s ST_readdir_getattr_trtbl[];

static PINT_sm_action readdir_finish_partial_read(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_readdir_finish_partial_read;
static struct PINT_tran_tbl_s ST_readdir_finish_partial_read_trtbl[];
static struct PINT_state_s ST_readdir_xfer_finish_partial_read;
static struct PINT_tran_tbl_s ST_readdir_xfer_finish_partial_read_trtbl[];

static PINT_sm_action readdir_msg_setup_msgpair(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_readdir_msg_setup_msgpair;
static struct PINT_tran_tbl_s ST_readdir_msg_setup_msgpair_trtbl[];
static struct PINT_state_s ST_readdir_msg_xfer_msgpair;
static struct PINT_tran_tbl_s ST_readdir_msg_xfer_msgpair_trtbl[];

static PINT_sm_action readdir_msg_done(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_readdir_msg_done;
static struct PINT_tran_tbl_s ST_readdir_msg_done_trtbl[];

static PINT_sm_action readdir_msg_failure(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_readdir_msg_failure;
static struct PINT_tran_tbl_s ST_readdir_msg_failure_trtbl[];

static PINT_sm_action readdir_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_cleanup;
static struct PINT_tran_tbl_s ST_cleanup_trtbl[];

struct PINT_state_machine_s pvfs2_client_readdir_sm = {
	.name = "pvfs2_client_readdir_sm",
	.first_state = &ST_init
};

static struct PINT_state_s ST_init = {
	 .state_name = "init" ,
	 .parent_machine = &pvfs2_client_readdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = readdir_init ,
	 .pjtbl = NULL ,
	 .trtbl = ST_init_trtbl 
};

static struct PINT_tran_tbl_s ST_init_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_readdir_getattr }
};

static struct PINT_state_s ST_readdir_getattr = {
	 .state_name = "readdir_getattr" ,
	 .parent_machine = &pvfs2_client_readdir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_client_getattr_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_readdir_getattr_trtbl 
};

static struct PINT_tran_tbl_s ST_readdir_getattr_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_readdir_finish_partial_read },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_readdir_finish_partial_read = {
	 .state_name = "readdir_finish_partial_read" ,
	 .parent_machine = &pvfs2_client_readdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = readdir_finish_partial_read ,
	 .pjtbl = NULL ,
	 .trtbl = ST_readdir_finish_partial_read_trtbl 
};

static struct PINT_tran_tbl_s ST_readdir_finish_partial_read_trtbl[] = {
	{ .return_value = NO_PARTIAL_READ ,
	 .next_state = &ST_readdir_msg_setup_msgpair },
	{ .return_value = 0 ,
	 .next_state = &ST_readdir_xfer_finish_partial_read },
	{ .return_value = -1 ,
	 .next_state = &ST_readdir_msg_failure }
};

static struct PINT_state_s ST_readdir_xfer_finish_partial_read = {
	 .state_name = "readdir_xfer_finish_partial_read" ,
	 .parent_machine = &pvfs2_client_readdir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_msgpairarray_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_readdir_xfer_finish_partial_read_trtbl 
};

static struct PINT_tran_tbl_s ST_readdir_xfer_finish_partial_read_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_readdir_msg_setup_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_readdir_msg_failure }
};

static struct PINT_state_s ST_readdir_msg_setup_msgpair = {
	 .state_name = "readdir_msg_setup_msgpair" ,
	 .parent_machine = &pvfs2_client_readdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = readdir_msg_setup_msgpair ,
	 .pjtbl = NULL ,
	 .trtbl = ST_readdir_msg_setup_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_readdir_msg_setup_msgpair_trtbl[] = {
	{ .return_value = READDIR_DONE ,
	 .next_state = &ST_readdir_msg_done },
	{ .return_value = 0 ,
	 .next_state = &ST_readdir_msg_xfer_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_readdir_msg_failure }
};

static struct PINT_state_s ST_readdir_msg_xfer_msgpair = {
	 .state_name = "readdir_msg_xfer_msgpair" ,
	 .parent_machine = &pvfs2_client_readdir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_msgpairarray_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_readdir_msg_xfer_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_readdir_msg_xfer_msgpair_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_readdir_msg_setup_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_readdir_msg_failure }
};

static struct PINT_state_s ST_readdir_msg_done = {
	 .state_name = "readdir_msg_done" ,
	 .parent_machine = &pvfs2_client_readdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = readdir_msg_done ,
	 .pjtbl = NULL ,
	 .trtbl = ST_readdir_msg_done_trtbl 
};

static struct PINT_tran_tbl_s ST_readdir_msg_done_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_readdir_msg_failure = {
	 .state_name = "readdir_msg_failure" ,
	 .parent_machine = &pvfs2_client_readdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = readdir_msg_failure ,
	 .pjtbl = NULL ,
	 .trtbl = ST_readdir_msg_failure_trtbl 
};

static struct PINT_tran_tbl_s ST_readdir_msg_failure_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_cleanup = {
	 .state_name = "cleanup" ,
	 .parent_machine = &pvfs2_client_readdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = readdir_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_cleanup_trtbl[] = {
	{ .return_value = -1 ,
	 .flag = SM_RETURN }
};

static struct PINT_state_s ST_dowork;
static struct PINT_tran_tbl_s ST_dowork_trtbl[];

static PINT_sm_action do_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_do_cleanup;
static struct PINT_tran_tbl_s ST_do_cleanup_trtbl[];

struct PINT_state_machine_s pvfs2_client_sysint_readdir_sm = {
	.name = "pvfs2_client_sysint_readdir_sm",
	.first_state = &ST_dowork
};

static struct PINT_state_s ST_dowork = {
	 .state_name = "dowork" ,
	 .parent_machine = &pvfs2_client_sysint_readdir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_client_readdir_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_dowork_trtbl 
};

static struct PINT_tran_tbl_s ST_dowork_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_do_cleanup }
};

static struct PINT_state_s ST_do_cleanup = {
	 .state_name = "do_cleanup" ,
	 .parent_machine = &pvfs2_client_sysint_readdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = do_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_do_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_do_cleanup_trtbl[] = {
	{ .return_value = -1 ,

	 .flag = SM_TERM }
};

#ifndef WIN32
# 121 "src/client/sysint/sys-readdir.sm"
#endif


/** Initiate reading of entries from a directory.
 *
 *  \param token opaque value used to track position in directory
 *         when more than one read is required.
 *  \param pvfs_dirent_incount maximum number of entries to read, if
 *         available, starting from token.
 */
PVFS_error PVFS_isys_readdir(
    PVFS_object_ref ref,
    PVFS_ds_position token, 
    int32_t pvfs_dirent_incount,
    const PVFS_credential *credential,
    PVFS_sysresp_readdir *resp,
    PVFS_sys_op_id *op_id,
    PVFS_hint hints,
    void *user_ptr)
{
    PVFS_error ret = -PVFS_EINVAL;
    PINT_smcb *smcb = NULL;
    PINT_client_sm *sm_p = NULL;

    gossip_debug(GOSSIP_READDIR_DEBUG, "PVFS_isys_readdir entered\n");

    if ((ref.handle == PVFS_HANDLE_NULL) ||
        (ref.fs_id == PVFS_FS_ID_NULL) ||
        (resp == NULL))
    {
        gossip_err("invalid (NULL) required argument\n");
        return ret;
    }

    if (pvfs_dirent_incount > PVFS_REQ_LIMIT_DIRENT_COUNT)
    {
        gossip_lerr("PVFS_isys_readdir unable to handle request "
                    "for %d entries.\n", pvfs_dirent_incount);
        return ret;
    }

    PINT_smcb_alloc(&smcb, PVFS_SYS_READDIR,
             sizeof(struct PINT_client_sm),
             client_op_state_get_machine,
             client_state_machine_terminate,
             pint_client_sm_context);
    if (smcb == NULL)
    {
        return -PVFS_ENOMEM;
    }
    sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    PINT_init_msgarray_params(sm_p, ref.fs_id);
    PINT_init_sysint_credential(sm_p->cred_p, credential);
    sm_p->readdir.readdir_resp = resp;
    sm_p->object_ref = ref;
    PVFS_hint_copy(hints, &sm_p->hints);
    PVFS_hint_add(&sm_p->hints, PVFS_HINT_HANDLE_NAME, sizeof(PVFS_handle), &ref.handle);

    /* point the sm dirent array and outcount to the readdir response field */
    sm_p->readdir_state.dirent_array = &resp->dirent_array;
    sm_p->readdir_state.dirent_outcount = &resp->pvfs_dirent_outcount;
    sm_p->readdir_state.token = &resp->token;
    sm_p->readdir_state.directory_version = &resp->directory_version;

    sm_p->readdir_state.pos_token = sm_p->readdir.pos_token = token;
    sm_p->readdir_state.dirent_limit = sm_p->readdir.dirent_limit = pvfs_dirent_incount;

    gossip_debug(GOSSIP_READDIR_DEBUG, "Doing readdir on handle "
                 "%llu on fs %d\n", llu(ref.handle), ref.fs_id);

    return PINT_client_state_machine_post(
        smcb,  op_id, user_ptr);
}

/** Read entries from a directory.
 *
 *  \param token opaque value used to track position in directory
 *         when more than one read is required.
 *  \param pvfs_dirent_incount maximum number of entries to read, if
 *         available, starting from token.
 */
PVFS_error PVFS_sys_readdir(
    PVFS_object_ref ref,
    PVFS_ds_position token, 
    int32_t pvfs_dirent_incount,
    const PVFS_credential *credential,
    PVFS_sysresp_readdir *resp,
    PVFS_hint hints)
{
    PVFS_error ret = -PVFS_EINVAL, error = 0;
    PVFS_sys_op_id op_id;

    gossip_debug(GOSSIP_READDIR_DEBUG, "PVFS_sys_readdir entered\n");

    ret = PVFS_isys_readdir(ref, token, pvfs_dirent_incount,
                            credential, resp, &op_id, hints, NULL);
    if (ret)
    {
        PVFS_perror_gossip("PVFS_isys_readdir call", ret);
        error = ret;
    }
    else if (!ret && op_id != -1)
    {
        ret = PVFS_sys_wait(op_id, "readdir", &error);
        if (ret)
        {
            PVFS_perror_gossip("PVFS_sys_wait call", ret);
            error = ret;
        }
        PINT_sys_release(op_id);
    }
    return error;
}

/****************************************************************/

static PINT_sm_action readdir_init(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int dirdata_index = 0;
    
    gossip_debug(GOSSIP_READDIR_DEBUG, "readdir state: init\n");

    *(sm_p->readdir_state.dirent_outcount) = 0;
    sm_p->readdir.num_dirdata_needed = 0;
                    
    if(sm_p->readdir_state.pos_token != PVFS_READDIR_START)
    {
        /* We need to strip out the dirdata index from the token.
         * The token looks like:
         *     16 bits dirdata index
         *     16 bits session id (managed by trove)
         *     32 bits position (managed by trove)
         */
        dirdata_index = sm_p->readdir_state.pos_token >> 48;
        sm_p->readdir_state.pos_token = sm_p->readdir_state.pos_token &
                                        0x0000ffffffffffff;
        gossip_debug(GOSSIP_READDIR_DEBUG,
                "[handle %llu, token %llu, dirdata_index %d]\n",
                llu(sm_p->object_ref.handle),
                llu(sm_p->readdir_state.pos_token),
                dirdata_index);
    }
    else
    {
        gossip_debug(GOSSIP_READDIR_DEBUG,
                "*** token=PVFS_READDIR_START, use dirdata_index=0\n");
    }
    sm_p->readdir_state.dirdata_index =
            sm_p->readdir.dirdata_index = dirdata_index;

    PINT_SM_GETATTR_STATE_FILL(
        sm_p->getattr,
        sm_p->object_ref,
        PVFS_ATTR_DIR_ALL|PVFS_ATTR_CAPABILITY|PVFS_ATTR_DISTDIR_ATTR,
        PVFS_TYPE_DIRECTORY,
        0);

    /* keep dirent_count of all dirdata server in
       sm_p->getattr.size_array */
    sm_p->getattr.keep_size_array = 1;

    return SM_ACTION_COMPLETE;
}

/* If we have already retrieved some directory entries (i.e., token !=
   PVFS_READDIR_START) then we can't depend on the count of directory
   entries from this server in the case where the caller is getting
   a list of directory entries for the purpose of deleting them. We
   don't know how many directory entries remain to be retrieved from
   this server, so we get as many as remain, up to the requested number
   of results. */
static PINT_sm_action readdir_finish_partial_read(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PINT_sm_msgpair_state *msg_p = NULL;
    int ret = -PVFS_EINVAL;

    gossip_debug(GOSSIP_READDIR_DEBUG, "readdir state: "
                 "readdir_finish_partial_read\n");

    if(sm_p->readdir_state.pos_token == PVFS_READDIR_START)
    {
        /* We haven't retrieved any results yet, so the count of
           directory entries on the server is reliable. We don't
           need special case processing. */
        js_p->error_code = NO_PARTIAL_READ;
        return SM_ACTION_COMPLETE;
    }

    sm_p->readdir.num_dirdata_needed = 1;

    PINT_msgpair_init(&sm_p->msgarray_op);
    msg_p = &sm_p->msgarray_op.msgpair;

    gossip_debug(
            GOSSIP_READDIR_DEBUG,
            "readdir: posting dirdata readdir "
            "%llu|%llu|%d | token is %llu | limit is %d\n",
            llu(sm_p->object_ref.handle),
            llu(sm_p->getattr.attr.dirdata_handles[sm_p->readdir_state.dirdata_index]),
            sm_p->object_ref.fs_id,
            llu(sm_p->readdir_state.pos_token),
            sm_p->readdir_state.dirent_limit);

    PINT_SERVREQ_READDIR_FILL(
            msg_p->req,
            sm_p->getattr.attr.capability,
            sm_p->object_ref.fs_id,
            sm_p->getattr.attr.dirdata_handles[sm_p->readdir_state.dirdata_index],
            sm_p->readdir_state.pos_token,
            sm_p->readdir_state.dirent_limit,
            sm_p->hints);

    /* fill in msgpair structure components */
    msg_p->fs_id = sm_p->getattr.object_ref.fs_id;
    msg_p->handle = sm_p->getattr.attr.dirdata_handles[sm_p->readdir_state.dirdata_index];
    msg_p->retry_flag = PVFS_MSGPAIR_RETRY;
    msg_p->comp_fn = readdir_msg_comp_fn;

    ret = PINT_cached_config_map_to_server(
            &msg_p->svr_addr, msg_p->handle, msg_p->fs_id);

    if (ret)
    {
        gossip_err("Failed to map dirdata server address\n");
        js_p->error_code = ret;
        return SM_ACTION_COMPLETE;
    }

    PINT_sm_push_frame(smcb, 0, &sm_p->msgarray_op);
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action readdir_msg_setup_msgpair(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    int i = 0;
    int tmp_index = 0;
    PINT_sm_msgpair_state *msg_p = NULL;
    int tmp_dirent_limit_needed = 0;
    int *tmp_dirdata_index_array = NULL;
    int *tmp_dirent_limit_array = NULL;
    PVFS_ds_position *token_array = NULL;

    gossip_debug(GOSSIP_READDIR_DEBUG, "readdir state: "
                 "readdir_msg_setup_msgpair\n");

    js_p->error_code = 0;

    if( sm_p->readdir_state.dirent_limit <=
        *(sm_p->readdir_state.dirent_outcount) )
    {              
        gossip_debug(GOSSIP_READDIR_DEBUG, "readdir: "
                "enough dirent fetched, exiting.\n");
        js_p->error_code = READDIR_DONE;
        return SM_ACTION_COMPLETE;
    }     

    /* If we did partial result processing above, then we need
       to move on to the next server. */
    if(sm_p->readdir_state.pos_token != PVFS_READDIR_START)
    {
        sm_p->readdir.dirdata_index++;
        sm_p->readdir.pos_token = PVFS_READDIR_START;
    }
    if( sm_p->readdir.dirdata_index >=
        sm_p->getattr.attr.dist_dir_attr.num_servers)
    {      
        gossip_debug(GOSSIP_READDIR_DEBUG, "readdir: "
                "all dirdata servers have been traversed, setting pos and return.\n");
        *(sm_p->readdir_state.token) = PVFS_READDIR_END;
        js_p->error_code = READDIR_DONE;
        return SM_ACTION_COMPLETE;
    }          

    /* print out the dirent_count distribution, for debugging purpose */
    assert(sm_p->getattr.size_array);
    gossip_debug(GOSSIP_READDIR_DEBUG, "readdir getattr: "
            "dirent_count of all dirdata handles\n");
    for(i = 0; i < sm_p->getattr.attr.dist_dir_attr.num_servers; i++)
    {       
        gossip_debug(GOSSIP_READDIR_DEBUG, 
                "dirent_count[%d]: %llu\n", i,
                llu(sm_p->getattr.size_array[i]));
    }       

    /* calculate dirent_count fetch distribution */
    tmp_dirent_limit_needed = sm_p->readdir_state.dirent_limit -
            *(sm_p->readdir_state.dirent_outcount); 
    gossip_debug(GOSSIP_READDIR_DEBUG, "tmp_dirent_limit_needed = %d.\n",
                 tmp_dirent_limit_needed);
        
    /* allocate space */
    sm_p->readdir.num_dirdata_needed = 0;
    token_array = malloc( sizeof(PVFS_ds_position) *
            sm_p->getattr.attr.dist_dir_attr.num_servers);
    tmp_dirent_limit_array = malloc( sizeof(int) *
            sm_p->getattr.attr.dist_dir_attr.num_servers);
    tmp_dirdata_index_array = malloc( sizeof(int) *
            sm_p->getattr.attr.dist_dir_attr.num_servers);
    if(!token_array || !tmp_dirent_limit_array || !tmp_dirdata_index_array)
    {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }

    /* fill in request parameters */
    while( (tmp_dirent_limit_needed > 0) &&
           (sm_p->readdir.dirdata_index <
            sm_p->getattr.attr.dist_dir_attr.num_servers) )
    {
        int cur_index = sm_p->readdir.dirdata_index;

        if(sm_p->getattr.size_array[cur_index] > 0)
        {
            tmp_dirdata_index_array[tmp_index] = cur_index;
            token_array[tmp_index] = PVFS_READDIR_START;

            if (tmp_dirent_limit_needed >
                sm_p->getattr.size_array[cur_index])
            {
                tmp_dirent_limit_array[tmp_index] =
                    sm_p->getattr.size_array[cur_index];
            }
            else
            {
                tmp_dirent_limit_array[tmp_index] =
                    tmp_dirent_limit_needed;
            }

            tmp_dirent_limit_needed -= tmp_dirent_limit_array[tmp_index];
            tmp_index++;
        }

        if(tmp_dirent_limit_needed > 0) /* need more dirents */
        {
            /* proceed to next dirdata */
            sm_p->readdir.dirdata_index++;
        }
    }

    /* total number of dirdata server need to contact */
    sm_p->readdir.num_dirdata_needed = tmp_index;

    if(tmp_index == 0)
    {
        gossip_debug(GOSSIP_READDIR_DEBUG," readdir: no dirent left in the remain dirdata servers. setting pos and return.\n");

        *(sm_p->readdir_state.token) = PVFS_READDIR_END;
        js_p->error_code = READDIR_DONE;
        goto readdir_msg_return;
    }

    gossip_debug(GOSSIP_READDIR_DEBUG," readdir: posting readdir req\n");

    /* initialize msgpair array */
    ret = PINT_msgpairarray_init(&sm_p->msgarray_op, tmp_index);
    if(ret != 0)
    {
        js_p->error_code = ret;
        goto readdir_msg_return;
    }

    /* prepare to post the readdir send/recv pairs for all dirdata*/
    foreach_msgpair(&sm_p->msgarray_op, msg_p, i)
    {
    
        gossip_debug(
                GOSSIP_READDIR_DEBUG,
                "readdir: posting dirdata readdir[%d]  ""%llu|%llu(#%d)|%d | token is %llu | limit is %d\n",
                i, llu(sm_p->object_ref.handle),
                llu(sm_p->getattr.attr.dirdata_handles[tmp_dirdata_index_array[i]]),
                           (tmp_dirdata_index_array[i]),
                sm_p->object_ref.fs_id,
                llu(token_array[i]),
                tmp_dirent_limit_array[i]);

        PINT_SERVREQ_READDIR_FILL(
                msg_p->req,
                sm_p->getattr.attr.capability,
                sm_p->object_ref.fs_id,
                sm_p->getattr.attr.dirdata_handles[tmp_dirdata_index_array[i]],
                token_array[i],
                tmp_dirent_limit_array[i],
                sm_p->hints);

        /* fill in msgpair structure components */
        msg_p->fs_id = sm_p->getattr.object_ref.fs_id;
        msg_p->handle = sm_p->getattr.attr.dirdata_handles[tmp_dirdata_index_array[i]];
        msg_p->retry_flag = PVFS_MSGPAIR_RETRY;
        msg_p->comp_fn = readdir_msg_comp_fn;

        ret = PINT_cached_config_map_to_server(
                &msg_p->svr_addr, msg_p->handle, msg_p->fs_id);

        if (ret)
        {
            gossip_err("Failed to map meta server address\n");
            js_p->error_code = ret;
            break;
        }
    }

    PINT_sm_push_frame(smcb, 0, &sm_p->msgarray_op);

readdir_msg_return:
    free(token_array);
    free(tmp_dirent_limit_array);
    free(tmp_dirdata_index_array);
    return SM_ACTION_COMPLETE;
}

static int readdir_msg_comp_fn(void *v_p,
                               struct PVFS_server_resp *resp_p,
                               int index)
{
    PINT_smcb *smcb = v_p;
    PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_MSGPAIR_PARENT_SM);
    
    gossip_debug(GOSSIP_READDIR_DEBUG, "readdir_msg_comp_fn\n");
    gossip_debug(GOSSIP_READDIR_DEBUG, "dirdata readdir[%d] got response %d\n",
                 index, resp_p->status);

    assert(resp_p->op == PVFS_SERV_READDIR);
    assert(index < sm_p->readdir.num_dirdata_needed);

    if (resp_p->status != 0)
    {
	return resp_p->status;
    }

    /* if it's from the last dirdata of the msg_array */
    if(index == (sm_p->readdir.num_dirdata_needed - 1))
    {
        PVFS_ds_position tmp_dirdata_index = 0;

        /* convert servresp_readdir response to a sysresp_readdir obj */
        tmp_dirdata_index = sm_p->readdir.dirdata_index & 0x0ffff;
        tmp_dirdata_index = tmp_dirdata_index << 48;

        *(sm_p->readdir_state.token) = tmp_dirdata_index + resp_p->u.readdir.token;
        sm_p->readdir_state.pos_token = *(sm_p->readdir_state.token);
        sm_p->readdir.pos_token = *(sm_p->readdir_state.token);
        *(sm_p->readdir_state.directory_version) =
            resp_p->u.readdir.directory_version;
        sm_p->readdir_state.dirdata_index = sm_p->readdir.dirdata_index;
                
        gossip_debug(GOSSIP_READDIR_DEBUG, 
                "*** update token value to %llu from dirdata readdir[%d]\n",
                llu(sm_p->readdir.pos_token), index);
    }
                
    gossip_debug(GOSSIP_READDIR_DEBUG, 
            "*** receiving readdir response [%d] with resp->dirent_count=%d when dirent_outcount = %d\n", 
            index,  resp_p->u.readdir.dirent_count, *(sm_p->readdir_state.dirent_outcount));

    if (resp_p->u.readdir.dirent_count > 0)
    {
        int dirent_array_offset, dirent_array_len;

        if(*(sm_p->readdir_state.dirent_outcount) == 0)
        {
            int dirent_array_len_total =
                (sizeof(PVFS_dirent) * (sm_p->readdir_state.dirent_limit));

            /* this dirent_array MUST be freed by caller */
            *(sm_p->readdir_state.dirent_array) =
                (PVFS_dirent *) malloc(dirent_array_len_total);
            assert(*(sm_p->readdir_state.dirent_array));
        }

        dirent_array_offset =
            (*(sm_p->readdir_state.dirent_outcount));
        dirent_array_len =
            (sizeof(PVFS_dirent) * resp_p->u.readdir.dirent_count);

        memcpy(*(sm_p->readdir_state.dirent_array) + dirent_array_offset,
               resp_p->u.readdir.dirent_array, dirent_array_len);
    }
    /* update dirent_outcount */
    *(sm_p->readdir_state.dirent_outcount) +=
        resp_p->u.readdir.dirent_count;

    gossip_debug(GOSSIP_READDIR_DEBUG, "*** Got %d directory entries "
                 "[version %lld, index = %d, dirent_outcount = %d]\n",
                 resp_p->u.readdir.dirent_count,
                 lld(resp_p->u.readdir.directory_version),
                 index,
                 *(sm_p->readdir_state.dirent_outcount) );

    return 0;
}

static PINT_sm_action readdir_msg_done(
        struct PINT_smcb *smcb, job_status_s *js_p)
{   
    gossip_debug(GOSSIP_CLIENT_DEBUG,
                 "readdir state: readdir_msg_done\n");
    /* main reason for this state is to clear error_code
     * otherwise cleanup will return with error 2 (READDIR_DONE)
     */
    js_p->error_code = 0;
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action readdir_msg_failure(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    gossip_debug(GOSSIP_READDIR_DEBUG,
                 "readdir state: readdir_msg_failure\n");
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action readdir_cleanup(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int i = 0;
    PVFS_object_ref tmp_ref;
    gossip_debug(GOSSIP_READDIR_DEBUG, "readdir state: cleanup\n");

    if(js_p->error_code == 0)
    {
        /* insert all handles into the ncache while we have them */
        tmp_ref.fs_id = sm_p->object_ref.fs_id;
        for(i = 0; i < *(sm_p->readdir_state.dirent_outcount); i++)
        {
            tmp_ref.handle = (*(sm_p->readdir_state.dirent_array))[i].handle;
            PINT_ncache_update(
                (const char *) (*(sm_p->readdir_state.dirent_array))[i].d_name,
                (const PVFS_object_ref *) &(tmp_ref),
                (const PVFS_object_ref *) &(sm_p->object_ref));
        }
    }

    if (sm_p->getattr.keep_size_array && sm_p->getattr.size_array)
    {
        gossip_debug(GOSSIP_READDIR_DEBUG,
                     "%s: about to free: getattr->size_array = %p\n",
                     __func__,
                     (void *) sm_p->getattr.size_array);
        PINT_SM_DATAFILE_SIZE_ARRAY_DESTROY(&sm_p->getattr.size_array);
    }

    /* cleanup tree request */
    PINT_msgpairarray_destroy(&sm_p->msgarray_op);
    PINT_SM_GETATTR_STATE_CLEAR(sm_p->getattr);

    if(js_p->error_code != 0)
    {
        PINT_acache_invalidate(sm_p->object_ref);
    }
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action do_cleanup(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    gossip_debug(GOSSIP_READDIR_DEBUG, "readdir state: do_cleanup\n");

    PINT_free_object_attr(&sm_p->getattr.attr);
    sm_p->error_code = js_p->error_code;
    gossip_debug(GOSSIP_READDIR_DEBUG, " final return code is %d\n",
                 sm_p->error_code);

    PINT_SET_OP_COMPLETE;
    return SM_ACTION_TERMINATE;
}



/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */
