/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will certainly be overwritten.
 */

/* 
 * (C) 2001 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include "server-config.h"
#include "pvfs2-server.h"
#include "pvfs2-internal.h"
#include "pint-security.h"

/*
 * if given a metafile, do a keyval flush
 * if given a datafile, do a bstream flush
 */
enum
{
    FLUSH_KEYVAL  = 4,
    FLUSH_BSTREAM = 5
};

void flush_init_state_machine(void);

static struct PINT_state_s ST_prelude;
static struct PINT_tran_tbl_s ST_prelude_trtbl[];

static PINT_sm_action flush_check_type(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_flush_check_type;
static struct PINT_tran_tbl_s ST_flush_check_type_trtbl[];

static PINT_sm_action flush_keyval_flush(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_kflush;
static struct PINT_tran_tbl_s ST_kflush_trtbl[];

static PINT_sm_action flush_check_error(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_kflush_check_error;
static struct PINT_tran_tbl_s ST_kflush_check_error_trtbl[];

static PINT_sm_action flush_bstream_flush(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_bflush;
static struct PINT_tran_tbl_s ST_bflush_trtbl[];
static struct PINT_state_s ST_bflush_check_error;
static struct PINT_tran_tbl_s ST_bflush_check_error_trtbl[];
static struct PINT_state_s ST_final_response;
static struct PINT_tran_tbl_s ST_final_response_trtbl[];

static PINT_sm_action flush_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_cleanup;
static struct PINT_tran_tbl_s ST_cleanup_trtbl[];

struct PINT_state_machine_s pvfs2_flush_sm = {
	.name = "pvfs2_flush_sm",
	.first_state = &ST_prelude
};

static struct PINT_state_s ST_prelude = {
	 .state_name = "prelude" ,
	 .parent_machine = &pvfs2_flush_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_prelude_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_prelude_trtbl 
};

static struct PINT_tran_tbl_s ST_prelude_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_flush_check_type },
	{ .return_value = -1 ,
	 .next_state = &ST_final_response }
};

static struct PINT_state_s ST_flush_check_type = {
	 .state_name = "flush_check_type" ,
	 .parent_machine = &pvfs2_flush_sm ,
	 .flag = SM_RUN ,
	 .action.func = flush_check_type ,
	 .pjtbl = NULL ,
	 .trtbl = ST_flush_check_type_trtbl 
};

static struct PINT_tran_tbl_s ST_flush_check_type_trtbl[] = {
	{ .return_value = FLUSH_KEYVAL ,
	 .next_state = &ST_kflush },
	{ .return_value = FLUSH_BSTREAM ,
	 .next_state = &ST_bflush },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_kflush = {
	 .state_name = "kflush" ,
	 .parent_machine = &pvfs2_flush_sm ,
	 .flag = SM_RUN ,
	 .action.func = flush_keyval_flush ,
	 .pjtbl = NULL ,
	 .trtbl = ST_kflush_trtbl 
};

static struct PINT_tran_tbl_s ST_kflush_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_kflush_check_error }
};

static struct PINT_state_s ST_kflush_check_error = {
	 .state_name = "kflush_check_error" ,
	 .parent_machine = &pvfs2_flush_sm ,
	 .flag = SM_RUN ,
	 .action.func = flush_check_error ,
	 .pjtbl = NULL ,
	 .trtbl = ST_kflush_check_error_trtbl 
};

static struct PINT_tran_tbl_s ST_kflush_check_error_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_final_response }
};

static struct PINT_state_s ST_bflush = {
	 .state_name = "bflush" ,
	 .parent_machine = &pvfs2_flush_sm ,
	 .flag = SM_RUN ,
	 .action.func = flush_bstream_flush ,
	 .pjtbl = NULL ,
	 .trtbl = ST_bflush_trtbl 
};

static struct PINT_tran_tbl_s ST_bflush_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_bflush_check_error }
};

static struct PINT_state_s ST_bflush_check_error = {
	 .state_name = "bflush_check_error" ,
	 .parent_machine = &pvfs2_flush_sm ,
	 .flag = SM_RUN ,
	 .action.func = flush_check_error ,
	 .pjtbl = NULL ,
	 .trtbl = ST_bflush_check_error_trtbl 
};

static struct PINT_tran_tbl_s ST_bflush_check_error_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_final_response }
};

static struct PINT_state_s ST_final_response = {
	 .state_name = "final_response" ,
	 .parent_machine = &pvfs2_flush_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_final_response_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_final_response_trtbl 
};

static struct PINT_tran_tbl_s ST_final_response_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_cleanup = {
	 .state_name = "cleanup" ,
	 .parent_machine = &pvfs2_flush_sm ,
	 .flag = SM_RUN ,
	 .action.func = flush_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_cleanup_trtbl[] = {
	{ .return_value = -1 ,

	 .flag = SM_TERM }
};

#ifndef WIN32
# 86 "src/server/flush.sm"
#endif


static PINT_sm_action flush_check_type(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    js_p->error_code = 0;

    if (s_op->attr.objtype == PVFS_TYPE_METAFILE)
    {
        js_p->error_code = FLUSH_KEYVAL;
    }
    else if (s_op->attr.objtype == PVFS_TYPE_DATAFILE)
    {
        js_p->error_code = FLUSH_BSTREAM;
    }
    return SM_ACTION_COMPLETE;
}

/*
 * Function: flush_keyval_flush
 *
 * Params:  server_op *s_op,
 *	    job_status_s *js_p
 *
 * Pre: None
 * Post: None
 * Returns: int
 *
 * Synopsys: send a keyval flush request to storage
 *
 */
static PINT_sm_action flush_keyval_flush(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -1;
    job_id_t tmp_id;

    gossip_debug(GOSSIP_SERVER_DEBUG, " doing keyval flush on %llu,%d\n",
                 llu(s_op->req->u.flush.handle), s_op->req->u.flush.fs_id);

    ret = job_trove_keyval_flush(
        s_op->req->u.flush.fs_id,
        s_op->req->u.flush.handle,
        s_op->req->u.flush.flags,
        smcb,
        0,
        js_p,
        &tmp_id,
        server_job_context, s_op->req->hints);

    return ret;
}

static PINT_sm_action flush_check_error(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    char buf[64] = {0};
    if (js_p->error_code != 0)
    {
        PVFS_strerror_r(js_p->error_code, buf, 64);

        gossip_err("failed to flush handle %llu: %s\n",
                   llu(s_op->req->u.flush.handle), buf);
    }
    return SM_ACTION_COMPLETE;
}

/*
 * Function: flush_bstream_flush
 *
 * Params:  server_op *s_op,
 *	    job_status_s *js_p
 *
 * Pre: None
 * Post: None
 * Returns: int
 *
 * Synopsys: send a bstream flush request to storage
 *
 */
static PINT_sm_action flush_bstream_flush(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -1;
    job_id_t i;

    gossip_debug(GOSSIP_SERVER_DEBUG, " doing bstream flush on %llu,%d\n",
                 llu(s_op->req->u.flush.handle), s_op->req->u.flush.fs_id);

    ret = job_trove_bstream_flush(
        s_op->req->u.flush.fs_id,
        s_op->req->u.flush.handle,
        s_op->req->u.flush.flags,
        smcb,
        0,
        js_p,
        &i,
        server_job_context, s_op->req->hints);

    return ret;
}
	    
static PINT_sm_action flush_cleanup(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    return(server_state_machine_complete(smcb));
}

static int perm_flush(PINT_server_op *s_op)
{
    int ret;

    ret = 0;

    return ret;
}

PINT_GET_OBJECT_REF_DEFINE(flush);

struct PINT_server_req_params pvfs2_flush_params =
{
    .string_name = "flush",
    .perm = perm_flush,
    .access_type = PINT_server_req_modify,
    .sched_policy = PINT_SERVER_REQ_SCHEDULE,
    .get_object_ref = PINT_get_object_ref_flush,
    .state_machine = &pvfs2_flush_sm
};

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */
