/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will certainly be overwritten.
 */

/*
 * Copyright 2001-12 Clemson University
 *
 * See COPYING in top-level directory.
 */

#include <string.h>
#include <stddef.h>
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_MALLOC_H
/* #include <malloc.h> */
#endif

#include "pvfs2-config.h"
#include "server-config.h"
#include "pvfs2-types.h"
#include "pvfs2-server.h"
#include "state-machine.h"
#include "job.h"
#include "pvfs2-attr.h"
#include "gossip.h"
#include "pvfs2-storage.h"
#include "pvfs2-internal.h"
#include "pint-util.h"
#include "str-utils.h"
#include "check.h"
#include "security-util.h"
#include "pint-uid-map.h"
#include "pint-cached-config.h"
#include "dist-dir-utils.h"

static int lookup_get_dirent_comp_fn(
    void *v_p, struct PVFS_server_resp *resp_p, int i);

enum 
{
    STATE_ENOTDIR = 22,
    STATE_NOMORESEGS = 23,
    LOOKUP_CHECK_DIR_ACLS = 24,
    LOOKUP_CHECK_PERMS = 25,
    LOCAL_DIRENT = 26,
    REMOTE_DIRENT = 27
};

static struct PINT_state_s ST_prelude;
static struct PINT_tran_tbl_s ST_prelude_trtbl[];

static PINT_sm_action lookup_init(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_init;
static struct PINT_tran_tbl_s ST_init_trtbl[];

static PINT_sm_action lookup_read_object_metadata(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_read_object_metadata;
static struct PINT_tran_tbl_s ST_read_object_metadata_trtbl[];

static PINT_sm_action lookup_verify_object_metadata(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_verify_object_metadata;
static struct PINT_tran_tbl_s ST_verify_object_metadata_trtbl[];

static PINT_sm_action lookup_check_perms(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_check_perms;
static struct PINT_tran_tbl_s ST_check_perms_trtbl[];

static PINT_sm_action lookup_read_directory_acls(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_read_directory_acls;
static struct PINT_tran_tbl_s ST_read_directory_acls_trtbl[];

static PINT_sm_action lookup_check_acls(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_check_acls;
static struct PINT_tran_tbl_s ST_check_acls_trtbl[];

static PINT_sm_action lookup_read_num_directory_entry_handles(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_read_num_directory_entry_handles;
static struct PINT_tran_tbl_s ST_read_num_directory_entry_handles_trtbl[];

static PINT_sm_action lookup_read_directory_entry_handles(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_read_directory_entry_handles;
static struct PINT_tran_tbl_s ST_read_directory_entry_handles_trtbl[];

static PINT_sm_action lookup_read_directory_entry(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_read_directory_entry;
static struct PINT_tran_tbl_s ST_read_directory_entry_trtbl[];

static PINT_sm_action lookup_read_directory_entry_local(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_read_directory_entry_local;
static struct PINT_tran_tbl_s ST_read_directory_entry_local_trtbl[];

static PINT_sm_action lookup_read_directory_entry_remote(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_read_directory_entry_remote;
static struct PINT_tran_tbl_s ST_read_directory_entry_remote_trtbl[];
static struct PINT_state_s ST_read_directory_entry_xfer_msgpair;
static struct PINT_tran_tbl_s ST_read_directory_entry_xfer_msgpair_trtbl[];

static PINT_sm_action lookup_setup_resp(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_setup_resp;
static struct PINT_tran_tbl_s ST_setup_resp_trtbl[];
static struct PINT_state_s ST_final_response;
static struct PINT_tran_tbl_s ST_final_response_trtbl[];

static PINT_sm_action lookup_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_cleanup;
static struct PINT_tran_tbl_s ST_cleanup_trtbl[];

struct PINT_state_machine_s pvfs2_lookup_sm = {
	.name = "pvfs2_lookup_sm",
	.first_state = &ST_prelude
};

static struct PINT_state_s ST_prelude = {
	 .state_name = "prelude" ,
	 .parent_machine = &pvfs2_lookup_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_prelude_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_prelude_trtbl 
};

static struct PINT_tran_tbl_s ST_prelude_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_init },
	{ .return_value = -1 ,
	 .next_state = &ST_final_response }
};

static struct PINT_state_s ST_init = {
	 .state_name = "init" ,
	 .parent_machine = &pvfs2_lookup_sm ,
	 .flag = SM_RUN ,
	 .action.func = lookup_init ,
	 .pjtbl = NULL ,
	 .trtbl = ST_init_trtbl 
};

static struct PINT_tran_tbl_s ST_init_trtbl[] = {
	{ .return_value = STATE_ENOTDIR ,
	 .next_state = &ST_setup_resp },
	{ .return_value = -1 ,
	 .next_state = &ST_read_object_metadata }
};

static struct PINT_state_s ST_read_object_metadata = {
	 .state_name = "read_object_metadata" ,
	 .parent_machine = &pvfs2_lookup_sm ,
	 .flag = SM_RUN ,
	 .action.func = lookup_read_object_metadata ,
	 .pjtbl = NULL ,
	 .trtbl = ST_read_object_metadata_trtbl 
};

static struct PINT_tran_tbl_s ST_read_object_metadata_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_verify_object_metadata },
	{ .return_value = -1 ,
	 .next_state = &ST_setup_resp }
};

static struct PINT_state_s ST_verify_object_metadata = {
	 .state_name = "verify_object_metadata" ,
	 .parent_machine = &pvfs2_lookup_sm ,
	 .flag = SM_RUN ,
	 .action.func = lookup_verify_object_metadata ,
	 .pjtbl = NULL ,
	 .trtbl = ST_verify_object_metadata_trtbl 
};

static struct PINT_tran_tbl_s ST_verify_object_metadata_trtbl[] = {
	{ .return_value = LOOKUP_CHECK_PERMS ,
	 .next_state = &ST_check_perms },
	{ .return_value = 0 ,
	 .next_state = &ST_read_num_directory_entry_handles },
	{ .return_value = -1 ,
	 .next_state = &ST_setup_resp }
};

static struct PINT_state_s ST_check_perms = {
	 .state_name = "check_perms" ,
	 .parent_machine = &pvfs2_lookup_sm ,
	 .flag = SM_RUN ,
	 .action.func = lookup_check_perms ,
	 .pjtbl = NULL ,
	 .trtbl = ST_check_perms_trtbl 
};

static struct PINT_tran_tbl_s ST_check_perms_trtbl[] = {
	{ .return_value = LOOKUP_CHECK_DIR_ACLS ,
	 .next_state = &ST_read_directory_acls },
	{ .return_value = 0 ,
	 .next_state = &ST_read_num_directory_entry_handles },
	{ .return_value = -1 ,
	 .next_state = &ST_setup_resp }
};

static struct PINT_state_s ST_read_directory_acls = {
	 .state_name = "read_directory_acls" ,
	 .parent_machine = &pvfs2_lookup_sm ,
	 .flag = SM_RUN ,
	 .action.func = lookup_read_directory_acls ,
	 .pjtbl = NULL ,
	 .trtbl = ST_read_directory_acls_trtbl 
};

static struct PINT_tran_tbl_s ST_read_directory_acls_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_check_acls }
};

static struct PINT_state_s ST_check_acls = {
	 .state_name = "check_acls" ,
	 .parent_machine = &pvfs2_lookup_sm ,
	 .flag = SM_RUN ,
	 .action.func = lookup_check_acls ,
	 .pjtbl = NULL ,
	 .trtbl = ST_check_acls_trtbl 
};

static struct PINT_tran_tbl_s ST_check_acls_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_read_num_directory_entry_handles },
	{ .return_value = -1 ,
	 .next_state = &ST_setup_resp }
};

static struct PINT_state_s ST_read_num_directory_entry_handles = {
	 .state_name = "read_num_directory_entry_handles" ,
	 .parent_machine = &pvfs2_lookup_sm ,
	 .flag = SM_RUN ,
	 .action.func = lookup_read_num_directory_entry_handles ,
	 .pjtbl = NULL ,
	 .trtbl = ST_read_num_directory_entry_handles_trtbl 
};

static struct PINT_tran_tbl_s ST_read_num_directory_entry_handles_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_read_directory_entry_handles }
};

static struct PINT_state_s ST_read_directory_entry_handles = {
	 .state_name = "read_directory_entry_handles" ,
	 .parent_machine = &pvfs2_lookup_sm ,
	 .flag = SM_RUN ,
	 .action.func = lookup_read_directory_entry_handles ,
	 .pjtbl = NULL ,
	 .trtbl = ST_read_directory_entry_handles_trtbl 
};

static struct PINT_tran_tbl_s ST_read_directory_entry_handles_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_read_directory_entry },
	{ .return_value = -1 ,
	 .next_state = &ST_setup_resp }
};

static struct PINT_state_s ST_read_directory_entry = {
	 .state_name = "read_directory_entry" ,
	 .parent_machine = &pvfs2_lookup_sm ,
	 .flag = SM_RUN ,
	 .action.func = lookup_read_directory_entry ,
	 .pjtbl = NULL ,
	 .trtbl = ST_read_directory_entry_trtbl 
};

static struct PINT_tran_tbl_s ST_read_directory_entry_trtbl[] = {
	{ .return_value = LOCAL_DIRENT ,
	 .next_state = &ST_read_directory_entry_local },
	{ .return_value = REMOTE_DIRENT ,
	 .next_state = &ST_read_directory_entry_remote },
	{ .return_value = -1 ,
	 .next_state = &ST_setup_resp }
};

static struct PINT_state_s ST_read_directory_entry_local = {
	 .state_name = "read_directory_entry_local" ,
	 .parent_machine = &pvfs2_lookup_sm ,
	 .flag = SM_RUN ,
	 .action.func = lookup_read_directory_entry_local ,
	 .pjtbl = NULL ,
	 .trtbl = ST_read_directory_entry_local_trtbl 
};

static struct PINT_tran_tbl_s ST_read_directory_entry_local_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_read_object_metadata },
	{ .return_value = -1 ,
	 .next_state = &ST_setup_resp }
};

static struct PINT_state_s ST_read_directory_entry_remote = {
	 .state_name = "read_directory_entry_remote" ,
	 .parent_machine = &pvfs2_lookup_sm ,
	 .flag = SM_RUN ,
	 .action.func = lookup_read_directory_entry_remote ,
	 .pjtbl = NULL ,
	 .trtbl = ST_read_directory_entry_remote_trtbl 
};

static struct PINT_tran_tbl_s ST_read_directory_entry_remote_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_read_directory_entry_xfer_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_setup_resp }
};

static struct PINT_state_s ST_read_directory_entry_xfer_msgpair = {
	 .state_name = "read_directory_entry_xfer_msgpair" ,
	 .parent_machine = &pvfs2_lookup_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_msgpairarray_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_read_directory_entry_xfer_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_read_directory_entry_xfer_msgpair_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_read_object_metadata },
	{ .return_value = -1 ,
	 .next_state = &ST_setup_resp }
};

static struct PINT_state_s ST_setup_resp = {
	 .state_name = "setup_resp" ,
	 .parent_machine = &pvfs2_lookup_sm ,
	 .flag = SM_RUN ,
	 .action.func = lookup_setup_resp ,
	 .pjtbl = NULL ,
	 .trtbl = ST_setup_resp_trtbl 
};

static struct PINT_tran_tbl_s ST_setup_resp_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_final_response }
};

static struct PINT_state_s ST_final_response = {
	 .state_name = "final_response" ,
	 .parent_machine = &pvfs2_lookup_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_final_response_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_final_response_trtbl 
};

static struct PINT_tran_tbl_s ST_final_response_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_cleanup = {
	 .state_name = "cleanup" ,
	 .parent_machine = &pvfs2_lookup_sm ,
	 .flag = SM_RUN ,
	 .action.func = lookup_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_cleanup_trtbl[] = {
	{ .return_value = -1 ,

	 .flag = SM_TERM }
};

#ifndef WIN32
# 161 "src/server/lookup.sm"
#endif


/*
 * Function: lookup_init
 *
 * Synopsis: initializes internal structures and posts job to request
 * scheduler.
 *
 * Assumes req structure holds a valid path.
 *
 * Initializes segp, seg_ct, seg_nr fields in s_op->u.lookup.
 *
 * Allocates memory for handle and attribute arrays that will be
 * returned in the response.
 *
 * Note: memory is allocated as one big chunk, pointed to by
 * s_op->resp.u.lookup_path.handle_array.
 *
 */
static PINT_sm_action lookup_init(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    char *ptr = NULL;

    s_op->u.lookup.attr.dist_dir_bitmap = NULL;
    s_op->u.lookup.attr.dirdata_handles = NULL;
    s_op->key_a = NULL;
    s_op->val_a = NULL;
    s_op->error_a = NULL;

    /* fill in the lookup portion of the PINT_server_op */
    s_op->u.lookup.segp = NULL;
    s_op->u.lookup.seg_nr = 0;
    s_op->u.lookup.seg_ct = PINT_string_count_segments(
                                        s_op->req->u.lookup_path.path);
    s_op->u.lookup.handle_ct = 0;
    s_op->u.lookup.attr_ct = 0;

    gossip_debug(GOSSIP_SERVER_DEBUG, " STARTING LOOKUP REQUEST "
                 "(path:%s)(fs_id:%d)(handle:%llu)(attrmask:%u)"
                 "(# of segments:%u)\n",
                 s_op->req->u.lookup_path.path,
                 s_op->req->u.lookup_path.fs_id,
                 llu(s_op->req->u.lookup_path.handle),
                 s_op->req->u.lookup_path.attrmask,
                 s_op->u.lookup.seg_ct);
    if ((s_op->u.lookup.seg_ct < 0) ||
        (s_op->u.lookup.seg_ct > PVFS_REQ_LIMIT_PATH_SEGMENT_COUNT))
    {
        gossip_err("  invalid path %s (bad segment count); "
                   "sending error response\n",
                   s_op->req->u.lookup_path.path);
        js_p->error_code = -PVFS_ENOTDIR;
        return SM_ACTION_DEFERRED;
    }

    /* allocate the internal ds_attr_array */
    s_op->u.lookup.ds_attr_array = (PVFS_ds_attributes *)
        malloc(s_op->u.lookup.seg_ct * sizeof(PVFS_ds_attributes));
    if (!s_op->u.lookup.ds_attr_array)
    {
        js_p->error_code = -PVFS_ENOMEM;
        return 1;
    }

    /* allocate memory
     *
     * Note: all memory is allocated in a single block,
     * pointed to by s_op->resp.u.lookup_path.handle_array
     */
    ptr = malloc(s_op->u.lookup.seg_ct *
                 (sizeof(PVFS_handle) + sizeof(PVFS_object_attr)));
    if (!ptr)
    {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }

    s_op->resp.u.lookup_path.handle_array = (PVFS_handle *)ptr;
    ptr += (s_op->u.lookup.seg_ct * sizeof(PVFS_handle));

    s_op->resp.u.lookup_path.attr_array = (PVFS_object_attr *)ptr;

    js_p->error_code = 0;
    return SM_ACTION_COMPLETE;
}

/*
 * Function: lookup_read_object_metadata
 *
 * Synopsis: Given an object handle, looks up the attributes
 * (metadata) for that handle.
 *
 * Initializes key and value structures to direct metadata:
 * - if this is the starting (base) handle, store in
 *   s_op->u.lookup.base_attr
 * - otherwise store it in the appropriate slot in the resp handle array
 *
 * Posts the keyval read to trove.
 */
static PINT_sm_action lookup_read_object_metadata(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    job_id_t j_id;
    PVFS_handle handle = PVFS_HANDLE_NULL;
    PVFS_ds_attributes *ds_attr = NULL;

    assert(s_op->u.lookup.seg_nr <= s_op->u.lookup.seg_ct);

    /* use the base handle if we haven't looked up a segment yet */
    if (s_op->u.lookup.seg_nr == 0)
    {
        handle = s_op->req->u.lookup_path.handle;
        ds_attr = &(s_op->u.lookup.ds_attr_array[0]);
    }
    else
    {
        handle = s_op->resp.u.lookup_path.handle_array[
            s_op->u.lookup.seg_nr - 1];
        ds_attr = &(s_op->u.lookup.ds_attr_array[
            s_op->u.lookup.seg_nr - 1]);
    }

    /* update our successful handle read count */
    s_op->u.lookup.handle_ct++;

    /* Copy the fsid and handle to the s_op structure for the acl check */
    s_op->target_handle = handle;
    s_op->target_fs_id = s_op->req->u.lookup_path.fs_id;

    /* get the dspace attributes/metadata */
    ret = job_trove_dspace_getattr(
        s_op->req->u.lookup_path.fs_id, handle, smcb, ds_attr,
        0, js_p, &j_id, server_job_context, s_op->req->hints );

    return ret;
}

/*
 * Function: lookup_verify_object_metadata
 *
 * Synopsis: Examine the metadata returned from the prelude sm.  If
 * the metadata is for a directory, prepare to read the handle of the
 * next segment, if there is one.  If the metadata is for a file,
 * prepare to send a response.
 *
 * If the object is a directory, this function sets the
 * s_op->u.lookup.segp value to point to the next segment to look up;
 * this is used in lookup_read_directory_entry.
 *
 * This function does not post an operation, but rather returns 1
 * immediately.
 */
static PINT_sm_action lookup_verify_object_metadata(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PVFS_object_attr *a_p = NULL;
    PVFS_ds_attributes *ds_attr = NULL;

    if (s_op->u.lookup.seg_nr == 0)
    {
        a_p = &s_op->attr;
        ds_attr = &(s_op->u.lookup.ds_attr_array[0]);
    }
    else
    {
        a_p = &s_op->resp.u.lookup_path.attr_array[
            s_op->u.lookup.seg_nr - 1];
        ds_attr = &(s_op->u.lookup.ds_attr_array[
            s_op->u.lookup.seg_nr - 1]);
    }

    PVFS_ds_attr_to_object_attr(ds_attr, a_p);
    a_p->mask = PVFS_ATTR_COMMON_ALL;
    s_op->target_object_attr = a_p;

    /* update our successful attr read count */
    s_op->u.lookup.attr_ct++;

    assert(((a_p->objtype == PVFS_TYPE_DIRECTORY) ||
            (a_p->objtype == PVFS_TYPE_METAFILE)  ||
            (a_p->objtype == PVFS_TYPE_SYMLINK)));

    gossip_debug(
        GOSSIP_SERVER_DEBUG, "  attrs = (owner = %d, group = %d, "
        "perms = %o, type = %d)\n", a_p->owner, a_p->group,
        a_p->perms, a_p->objtype);

    /* if we hit a metafile, we are done */
    if (a_p->objtype == PVFS_TYPE_METAFILE)
    {
        gossip_debug(GOSSIP_SERVER_DEBUG, "  object is a metafile; "
                     "halting lookup and sending response\n");

        js_p->error_code = STATE_ENOTDIR;
        return SM_ACTION_COMPLETE;
    }

    /*
      if we hit a symlink, we're done; client will pick up the pieces
      and continue to resolve the symlink if required
    */
    if (a_p->objtype == PVFS_TYPE_SYMLINK)
    {
        gossip_debug(GOSSIP_SERVER_DEBUG, "  object is a symlink; "
                     "halting lookup and sending response\n");

        js_p->error_code = STATE_ENOTDIR;
        return SM_ACTION_COMPLETE;
    }

    /* if we looked up all the segments, we are done */
    if (s_op->u.lookup.seg_nr == s_op->u.lookup.seg_ct)
    {
        gossip_debug(GOSSIP_SERVER_DEBUG, "  no more segments in path; "
                     "sending response\n");

        js_p->error_code = STATE_NOMORESEGS;
        return SM_ACTION_COMPLETE;
    }

    /* if we reach this point, the object is a directory. If this is not 
     * the first segment being looked up on this server, check permissions
     * by going to the check_perms state. (The first segment is checked when
     * the capability is checked by the prelude.)
     */
    if (s_op->u.lookup.seg_nr > 0)
    {
        js_p->error_code = LOOKUP_CHECK_PERMS;
        return SM_ACTION_COMPLETE;
    }

    return SM_ACTION_COMPLETE;
}

/*                                                              
 * Function: lookup_check_perms
 * 
 * Synopsis: check to see whether the requesting user has permission to do
 * the lookup. This function checks the file mode (i.e. mask). If the file
 * mode doesn't provide permission, the SM will proceed to the check_acls
 * state.
 */
static PINT_sm_action lookup_check_perms(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PVFS_object_attr *a_p = s_op->target_object_attr;
    PVFS_credential *cred = &(s_op->req->u.lookup_path.credential);
    PVFS_uid uid;
    PVFS_gid group_array[PVFS_REQ_LIMIT_GROUPS];
    uint32_t op_mask, num_groups;
    char mask_buf[16];
    int ret;

    /* If we get here with an invalid fsid and handle, we have to
     * return -PVFS_EACCESS 
     */
    if (s_op->target_fs_id == PVFS_FS_ID_NULL
        || s_op->target_handle == PVFS_HANDLE_NULL)
    {
        js_p->error_code = -PVFS_EACCES;
        return SM_ACTION_COMPLETE;
    }

    assert(a_p);

    js_p->error_code = 0;

    /* map the user using security */
    ret = PINT_map_credential(cred, &uid, &num_groups, group_array);
    if (ret != 0)
    {
        js_p->error_code = ret;
        return SM_ACTION_COMPLETE;
    }

    PINT_debug_credential(cred, "  lookup_check_perms", uid, num_groups,
                          group_array);

#ifdef ENABLE_SECURITY_CERT
    op_mask = 0;
    /* no capabilities for unsigned credential */
    if (!IS_UNSIGNED_CRED(cred))
    {
#endif
    /* retrieve the capabilities of the credential as a mask */
    ret = PINT_get_capabilities(NULL, 0, uid, group_array, num_groups, 
                                a_p, &op_mask);

    if (ret != 0)
    {
        /* Currently PINT_get_capabilities only returns 0 unless ACLs are 
         * being checked. This code is provided for future-proofing.
         */
        gossip_err("  lookup_check_perms: could not retrieve permissions mask "
                   "(%d)\n", ret);
        js_p->error_code = -PVFS_EINVAL;
        return SM_ACTION_COMPLETE;
    }
#ifdef ENABLE_SECURITY_CERT
    } /* if */
#endif

    gossip_debug(GOSSIP_SERVER_DEBUG, "  lookup_check_perms: op mask = %s\n",
                 PINT_print_op_mask(op_mask, mask_buf));
    
    /* must have executable permission */
    if ((op_mask & PINT_CAP_EXEC) == 0)
    {
        /* no file-mode permission--check ACLs */
#ifdef ENABLE_SECURITY_CERT
        /* don't check ACLs for unsigned cred */
        js_p->error_code = IS_UNSIGNED_CRED(cred) ? 0 : LOOKUP_CHECK_DIR_ACLS;
#else
        js_p->error_code = LOOKUP_CHECK_DIR_ACLS;
#endif
        return SM_ACTION_COMPLETE;
    }

    return SM_ACTION_COMPLETE;
}

/* Function: lookup_read_acls 
 *
 * Synopsis: Post a keyval DB read of the posix acls to check and see if 
 * directory traversal is allowed or not
 */
static PINT_sm_action lookup_read_directory_acls(
    struct PINT_smcb *smcb, job_status_s* js_p)
{
    int ret = -PVFS_EINVAL;
    job_id_t j_id;
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    /* If we get here with an invalid fsid and handle, we have to
     * return -PVFS_EACCESS 
     */
    if (s_op->target_fs_id == PVFS_FS_ID_NULL
        || s_op->target_handle == PVFS_HANDLE_NULL)
    {
        js_p->error_code = -PVFS_EACCES;
        return SM_ACTION_COMPLETE;
    }
    js_p->error_code = 0;

    memset(&s_op->key, 0, sizeof(PVFS_ds_keyval));
    memset(&s_op->val, 0, sizeof(PVFS_ds_keyval));
    s_op->key.buffer = "system.posix_acl_access";
    s_op->key.buffer_sz = strlen(s_op->key.buffer) + 1;
    s_op->val.buffer = (char *) malloc(PVFS_REQ_LIMIT_VAL_LEN);
    if (!s_op->val.buffer)
    {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }
    s_op->val.buffer_sz = PVFS_REQ_LIMIT_VAL_LEN;

    gossip_debug(GOSSIP_SERVER_DEBUG, "  About to retrieve acl keyvals "
                 "for handle %llu\n", llu(s_op->target_handle));

    /* Read acl keys */
    ret = job_trove_keyval_read(
        s_op->target_fs_id, s_op->target_handle, &s_op->key, &s_op->val,
        0,
        NULL, smcb, 0, js_p, &j_id, server_job_context, s_op->req->hints);

    return ret;
}
/* 
 * Function lookup_check_acls
 *
 * Synopsis: check to see whether the requesting user has permission to do
 * the lookup. This function checks POSIX ACLs.
 */
static PINT_sm_action lookup_check_acls(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PVFS_object_attr *a_p = s_op->target_object_attr;
    PVFS_credential *cred = &(s_op->req->u.lookup_path.credential);
    PVFS_uid uid;
    PVFS_gid group_array[PVFS_REQ_LIMIT_GROUPS];
    uint32_t op_mask, num_groups;
    char mask_buf[16];
    int ret;

    assert(a_p);

    if (s_op->val.read_sz == 0)
    {
        /* No ACLs available--return EACCES */
        gossip_debug(GOSSIP_SERVER_DEBUG, "  lookup_check_acls: no acls\n");
        js_p->error_code = -PVFS_EACCES;
        goto cleanup;
    }

    ret = PINT_map_credential(cred, &uid, &num_groups, group_array);
    if (ret != 0)
    {
        js_p->error_code = -PVFS_EACCES;
        goto cleanup;
    }

    /* get the op mask given the ACLs */
    ret = PINT_get_capabilities(s_op->val.buffer, s_op->val.read_sz, 
        uid, group_array, num_groups, a_p, &op_mask);

    if (ret != 0)
    {
        /* unexpected error */
        gossip_err("  lookup_check_acls: could not retrieve permissions mask "
                   "(%d)\n", ret);
        js_p->error_code = -PVFS_EINVAL;
        goto cleanup;
    }

    gossip_debug(GOSSIP_SERVER_DEBUG, "  lookup_check_acls: op mask = %s\n",
                 PINT_print_op_mask(op_mask, mask_buf));

    /* must have executable permission */
    if ((op_mask & PINT_CAP_EXEC) == 0)
    {
        js_p->error_code = -PVFS_EACCES;
        goto cleanup;
    }

    /* success if we get here */
    js_p->error_code = 0;

cleanup:
    free(s_op->val.buffer);

    return SM_ACTION_COMPLETE;
}

/*
 * Function: lookup_read_num_directory_entry_handles
 *
 * Synopsis: Given a directory handle, determine how many handles are
 * used to store directory entries for this directory.
 *
 * Initializes key and value structures to direct num handles into
 * s_op->u.lookup.num_dirent_handles. The handle to use for the
 * read is either:
 * - the starting handle from the req (if we haven't looked up a
 *   segment yet), or
 * - the previous segment's handle (from response handle array).
 *
 * Posts the keyval read to trove.
 */
static PINT_sm_action lookup_read_num_directory_entry_handles(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    PVFS_handle handle = PVFS_HANDLE_NULL;
    job_id_t j_id;

    /* use the base handle if we haven't looked up a segment yet */
    if (s_op->u.lookup.seg_nr == 0)
    {
        handle = s_op->req->u.lookup_path.handle;
    }
    else
    {
        handle = s_op->resp.u.lookup_path.handle_array[
            s_op->u.lookup.seg_nr-1];
    }

    gossip_debug(GOSSIP_SERVER_DEBUG,
                 "  reading distributed directory attributes from handle %llu\n",
                 llu(handle));

    s_op->key.buffer = Trove_Common_Keys[DIST_DIR_ATTR_KEY].key;
    s_op->key.buffer_sz = Trove_Common_Keys[DIST_DIR_ATTR_KEY].size;
    s_op->val.buffer = &s_op->u.lookup.attr.dist_dir_attr;
    s_op->val.buffer_sz = sizeof(s_op->u.lookup.attr.dist_dir_attr);

    ret = job_trove_keyval_read(
        s_op->req->u.lookup_path.fs_id, handle, &s_op->key, &s_op->val,
        0,
        NULL, smcb, 0, js_p, &j_id, server_job_context, s_op->req->hints);

    return ret;
}

/*
 * Function: lookup_read_directory_entry_handles
 *
 * Synopsis: Given a directory handle, look up the handle used to
 * store directory entries for this directory.
 *
 * Initializes key and value structures to direct handle into
 * s_op->u.lookup.dirent_handle, which is where we always store the
 * handle used to read directory entries.  The handle to use for the
 * read is either:
 * - the starting handle from the req (if we haven't looked up a
 *   segment yet), or
 * - the previous segment's handle (from response handle array).
 *
 * Posts the keyval read to trove.
 */
static PINT_sm_action lookup_read_directory_entry_handles(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    PVFS_handle handle = PVFS_HANDLE_NULL;
    job_id_t j_id;
    PVFS_object_attr *attr;
    int keyval_count;

    attr = &s_op->u.lookup.attr;

    if(js_p->error_code == -TROVE_ENOENT)
    {
        gossip_debug(GOSSIP_GETATTR_DEBUG, "lookup: no DIST_DIR_ATTR key present!\n");
        attr->dist_dir_bitmap = NULL;
        attr->dirdata_handles = NULL;
        return SM_ACTION_COMPLETE;
    }

    assert(attr->dist_dir_attr.num_servers > 0 &&
        attr->dist_dir_attr.bitmap_size > 0);

    /* use the base handle if we haven't looked up a segment yet */
    if (s_op->u.lookup.seg_nr == 0)
    {
        handle = s_op->req->u.lookup_path.handle;
    }
    else
    {
        handle = s_op->resp.u.lookup_path.handle_array[
            s_op->u.lookup.seg_nr-1];
    }

    gossip_debug(GOSSIP_SERVER_DEBUG,
            "lookup: get dist-dir-attr for dir meta handle %llu "
            "with tree_height=%d, num_servers=%d, bitmap_size=%d, "
            "split_size=%d, server_no=%d and branch_level=%d\n",
            llu(handle),
            attr->dist_dir_attr.tree_height,
            attr->dist_dir_attr.num_servers,
            attr->dist_dir_attr.bitmap_size,
            attr->dist_dir_attr.split_size,
            attr->dist_dir_attr.server_no,
            attr->dist_dir_attr.branch_level);

    /* allocate space for bitmap and dirdata handles */
    attr->dist_dir_bitmap =
        malloc(attr->dist_dir_attr.bitmap_size *
                sizeof(PVFS_dist_dir_bitmap_basetype));
    attr->dirdata_handles =
        malloc(attr->dist_dir_attr.num_servers *
                sizeof(PVFS_handle));
    if(!attr->dist_dir_bitmap ||
            !attr->dirdata_handles)
    {
        free(attr->dist_dir_bitmap);
        free(attr->dirdata_handles);
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }

    /* total 2 keyvals, DIST_DIRDATA_BITMAP, DIST_DIRDATA_HANDLES */
    keyval_count = 2;

    s_op->key_a = malloc(sizeof(PVFS_ds_keyval) * keyval_count);
    if(!s_op->key_a)
    {
        free(attr->dist_dir_bitmap);
        free(attr->dirdata_handles);
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }

    s_op->val_a = malloc(sizeof(PVFS_ds_keyval) * keyval_count);
    if(!s_op->val_a)
    {
        free(attr->dist_dir_bitmap);
        free(attr->dirdata_handles);
        free(s_op->key_a);
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }
    memset(s_op->val_a, 0, sizeof(PVFS_ds_keyval) * keyval_count);

    s_op->key_a[0].buffer = Trove_Common_Keys[DIST_DIRDATA_BITMAP_KEY].key;
    s_op->key_a[0].buffer_sz = Trove_Common_Keys[DIST_DIRDATA_BITMAP_KEY].size;

    s_op->val_a[0].buffer_sz =
        attr->dist_dir_attr.bitmap_size *
        sizeof(PVFS_dist_dir_bitmap_basetype);
    s_op->val_a[0].buffer = attr->dist_dir_bitmap;

    s_op->key_a[1].buffer = Trove_Common_Keys[DIST_DIRDATA_HANDLES_KEY].key;
    s_op->key_a[1].buffer_sz = Trove_Common_Keys[DIST_DIRDATA_HANDLES_KEY].size;

    s_op->val_a[1].buffer = attr->dirdata_handles;
    s_op->val_a[1].buffer_sz = attr->dist_dir_attr.num_servers *
        sizeof(PVFS_handle);

    s_op->error_a = (PVFS_error*)calloc(keyval_count,
        sizeof(PVFS_error));
    if (s_op->error_a == NULL)
    {
        free(attr->dist_dir_bitmap);
        free(attr->dirdata_handles);
        free(s_op->key_a);
        free(s_op->val_a);
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }

    js_p->error_code = 0;
    ret = job_trove_keyval_read_list(
        s_op->req->u.lookup_path.fs_id, handle,
        s_op->key_a, s_op->val_a,
        s_op->error_a,
        keyval_count,
        0,
        NULL,
        smcb,
        0,
        js_p,
        &j_id,
        server_job_context, s_op->req->hints);

    return ret;
}

/*
 * Function: lookup_read_directory_entry
 *
 * Synopsis: Given a handle for a dspace holding directory entries,
 * look up the current segment and obtain its handle.
 */
static PINT_sm_action lookup_read_directory_entry(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    PVFS_dist_dir_hash_type dirdata_hash;
    server_configuration_s *config = PINT_server_config_mgr_get_config();
    char dirdata_server_name[1024];

    /* find the segment that we should look up in the directory */
    ret = PINT_string_next_segment(
        s_op->req->u.lookup_path.path, &s_op->u.lookup.segp,
        &s_op->u.lookup.segstate);

    if (ret != 0)
    {
        gossip_err("PINT_string_next_segment failed: path: %s\n",
                   s_op->req->u.lookup_path.path);
    }
    assert(ret == 0);

    /* Need to see if directory entry is on this server. If not prepare
       to send a request to the server where it is located. */

    /* find the hash value and the dist dir bucket */
    dirdata_hash = PINT_encrypt_dirdata(s_op->u.lookup.segp);
    gossip_debug(GOSSIP_SERVER_DEBUG, "lookup: encrypt dirent %s into hash value %llu.\n",
            s_op->u.lookup.segp, llu(dirdata_hash));

    s_op->u.lookup.dirdata_server_index =
        PINT_find_dist_dir_bucket(dirdata_hash,
            &s_op->u.lookup.attr.dist_dir_attr,
            s_op->u.lookup.attr.dist_dir_bitmap);
    gossip_debug(GOSSIP_SERVER_DEBUG,
        "lookup: selecting bucket No.%d from dist_dir_bitmap.\n",
        s_op->u.lookup.dirdata_server_index);
    gossip_debug(
        GOSSIP_SERVER_DEBUG, "  need to read from dirent handle = "
        "%llu, segment = %s (len=%d)\n", llu(s_op->u.lookup.attr.dirdata_handles[s_op->u.lookup.dirdata_server_index]),
        s_op->u.lookup.segp, (int) strlen(s_op->u.lookup.segp));

    /* find the server name of the dirdata handle */
    PINT_cached_config_get_server_name(dirdata_server_name, 1024,
            s_op->u.lookup.attr.dirdata_handles[s_op->u.lookup.dirdata_server_index],
            s_op->req->u.lookup_path.fs_id);

    if ( !strcmp(dirdata_server_name, config->host_id) )
    {
        gossip_debug(GOSSIP_SERVER_DEBUG,
                "lookup: local server !!!\n");
        js_p->error_code = LOCAL_DIRENT;
    }
    else
    {
        gossip_debug(GOSSIP_SERVER_DEBUG,
                "lookup: remote server !!!\n");
        js_p->error_code = REMOTE_DIRENT;
    }
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action lookup_read_directory_entry_local(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    job_id_t j_id;
    int ret = -PVFS_EINVAL;

    js_p->error_code = 0;

    s_op->key.buffer = s_op->u.lookup.segp;
    s_op->key.buffer_sz = strlen(s_op->u.lookup.segp) + 1;
    s_op->val.buffer =
        &s_op->resp.u.lookup_path.handle_array[s_op->u.lookup.seg_nr];
    s_op->val.buffer_sz = sizeof(PVFS_handle);

    /*
      NOTE: if this operation fails, seg_nr will indicate one too many
      valid segments; this is addressed in lookup_send_response.
    */
    s_op->u.lookup.seg_nr++;

    ret = job_trove_keyval_read(
        s_op->req->u.lookup_path.fs_id,
        s_op->u.lookup.attr.dirdata_handles[s_op->u.lookup.dirdata_server_index],
        &s_op->key, &s_op->val,
        TROVE_KEYVAL_DIRECTORY_ENTRY,
        NULL, smcb, 0, js_p, &j_id,
        server_job_context, s_op->req->hints);
    return ret;
}

static PINT_sm_action lookup_read_directory_entry_remote(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PINT_sm_msgpair_state *msg_p = NULL;
    int ret;
    PVFS_capability capability;

    gossip_debug(GOSSIP_LOOKUP_DEBUG, "lookup state: read_directory_entry_remote\n");

    /*
      NOTE: if this operation fails, seg_nr will indicate one too many
      valid segments; this is addressed in lookup_send_response.
    */
    s_op->u.lookup.seg_nr++;

    PINT_msgpair_init(&s_op->msgarray_op);
    msg_p = &s_op->msgarray_op.msgpair;
    PINT_serv_init_msgarray_params(s_op, s_op->req->u.lookup_path.fs_id);

    PINT_null_capability(&capability);

    PINT_SERVREQ_MGMT_GET_DIRENT_FILL(
        msg_p->req,
        capability,
        s_op->req->u.lookup_path.fs_id,
        s_op->u.lookup.attr.dirdata_handles[s_op->u.lookup.dirdata_server_index],
        s_op->u.lookup.segp,
        NULL);

    PINT_cleanup_capability(&capability);

    msg_p->fs_id = s_op->req->u.lookup_path.fs_id;
    msg_p->handle =
        s_op->u.lookup.attr.dirdata_handles[s_op->u.lookup.dirdata_server_index];
    msg_p->retry_flag = PVFS_MSGPAIR_RETRY;
    msg_p->comp_fn = lookup_get_dirent_comp_fn;

    ret = PINT_cached_config_map_to_server(
        &msg_p->svr_addr, msg_p->handle, msg_p->fs_id);

    if (ret)
    {
        gossip_err("Failed to map dirdata server address\n");
        js_p->error_code = ret;
        return SM_ACTION_COMPLETE;
    }

    gossip_debug(GOSSIP_LOOKUP_DEBUG,
        "reading remote directory entry from handle %llu\n",
        llu(msg_p->handle));

    PINT_sm_push_frame(smcb, 0, &s_op->msgarray_op);
    js_p->error_code = 0;
    return SM_ACTION_COMPLETE;
}

static int lookup_get_dirent_comp_fn(
    void *v_p, struct PVFS_server_resp *resp_p, int index)
{
    PINT_smcb *smcb = v_p;
    PINT_server_op *s_op = PINT_sm_frame(smcb, (PINT_MSGPAIR_PARENT_SM));


    assert(resp_p->op == PVFS_SERV_MGMT_GET_DIRENT);

    if (resp_p->status == 0 && resp_p->u.mgmt_get_dirent.error == 0)
    {
        s_op->resp.u.lookup_path.handle_array[s_op->u.lookup.seg_nr-1] =
            resp_p->u.mgmt_get_dirent.handle;

        gossip_debug(
            GOSSIP_SERVER_DEBUG, "  lookup_get_dirent_comp_fn: "
            "got dirent handle %llu\n",
            llu(resp_p->u.mgmt_get_dirent.handle));
    }
    return resp_p->u.mgmt_get_dirent.error;
}

static PINT_sm_action lookup_setup_resp(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    /*
      NOTE: we may have handle_count N with attr_count N-1 in the case
      that another meta-server needs to continue with the path (attr)
      lookup.  otherwise, we're returning N handles with N attrs.

      # actually completed are one less than the respective counts
    */
    s_op->resp.u.lookup_path.handle_count = s_op->u.lookup.handle_ct - 1;
    s_op->resp.u.lookup_path.attr_count = s_op->u.lookup.attr_ct - 1;

    if (s_op->resp.u.lookup_path.handle_count ||
        s_op->resp.u.lookup_path.attr_count)
    {
        js_p->error_code = 0;
    }
    else if (js_p->error_code < 0)
    {
        /* preserve error code in this case and fall through */
        gossip_debug(GOSSIP_SERVER_DEBUG, "  lookup error in previous step\n");
    }
    else
    {
        js_p->error_code = -PVFS_ENOENT;
    }

    gossip_debug(GOSSIP_SERVER_DEBUG, "  sending '%s' response with %d "
                 "handle(s) and %d attr(s)\n",
                 (js_p->error_code ? "error" : "success"),
                 s_op->resp.u.lookup_path.handle_count,
                 s_op->resp.u.lookup_path.attr_count);

    /* end timer */
    PINT_perf_timer_end(PINT_server_tpc, PINT_PERF_TLOOKUP, &s_op->start_time);

    if (js_p->error_code == 0)
    {
        PINT_ACCESS_DEBUG(
            s_op, GOSSIP_ACCESS_DEBUG, "path: %s, handle: %llu\n", 
            s_op->req->u.lookup_path.path, 
            llu(s_op->resp.u.lookup_path.handle_array[
                s_op->resp.u.lookup_path.handle_count-1]));
    }
    else
    {
        PINT_ACCESS_DEBUG(
            s_op, GOSSIP_ACCESS_DEBUG, "path: %s, lookup failed\n", 
            s_op->req->u.lookup_path.path);
    }

    return SM_ACTION_COMPLETE;
}

/*
 * Function: lookup_cleanup
 *
 * Synopsis: Free memory allocated during request processing.
 *
 * There are a bunch of regions that must be freed after processing
 * completes:
 * - decoded request (s_op->decoded)
 * - encoded request (s_op->unexp_bmi_buff.buffer)
 * - encoded response (s_op->encoded)
 * - original (decoded) response (s_op->resp)
 * - dynamically allocated space (in this case 
 *   s_op->resp.u.lookup_path.handle_array)
 * - the server operation structure itself
 */
static PINT_sm_action lookup_cleanup(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    if (s_op->resp.u.lookup_path.handle_array)
    {
        free(s_op->resp.u.lookup_path.handle_array);
        s_op->resp.u.lookup_path.handle_array = NULL;
    }

    if (s_op->u.lookup.ds_attr_array)
    {
        free(s_op->u.lookup.ds_attr_array);
        s_op->u.lookup.ds_attr_array = NULL;
    }

    free(s_op->u.lookup.attr.dist_dir_bitmap);
    s_op->u.lookup.attr.dist_dir_bitmap = NULL;
    free(s_op->u.lookup.attr.dirdata_handles);
    s_op->u.lookup.attr.dirdata_handles = NULL;

    free(s_op->key_a);
    s_op->key_a = NULL;
    free(s_op->val_a);
    s_op->val_a = NULL;
    free(s_op->error_a);
    s_op->error_a = NULL;

    return(server_state_machine_complete(smcb));
}

static int perm_lookup(PINT_server_op *s_op)
{
    int ret;

    if (s_op->req->capability.op_mask & PINT_CAP_EXEC)
    {
        ret = 0;
    }
    else
    {
        ret = -PVFS_EACCES;
    }

    return ret;
}
PINT_GET_CREDENTIAL_DEFINE(lookup_path);
PINT_GET_OBJECT_REF_DEFINE(lookup_path);

struct PINT_server_req_params pvfs2_lookup_params = 
{
    .string_name = "lookup",
    .perm = perm_lookup,
/*    .access_type = PINT_server_req_readonly, */
    .sched_policy = PINT_SERVER_REQ_SCHEDULE,
    .get_credential = PINT_get_credential_lookup_path,
    .get_object_ref = PINT_get_object_ref_lookup_path,
    .state_machine = &pvfs2_lookup_sm
};


/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */
