/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will certainly be overwritten.
 */

/*
 * (C) 2010 Clemson University
 *
 * See COPYING in top-level directory.
 */

#include <assert.h>
#include <unistd.h>

#include "pvfs2-config.h"
#include "extent-utils.h"
#include "pint-cached-config.h" 
#include "pint-perf-counter.h"
#include "pint-util.h"
#include "pvfs2-attr.h"
#include "pvfs2-internal.h"
#include "pvfs2-req-proto.h"
#include "pvfs2-server.h"
#include "pvfs2-types.h"
#include "pvfs2-util.h"
#include "security-util.h"
#include "server-config.h"
#include "dist-dir-utils.h"
#ifdef ENABLE_SECURITY_CERT
#include "cert-util.h"
#endif

/*****
mgmt_create_root_dir.sm:
1. allocate dirdata handles for root directory.
2. create lost+found directory under the root directory.
*****/

enum
{
    NO_REQ = 100,
    LOCAL_OPERATION,
    REMOTE_OPERATION
};

static char *lost_and_found_string = "lost+found";
static int num_retries = 0;

static int mkdir_lost_and_found_comp_fn(
        void *v_p,
        struct PVFS_server_resp *resp_p,
        int index);
static int crdirent_lost_and_found_comp_fn(
        void *v_p,
        struct PVFS_server_resp *resp_p,
        int index);
static int delete_lost_and_found_handle_comp_fn(
        void *v_p,
        struct PVFS_server_resp *resp_p,
        int index);



static PINT_sm_action mgmt_create_root_dir_check_for_request(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_check_for_request;
static struct PINT_tran_tbl_s ST_check_for_request_trtbl[];

static PINT_sm_action mgmt_create_root_dir_create_dist_dir_struct(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_create_dist_dir_struct;
static struct PINT_tran_tbl_s ST_create_dist_dir_struct_trtbl[];

static PINT_sm_action mgmt_create_root_dir_request_remote_dirdata_dspace(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_request_remote_dirdata_dspace;
static struct PINT_tran_tbl_s ST_request_remote_dirdata_dspace_trtbl[];

static PINT_sm_action mgmt_create_root_dir_retry_remote_dirdata_dspace(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_retry_remote_dirdata_dspace;
static struct PINT_tran_tbl_s ST_retry_remote_dirdata_dspace_trtbl[];

static PINT_sm_action mgmt_create_root_dir_create_local_dirdata_dspace(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_create_local_dirdata_dspace;
static struct PINT_tran_tbl_s ST_create_local_dirdata_dspace_trtbl[];

static PINT_sm_action mgmt_create_root_dir_fill_handles_to_dist_dir_struct(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_fill_handles_to_dist_dir_struct;
static struct PINT_tran_tbl_s ST_fill_handles_to_dist_dir_struct_trtbl[];

static PINT_sm_action mgmt_create_root_dir_dirdata_attr_and_keyval_setup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_dirdata_attr_and_keyval_setup;
static struct PINT_tran_tbl_s ST_dirdata_attr_and_keyval_setup_trtbl[];
static struct PINT_state_s ST_run_tree_setattr;
static struct PINT_tran_tbl_s ST_run_tree_setattr_trtbl[];

static PINT_sm_action mgmt_create_root_dir_tree_setattr_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_tree_setattr_cleanup;
static struct PINT_tran_tbl_s ST_tree_setattr_cleanup_trtbl[];

static PINT_sm_action mgmt_create_root_dir_write_keyval_to_meta_handle(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_write_keyval_to_meta_handle;
static struct PINT_tran_tbl_s ST_write_keyval_to_meta_handle_trtbl[];

static PINT_sm_action mgmt_create_root_dir_write_keyval_to_dirdata_handle(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_write_keyval_to_dirdata_handle;
static struct PINT_tran_tbl_s ST_write_keyval_to_dirdata_handle_trtbl[];

static PINT_sm_action mgmt_create_root_dir_mkdir_lost_and_found_setup_msgpair(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_mkdir_lost_and_found_setup_msgpair;
static struct PINT_tran_tbl_s ST_mkdir_lost_and_found_setup_msgpair_trtbl[];
static struct PINT_state_s ST_mkdir_lost_and_found_msg_xfer_msgpair;
static struct PINT_tran_tbl_s ST_mkdir_lost_and_found_msg_xfer_msgpair_trtbl[];
static struct PINT_state_s ST_local_mkdir;
static struct PINT_tran_tbl_s ST_local_mkdir_trtbl[];

static PINT_sm_action mgmt_create_root_dir_local_mkdir_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_local_mkdir_cleanup;
static struct PINT_tran_tbl_s ST_local_mkdir_cleanup_trtbl[];

static PINT_sm_action crdirent_lost_and_found_setup_msgpair(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_crdirent_lost_and_found_setup_msgpair;
static struct PINT_tran_tbl_s ST_crdirent_lost_and_found_setup_msgpair_trtbl[];
static struct PINT_state_s ST_crdirent_lost_and_found_xfer_msgpair;
static struct PINT_tran_tbl_s ST_crdirent_lost_and_found_xfer_msgpair_trtbl[];
static struct PINT_state_s ST_local_crdirent;
static struct PINT_tran_tbl_s ST_local_crdirent_trtbl[];

static PINT_sm_action mgmt_create_root_dir_local_crdirent_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_local_crdirent_cleanup;
static struct PINT_tran_tbl_s ST_local_crdirent_cleanup_trtbl[];

static PINT_sm_action delete_lost_and_found_handle_setup_msgpair(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_delete_lost_and_found_handle_setup_msgpair;
static struct PINT_tran_tbl_s ST_delete_lost_and_found_handle_setup_msgpair_trtbl[];
static struct PINT_state_s ST_delete_lost_and_found_handle_xfer_msgpair;
static struct PINT_tran_tbl_s ST_delete_lost_and_found_handle_xfer_msgpair_trtbl[];
static struct PINT_state_s ST_local_delete;
static struct PINT_tran_tbl_s ST_local_delete_trtbl[];

static PINT_sm_action mgmt_create_root_dir_local_delete_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_local_delete_cleanup;
static struct PINT_tran_tbl_s ST_local_delete_cleanup_trtbl[];

static PINT_sm_action mgmt_create_root_dir_cleanup_noreq(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_cleanup_noreq;
static struct PINT_tran_tbl_s ST_cleanup_noreq_trtbl[];

struct PINT_state_machine_s pvfs2_mgmt_create_root_dir_sm = {
	.name = "pvfs2_mgmt_create_root_dir_sm",
	.first_state = &ST_check_for_request
};

static struct PINT_state_s ST_check_for_request = {
	 .state_name = "check_for_request" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_root_dir_check_for_request ,
	 .pjtbl = NULL ,
	 .trtbl = ST_check_for_request_trtbl 
};

static struct PINT_tran_tbl_s ST_check_for_request_trtbl[] = {
	{ .return_value = NO_REQ ,
	 .next_state = &ST_create_dist_dir_struct },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_create_dist_dir_struct = {
	 .state_name = "create_dist_dir_struct" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_root_dir_create_dist_dir_struct ,
	 .pjtbl = NULL ,
	 .trtbl = ST_create_dist_dir_struct_trtbl 
};

static struct PINT_tran_tbl_s ST_create_dist_dir_struct_trtbl[] = {
	{ .return_value = REMOTE_OPERATION ,
	 .next_state = &ST_request_remote_dirdata_dspace },
	{ .return_value = 0 ,
	 .next_state = &ST_create_local_dirdata_dspace },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_request_remote_dirdata_dspace = {
	 .state_name = "request_remote_dirdata_dspace" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_root_dir_request_remote_dirdata_dspace ,
	 .pjtbl = NULL ,
	 .trtbl = ST_request_remote_dirdata_dspace_trtbl 
};

static struct PINT_tran_tbl_s ST_request_remote_dirdata_dspace_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_create_local_dirdata_dspace },
	{ .return_value = -1 ,
	 .next_state = &ST_retry_remote_dirdata_dspace }
};

static struct PINT_state_s ST_retry_remote_dirdata_dspace = {
	 .state_name = "retry_remote_dirdata_dspace" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_root_dir_retry_remote_dirdata_dspace ,
	 .pjtbl = NULL ,
	 .trtbl = ST_retry_remote_dirdata_dspace_trtbl 
};

static struct PINT_tran_tbl_s ST_retry_remote_dirdata_dspace_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_request_remote_dirdata_dspace }
};

static struct PINT_state_s ST_create_local_dirdata_dspace = {
	 .state_name = "create_local_dirdata_dspace" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_root_dir_create_local_dirdata_dspace ,
	 .pjtbl = NULL ,
	 .trtbl = ST_create_local_dirdata_dspace_trtbl 
};

static struct PINT_tran_tbl_s ST_create_local_dirdata_dspace_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_fill_handles_to_dist_dir_struct },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_fill_handles_to_dist_dir_struct = {
	 .state_name = "fill_handles_to_dist_dir_struct" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_root_dir_fill_handles_to_dist_dir_struct ,
	 .pjtbl = NULL ,
	 .trtbl = ST_fill_handles_to_dist_dir_struct_trtbl 
};

static struct PINT_tran_tbl_s ST_fill_handles_to_dist_dir_struct_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_dirdata_attr_and_keyval_setup },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_dirdata_attr_and_keyval_setup = {
	 .state_name = "dirdata_attr_and_keyval_setup" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_root_dir_dirdata_attr_and_keyval_setup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_dirdata_attr_and_keyval_setup_trtbl 
};

static struct PINT_tran_tbl_s ST_dirdata_attr_and_keyval_setup_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_run_tree_setattr },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_run_tree_setattr = {
	 .state_name = "run_tree_setattr" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_tree_setattr_work_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_run_tree_setattr_trtbl 
};

static struct PINT_tran_tbl_s ST_run_tree_setattr_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_tree_setattr_cleanup }
};

static struct PINT_state_s ST_tree_setattr_cleanup = {
	 .state_name = "tree_setattr_cleanup" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_root_dir_tree_setattr_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_tree_setattr_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_tree_setattr_cleanup_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_write_keyval_to_meta_handle },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_write_keyval_to_meta_handle = {
	 .state_name = "write_keyval_to_meta_handle" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_root_dir_write_keyval_to_meta_handle ,
	 .pjtbl = NULL ,
	 .trtbl = ST_write_keyval_to_meta_handle_trtbl 
};

static struct PINT_tran_tbl_s ST_write_keyval_to_meta_handle_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_write_keyval_to_dirdata_handle },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_write_keyval_to_dirdata_handle = {
	 .state_name = "write_keyval_to_dirdata_handle" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_root_dir_write_keyval_to_dirdata_handle ,
	 .pjtbl = NULL ,
	 .trtbl = ST_write_keyval_to_dirdata_handle_trtbl 
};

static struct PINT_tran_tbl_s ST_write_keyval_to_dirdata_handle_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_mkdir_lost_and_found_setup_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_mkdir_lost_and_found_setup_msgpair = {
	 .state_name = "mkdir_lost_and_found_setup_msgpair" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_root_dir_mkdir_lost_and_found_setup_msgpair ,
	 .pjtbl = NULL ,
	 .trtbl = ST_mkdir_lost_and_found_setup_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_mkdir_lost_and_found_setup_msgpair_trtbl[] = {
	{ .return_value = REMOTE_OPERATION ,
	 .next_state = &ST_mkdir_lost_and_found_msg_xfer_msgpair },
	{ .return_value = LOCAL_OPERATION ,
	 .next_state = &ST_local_mkdir },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_mkdir_lost_and_found_msg_xfer_msgpair = {
	 .state_name = "mkdir_lost_and_found_msg_xfer_msgpair" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_msgpairarray_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_mkdir_lost_and_found_msg_xfer_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_mkdir_lost_and_found_msg_xfer_msgpair_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_crdirent_lost_and_found_setup_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_local_mkdir = {
	 .state_name = "local_mkdir" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_mkdir_work_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_local_mkdir_trtbl 
};

static struct PINT_tran_tbl_s ST_local_mkdir_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_local_mkdir_cleanup },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_local_mkdir_cleanup = {
	 .state_name = "local_mkdir_cleanup" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_root_dir_local_mkdir_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_local_mkdir_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_local_mkdir_cleanup_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_crdirent_lost_and_found_setup_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_crdirent_lost_and_found_setup_msgpair = {
	 .state_name = "crdirent_lost_and_found_setup_msgpair" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = crdirent_lost_and_found_setup_msgpair ,
	 .pjtbl = NULL ,
	 .trtbl = ST_crdirent_lost_and_found_setup_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_crdirent_lost_and_found_setup_msgpair_trtbl[] = {
	{ .return_value = REMOTE_OPERATION ,
	 .next_state = &ST_crdirent_lost_and_found_xfer_msgpair },
	{ .return_value = LOCAL_OPERATION ,
	 .next_state = &ST_local_crdirent },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_crdirent_lost_and_found_xfer_msgpair = {
	 .state_name = "crdirent_lost_and_found_xfer_msgpair" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_msgpairarray_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_crdirent_lost_and_found_xfer_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_crdirent_lost_and_found_xfer_msgpair_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_cleanup_noreq },
	{ .return_value = -1 ,
	 .next_state = &ST_delete_lost_and_found_handle_setup_msgpair }
};

static struct PINT_state_s ST_local_crdirent = {
	 .state_name = "local_crdirent" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_crdirent_work_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_local_crdirent_trtbl 
};

static struct PINT_tran_tbl_s ST_local_crdirent_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_local_crdirent_cleanup },
	{ .return_value = -1 ,
	 .next_state = &ST_delete_lost_and_found_handle_setup_msgpair }
};

static struct PINT_state_s ST_local_crdirent_cleanup = {
	 .state_name = "local_crdirent_cleanup" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_root_dir_local_crdirent_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_local_crdirent_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_local_crdirent_cleanup_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_delete_lost_and_found_handle_setup_msgpair = {
	 .state_name = "delete_lost_and_found_handle_setup_msgpair" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = delete_lost_and_found_handle_setup_msgpair ,
	 .pjtbl = NULL ,
	 .trtbl = ST_delete_lost_and_found_handle_setup_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_delete_lost_and_found_handle_setup_msgpair_trtbl[] = {
	{ .return_value = REMOTE_OPERATION ,
	 .next_state = &ST_delete_lost_and_found_handle_xfer_msgpair },
	{ .return_value = LOCAL_OPERATION ,
	 .next_state = &ST_local_delete },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_delete_lost_and_found_handle_xfer_msgpair = {
	 .state_name = "delete_lost_and_found_handle_xfer_msgpair" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_msgpairarray_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_delete_lost_and_found_handle_xfer_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_delete_lost_and_found_handle_xfer_msgpair_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_local_delete = {
	 .state_name = "local_delete" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_remove_work_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_local_delete_trtbl 
};

static struct PINT_tran_tbl_s ST_local_delete_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_local_delete_cleanup },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_local_delete_cleanup = {
	 .state_name = "local_delete_cleanup" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_root_dir_local_delete_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_local_delete_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_local_delete_cleanup_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup_noreq }
};

static struct PINT_state_s ST_cleanup_noreq = {
	 .state_name = "cleanup_noreq" ,
	 .parent_machine = &pvfs2_mgmt_create_root_dir_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_create_root_dir_cleanup_noreq ,
	 .pjtbl = NULL ,
	 .trtbl = ST_cleanup_noreq_trtbl 
};

static struct PINT_tran_tbl_s ST_cleanup_noreq_trtbl[] = {
	{ .return_value = -1 ,

	 .flag = SM_TERM }
};

#ifndef WIN32
# 228 "src/server/mgmt-create-root-dir.sm"
#endif


/*
 * Function: mgmt_create_root_dir_check_for_request
 * Params:   server_op *b,
 *           job_status_s *js_p
 *
 * Returns:  int
 *
 * Synopsis: Check if this state machine came about from a request or 
 *           from a noreq() state machine (on server startup).
 */
static PINT_sm_action mgmt_create_root_dir_check_for_request( 
    struct PINT_smcb *smcb, 
    job_status_s *js_p)
{

    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    server_configuration_s *user_opts = PINT_server_config_mgr_get_config();
#ifdef ENABLE_SECURITY_CERT
    X509 *xcert = NULL;
    PVFS_certificate *cert = NULL;
    int ret = -1;
#endif

    assert(s_op);

    if( s_op->req == NULL )
    {
        js_p->error_code = NO_REQ;
    }
    else
    {
        gossip_debug(GOSSIP_SERVER_DEBUG, "mgmt_create_root_dir: can only be called noreq, not doing anything!!\n");
        js_p->error_code = 0;
    }

    /* Create credential that will be used for requests. */
    PINT_init_credential(&s_op->u.mgmt_create_root_dir.credential);
    s_op->u.mgmt_create_root_dir.credential.userid = 0;
    s_op->u.mgmt_create_root_dir.credential.num_groups = 1;
    s_op->u.mgmt_create_root_dir.credential.group_array =
            malloc(sizeof(PVFS_gid));
    s_op->u.mgmt_create_root_dir.credential.group_array[0] = 0;
    s_op->u.mgmt_create_root_dir.credential.issuer = 
            malloc(strlen(user_opts->server_alias) + 3);
    s_op->u.mgmt_create_root_dir.credential.issuer[0] = 'S';
    s_op->u.mgmt_create_root_dir.credential.issuer[1] = ':';
    strcpy(s_op->u.mgmt_create_root_dir.credential.issuer+2,
             user_opts->server_alias);
    s_op->u.mgmt_create_root_dir.credential.timeout =
            PINT_util_get_current_time() + user_opts->credential_timeout;

#ifdef ENABLE_SECURITY_CERT
    /* use CA certificate as cert in credential */
    ret = PINT_load_cert_from_file(user_opts->ca_file, &xcert);
    if (ret != 0)
    {
        gossip_err("mgmt_create_root_dir: could not load CA "
                     "certificate: %d\n", ret);

        js_p->error_code = -PVFS_EACCES;
        return SM_ACTION_COMPLETE;
    }

    ret = PINT_X509_to_cert(xcert, &cert);
    if (ret != 0)
    {
        PINT_security_error(__func__, ret);
        js_p->error_code = -PVFS_EACCES;
        X509_free(xcert);
        return SM_ACTION_COMPLETE;
    }

    ret = PINT_copy_cert(cert, 
                         &s_op->u.mgmt_create_root_dir.credential.certificate);
    if (ret != 0)
    {
        gossip_err("mgmt_create_root_dir: could not copy certificate\n");
        js_p->error_code = -PVFS_EACCES;
        PINT_cleanup_cert(cert);
        free(cert);
        X509_free(xcert);
        return SM_ACTION_COMPLETE;
    }

    PINT_cleanup_cert(cert);
    free(cert);
    X509_free(xcert);
#endif

    PINT_sign_credential(&s_op->u.mgmt_create_root_dir.credential);

    return SM_ACTION_COMPLETE;
}


/* init dist_dir_struct in s_op->attr.u.dir and 
 * s_op->u.mgmt_create_root_dir */
static PINT_sm_action mgmt_create_root_dir_create_dist_dir_struct(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    server_configuration_s *user_opts = PINT_server_config_mgr_get_config();
    PVFS_object_attr *attr;
    int num_total_dirdata_servers, num_initial_dirdata_servers;
    int ret = -1;
    unsigned char *c;
    int i;

    js_p->error_code = 0;
    attr = (&s_op->attr);

    /* Find total # of meta servers */
    ret = PINT_cached_config_get_num_meta(s_op->target_fs_id,
                                          &num_total_dirdata_servers);
    if(ret < 0)
    {
        gossip_err("Error: failed to get number of metadata servers\n");
        js_p->error_code = ret;
        return SM_ACTION_COMPLETE;
    }

    /* Honor max # of dirdata servers from config file */
    if (user_opts->distr_dir_servers_max < num_total_dirdata_servers)
    {
        num_total_dirdata_servers = user_opts->distr_dir_servers_max;
    }

    /* set num_dirdata_servers for pre-allocation of dirdata handles */
    s_op->u.mgmt_create_root_dir.num_dirdata_servers =
                    num_total_dirdata_servers;

    /* for root dir, use all dirdata servers */
    num_initial_dirdata_servers = num_total_dirdata_servers;

    /* init meta handle dist_dir_struct */
    ret = PINT_init_dist_dir_state(
                    &attr->dist_dir_attr,
                    &attr->dist_dir_bitmap,
                    num_total_dirdata_servers,
                    0,
                    num_initial_dirdata_servers,
                    100);

    assert(ret == 0);
    /* Need to set mask so we will free dist dir attrs when cleaning up. */
    attr->mask |= PVFS_ATTR_DISTDIR_ATTR;

    gossip_debug(GOSSIP_SERVER_DEBUG, 
            "mgmt-create-root-dir: Init dist-dir-attr for dir meta handle %llu "
            "with tree_height=%d, num_servers=%d, bitmap_size=%d, "
            "split_size=%d, server_no=%d and branch_level=%d\n",
            llu(s_op->target_handle),
            attr->dist_dir_attr.tree_height,
            attr->dist_dir_attr.num_servers,
            attr->dist_dir_attr.bitmap_size,
            attr->dist_dir_attr.split_size,
            attr->dist_dir_attr.server_no,
            attr->dist_dir_attr.branch_level);

    /* gossip bitmap, may adjust later */
    gossip_debug(GOSSIP_SERVER_DEBUG,
            "mgmt-create-root-dir: Init dist_dir_bitmap as:\n");
    for(i = attr->dist_dir_attr.bitmap_size - 1;
            i >= 0 ; i--)
    {
        c = (unsigned char *)(attr->dist_dir_bitmap + i);
        gossip_debug(GOSSIP_SERVER_DEBUG,
                " i=%d : %02x %02x %02x %02x\n",
                i, c[3], c[2], c[1], c[0]);
    }
    gossip_debug(GOSSIP_SERVER_DEBUG, "\n");

    /* allocate dirdata handle space, similar to create.sm */
    attr->dirdata_handles = malloc(
            sizeof(*attr->dirdata_handles) *
            num_total_dirdata_servers);
    s_op->u.mgmt_create_root_dir.handle_array_local = malloc(
            sizeof(*s_op->u.mgmt_create_root_dir.handle_array_local) *
            num_total_dirdata_servers);
    s_op->u.mgmt_create_root_dir.handle_array_remote = malloc(
            sizeof(*s_op->u.mgmt_create_root_dir.handle_array_remote) *
            num_total_dirdata_servers);

    if(!attr->dirdata_handles ||
            !s_op->u.mgmt_create_root_dir.handle_array_local ||
            !s_op->u.mgmt_create_root_dir.handle_array_remote )
    {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }

    /* dirdata on every meta server */
    s_op->u.mgmt_create_root_dir.handle_array_local_count = 1;
    s_op->u.mgmt_create_root_dir.handle_array_remote_count = 
            s_op->u.mgmt_create_root_dir.num_dirdata_servers - 1;
    if (s_op->u.mgmt_create_root_dir.handle_array_remote_count > 0)
    {
        js_p->error_code = REMOTE_OPERATION;
    }

    gossip_debug(GOSSIP_SERVER_DEBUG, "creating %d local dirdata files\n", 
        s_op->u.mgmt_create_root_dir.handle_array_local_count);
    gossip_debug(GOSSIP_SERVER_DEBUG, "creating %d remote dirdata files\n", 
        s_op->u.mgmt_create_root_dir.handle_array_remote_count);

    return SM_ACTION_COMPLETE; 
}

static PINT_sm_action mgmt_create_root_dir_retry_remote_dirdata_dspace(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    job_id_t tmp_id;

    if (++num_retries > 3)
    {
        gossip_err("Unable to create root directory."
                   " Please ensure that all configured servers are running."
                   " Will continue to retry...\n");
        num_retries = 0;
    }
    else
    {
        gossip_debug(GOSSIP_SERVER_DEBUG,
             "Unable to obtain remote handles for root directory.\n");
    }

    gossip_debug(GOSSIP_SERVER_DEBUG,
        "Sleeping for 30 seconds before retrying.\n");

    return(job_req_sched_post_timer((30*1000),
                                    smcb,
                                    0,
                                    js_p,
                                    &tmp_id,
                                    server_job_context));
}

static PINT_sm_action mgmt_create_root_dir_request_remote_dirdata_dspace(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -1;
    job_id_t j_id;

    if(s_op->u.mgmt_create_root_dir.handle_array_remote_count == 0)
    {
        js_p->error_code = 0;
        return(SM_ACTION_COMPLETE);
    }

    ret = job_precreate_pool_get_handles(
            s_op->target_fs_id,
            s_op->u.mgmt_create_root_dir.handle_array_remote_count,
            PVFS_TYPE_DIRDATA,
            NULL, /* server string set to NULL for now */
            s_op->u.mgmt_create_root_dir.handle_array_remote,
            0,
            smcb,
            0,
            js_p,
            &j_id,
            server_job_context,
            NULL);

    return ret;

}

static PINT_sm_action mgmt_create_root_dir_create_local_dirdata_dspace(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PVFS_object_attr *attr GCC_UNUSED;
    int ret = -PVFS_ENOMEM;
    job_id_t tmp_id;
    PVFS_handle_extent_array extent_array;
    server_configuration_s *user_opts = PINT_server_config_mgr_get_config();

    attr = (&s_op->attr);

    assert(s_op->u.mgmt_create_root_dir.num_dirdata_servers > 0);


    if(s_op->u.mgmt_create_root_dir.handle_array_local_count == 0)
    {
        /* no local work to do */
        js_p->error_code = 0;
        return(SM_ACTION_COMPLETE);
    }

    ret = PINT_config_get_meta_handle_extent_array(user_opts,
                                                   s_op->target_fs_id,
                                                   &extent_array);
    assert(ret == 0);
    assert(extent_array.extent_count > 0);

    gossip_debug(GOSSIP_SERVER_DEBUG, " local dirdata handle(s) will "
                 "be in starting hrange[0] %llu-%llu\n",
                 llu(extent_array.extent_array[0].first),
                 llu(extent_array.extent_array[0].last));

    ret = job_trove_dspace_create_list(
            s_op->target_fs_id,
            &extent_array,
            s_op->u.mgmt_create_root_dir.handle_array_local,
            s_op->u.mgmt_create_root_dir.handle_array_local_count,
            PVFS_TYPE_DIRDATA, 
            NULL,
            TROVE_SYNC,
            smcb,
            0,
            js_p,
            &tmp_id,
            server_job_context, 
            NULL);

    free(extent_array.extent_array);

    return(ret);
}



static PINT_sm_action mgmt_create_root_dir_fill_handles_to_dist_dir_struct(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PVFS_object_attr *attr;
    int i;
    int ret;
    int num_handles;
    PVFS_handle *handle_array = NULL;

    attr = &s_op->attr;

    gossip_debug(
        GOSSIP_SERVER_DEBUG, "  local dirdata handle (%llu)\n",
        llu(s_op->u.mgmt_create_root_dir.handle_array_local[0]));

    /* fill dirdata_handles array */
    attr->dirdata_handles[0] =
            s_op->u.mgmt_create_root_dir.handle_array_local[0];

    for(i = 0; i < s_op->u.mgmt_create_root_dir.handle_array_remote_count; i++)
    {
        attr->dirdata_handles[i+1] =
                s_op->u.mgmt_create_root_dir.handle_array_remote[i];
    }

    /* create a capability for the new dirdata's handles */

    /* Update capability to send with request. */
    /* first, free the one we have already been using */

    PINT_cleanup_capability(&s_op->u.mgmt_create_root_dir.capability);
        
    /* create new handle array with target handle and dirdata
     * handles */

    num_handles = s_op->attr.dist_dir_attr.num_servers + 1;
    handle_array = (PVFS_handle *) malloc(num_handles * sizeof(PVFS_handle));
    if (handle_array == NULL)
    {
        gossip_err("mgmt-create-root-dir: out of memory in %s\n", __func__);   
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }                   
    handle_array[0] = s_op->target_handle;
    memcpy((handle_array + 1),
           s_op->attr.dirdata_handles,
           s_op->attr.dist_dir_attr.num_servers * sizeof(PVFS_handle));
        
    /* create new capability -- note that handle_array will be
     * freed by PINT_cleanup_capability when the SM completes */

    ret = PINT_server_to_server_capability(
                             &s_op->u.mgmt_create_root_dir.capability,
                             s_op->target_fs_id,
                             num_handles,
                             handle_array);
    if (ret != 0)
    {
        gossip_err("mgmt-create-root-dir: unable to retrieve server-to-server "
                       "capability in %s\n", __func__);
        js_p->error_code = -PVFS_EACCES;
        return SM_ACTION_COMPLETE;
    }

    gossip_debug(GOSSIP_SERVER_DEBUG, 
    "\t mgmt-create-root-dir: dirdata handles array of root directory %llu.\n",
            llu(s_op->target_handle));

    for(i = 0; i < s_op->u.mgmt_create_root_dir.num_dirdata_servers; i++)
    {
        gossip_debug(GOSSIP_SERVER_DEBUG, 
                "\t\tdirdata server %d: %llu.\n",
                i, llu(attr->dirdata_handles[i]));
    }

    return SM_ACTION_COMPLETE;
}

static PINT_sm_action mgmt_create_root_dir_dirdata_attr_and_keyval_setup(
                      struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    struct PINT_server_op *tree_setattr_op = NULL;
    struct PVFS_server_req *tree_setattr_req = NULL;
    PVFS_object_attr attr;

    gossip_debug(GOSSIP_SERVER_DEBUG, "s_op->attr.objtype = %d\n", s_op->attr.objtype);

    /* set dirdata attr, set all the static component */
    memset(&attr, 0, sizeof(PVFS_object_attr));
    attr.owner = getuid();
    attr.group = getgid();
    attr.perms = 0777;
    attr.objtype = PVFS_TYPE_DIRDATA;
    PINT_dist_dir_attr_copyto(attr.dist_dir_attr,
                              s_op->attr.dist_dir_attr);
    attr.dirdata_handles = s_op->attr.dirdata_handles;
    attr.dist_dir_bitmap = s_op->attr.dist_dir_bitmap;
    attr.mask = PVFS_ATTR_COMMON_ALL;
    attr.mask |= PVFS_ATTR_DISTDIR_ATTR;

    gossip_debug(
        GOSSIP_SERVER_DEBUG,
        "  SENDING attrs: [owner = %d, group = %d\n\t"
        "perms = %o, type = %d, atime = %llu, mtime = %llu\n\t"
        "ctime = %llu ]\n",
        attr.owner, attr.group, attr.perms,
        attr.objtype, llu(attr.atime),
        llu(PINT_util_mkversion_time(attr.mtime)), llu(attr.ctime));

    tree_setattr_req = malloc(sizeof(struct PVFS_server_req));
    if (! tree_setattr_req) 
    {
        gossip_err("Unable to allocate tree_setattr_req\n");
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }   
    memset(tree_setattr_req, 0, sizeof(*tree_setattr_req));

    PINT_SERVREQ_TREE_SETATTR_FILL(
            *tree_setattr_req,
            s_op->u.mgmt_create_root_dir.capability,
            s_op->u.mgmt_create_root_dir.credential,
            s_op->target_fs_id,
            PVFS_TYPE_DIRDATA,
            attr,
            0,
            s_op->attr.dist_dir_attr.num_servers,
            s_op->attr.dirdata_handles,
            NULL);

    tree_setattr_op = malloc(sizeof(struct PINT_server_op));
    if (! tree_setattr_op)
    {
        gossip_err("Unable to allocate tree_setattr_op\n");
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }
    memset(tree_setattr_op, 0, sizeof(*tree_setattr_op));
    tree_setattr_op->req = tree_setattr_req;
    tree_setattr_op->op = PVFS_SERV_TREE_SETATTR;

    PINT_sm_push_frame(smcb, 0, tree_setattr_op);
    js_p->error_code = 0;
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action mgmt_create_root_dir_tree_setattr_cleanup(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *tree_setattr_op = NULL;
    int task_id = 0;
    int remaining = 0;
    tree_setattr_op = PINT_sm_pop_frame(smcb,
                                        &task_id,
                                        &js_p->error_code,
                                        &remaining);

    PINT_free_object_attr(&tree_setattr_op->req->u.tree_setattr.attr);
    free(tree_setattr_op->req);
    free(tree_setattr_op);

    return SM_ACTION_COMPLETE;
}

static PINT_sm_action mgmt_create_root_dir_write_keyval_to_meta_handle(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PVFS_object_attr *attr;
    int ret = -1;
    job_id_t j_id;

    /* total 3 keyvals,
     * PVFS_DIST_DIR_ATTR,
     * PVFS_DIRDATA_BITMAP,
     * PVFS_DIRDATA_HANDLES */
    int keyval_count = 3;

    /* !!!! this is to set meta handle keyval,
     * use dist_dir_attr in s_op->attr 
     */
    attr = &s_op->attr;

    s_op->key_a = malloc(sizeof(PVFS_ds_keyval) * keyval_count);
    if(!s_op->key_a)
    {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }

    s_op->val_a = malloc(sizeof(PVFS_ds_keyval) * keyval_count);
    if(!s_op->val_a)
    {
        free(s_op->key_a);
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }
    memset(s_op->val_a, 0, sizeof(PVFS_ds_keyval) * keyval_count);

    s_op->key_a[0].buffer = Trove_Common_Keys[DIST_DIR_ATTR_KEY].key;
    s_op->key_a[0].buffer_sz = Trove_Common_Keys[DIST_DIR_ATTR_KEY].size;

    s_op->val_a[0].buffer = &attr->dist_dir_attr;
    s_op->val_a[0].buffer_sz = sizeof(attr->dist_dir_attr);

    s_op->key_a[1].buffer = Trove_Common_Keys[DIST_DIRDATA_BITMAP_KEY].key;
    s_op->key_a[1].buffer_sz = Trove_Common_Keys[DIST_DIRDATA_BITMAP_KEY].size;

    s_op->val_a[1].buffer_sz = attr->dist_dir_attr.bitmap_size * 
                               sizeof(PVFS_dist_dir_bitmap_basetype);
    s_op->val_a[1].buffer = attr->dist_dir_bitmap;

    s_op->key_a[2].buffer = Trove_Common_Keys[DIST_DIRDATA_HANDLES_KEY].key;
    s_op->key_a[2].buffer_sz = Trove_Common_Keys[DIST_DIRDATA_HANDLES_KEY].size;

    s_op->val_a[2].buffer = attr->dirdata_handles;
    s_op->val_a[2].buffer_sz = attr->dist_dir_attr.num_servers * 
                                     sizeof(*attr->dirdata_handles);

    gossip_debug(GOSSIP_SERVER_DEBUG, 
            "  writing dist-dir-struct keyvals for meta handle: %llu "
            "\t with server_no=%d and branch_level=%d \n", 
            llu(s_op->target_handle),
            attr->dist_dir_attr.server_no,
            attr->dist_dir_attr.branch_level);


    ret = job_trove_keyval_write_list(s_op->target_fs_id,
                                      s_op->target_handle, /* meta handle */
                                      s_op->key_a,
                                      s_op->val_a,
                                      keyval_count,
                                      TROVE_SYNC,
                                      NULL,
                                      smcb,
                                      0,
                                      js_p,
                                      &j_id,
                                      server_job_context,
                                      NULL);

    return ret;
}

static PINT_sm_action mgmt_create_root_dir_write_keyval_to_dirdata_handle(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PVFS_object_attr *attr;
    int ret = -1;
    job_id_t j_id;
    int keyval_count = 3;

    attr = &s_op->attr;

    gossip_debug(GOSSIP_SERVER_DEBUG, 
            "  writing dist-dir-struct keyvals for dirdata handle: %llu "
            "\t with server_no=%d and branch_level=%d \n", 
            llu(s_op->attr.dirdata_handles[0]),
            attr->dist_dir_attr.server_no,
            attr->dist_dir_attr.branch_level);


    ret = job_trove_keyval_write_list(
            s_op->target_fs_id,
            s_op->attr.dirdata_handles[0], /* dirdata handle */
            s_op->key_a,
            s_op->val_a,
            keyval_count,
            TROVE_SYNC,
            NULL,
            smcb,
            0,
            js_p,
            &j_id,
            server_job_context,
            NULL);

    return ret;
}

/*
 * This function sets up a create for the lost+found directory, either
 * local or remote
 */
static PINT_sm_action mgmt_create_root_dir_mkdir_lost_and_found_setup_msgpair(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PVFS_object_attr attr;
    PVFS_sys_layout layout;
    int ret = -PVFS_EINVAL;
    PVFS_handle_extent_array meta_handle_extent_array;
    server_configuration_s *config = PINT_server_config_mgr_get_config();
    char server_name[1024];
    PVFS_BMI_addr_t svr_addr;

    js_p->error_code = 0;

    /* I think we can eliminate the sys_attr and just set values
     * directly in the attr.  A sys_attr is really only for users
     * an object_attr is the real one we use internally.
     */

    memset(&attr, 0, sizeof(attr));
    attr.owner = getuid();
    attr.group = getgid();
    attr.perms = 0777;
    attr.mask = (PVFS_ATTR_COMMON_ALL);
    attr.objtype = PVFS_TYPE_DIRECTORY;

    memset(&layout, 0, sizeof(layout));
    layout.algorithm = PVFS_SYS_LAYOUT_ROUND_ROBIN;

    gossip_debug(GOSSIP_SERVER_DEBUG," mgmt_create_root_dir: posting mkdir req for lost+found dir.\n ");

    ret = PINT_cached_config_get_next_meta(s_op->target_fs_id,
                                           &svr_addr,
                                           &meta_handle_extent_array);

    if (ret)
    {
        gossip_err("Failed to map meta server address\n");
        js_p->error_code = ret;
        return SM_ACTION_COMPLETE;
    }

    PINT_cached_config_get_server_name(
                             server_name,
                             1024,
                             meta_handle_extent_array.extent_array[0].first,
                             s_op->target_fs_id);

    if (! strcmp(server_name, config->host_id))
    {   
        /* local */
        struct PVFS_server_req *mkdir_req = NULL;
        struct PINT_server_op *mkdir_op = NULL;

        mkdir_req = malloc(sizeof(struct PVFS_server_req));
        if (! mkdir_req)
        {
            gossip_err("Unable to allocate mkdir_req\n");
            js_p->error_code = -PVFS_ENOMEM;
            return SM_ACTION_COMPLETE;
        }
        memset(mkdir_req, 0, sizeof(*mkdir_req));

        PINT_SERVREQ_MKDIR_FILL(
                    *mkdir_req,
                    s_op->u.mgmt_create_root_dir.capability,
                    s_op->u.mgmt_create_root_dir.credential,
                    s_op->target_fs_id,
                    meta_handle_extent_array,
                    attr,
                    s_op->attr.dist_dir_attr.num_servers,
                    s_op->attr.dist_dir_attr.num_servers,
                    s_op->attr.dist_dir_attr.split_size,
                    layout,
                    NULL);

        mkdir_op = malloc(sizeof(struct PINT_server_op));
        if (! mkdir_op)
        {
            gossip_err("Unable to allocate mkdir_op\n");
            js_p->error_code = -PVFS_ENOMEM;
            return SM_ACTION_COMPLETE;
        }
        memset(mkdir_op, 0, sizeof(*mkdir_op));
        mkdir_op->req = mkdir_req;
        mkdir_op->op = PVFS_SERV_MKDIR;
        mkdir_op->addr = svr_addr;

        PINT_sm_push_frame(smcb, LOCAL_OPERATION, mkdir_op);
        js_p->error_code = LOCAL_OPERATION;
    }
    else
    {   
        /* remote */
        PINT_sm_msgpair_state *msg_p = NULL;

        PINT_msgpair_init(&s_op->msgarray_op);
        msg_p = &s_op->msgarray_op.msgpair;
        PINT_serv_init_msgarray_params(s_op, s_op->target_fs_id);

        PINT_SERVREQ_MKDIR_FILL(
                    msg_p->req,
                    s_op->u.mgmt_create_root_dir.capability,
                    s_op->u.mgmt_create_root_dir.credential,
                    s_op->target_fs_id,
                    meta_handle_extent_array,
                    attr,
                    s_op->attr.dist_dir_attr.num_servers,
                    s_op->attr.dist_dir_attr.num_servers,
                    s_op->attr.dist_dir_attr.split_size,
                    layout,
                    NULL);

        msg_p->fs_id = s_op->target_fs_id;
        msg_p->handle = meta_handle_extent_array.extent_array[0].first;
        msg_p->retry_flag = PVFS_MSGPAIR_RETRY;
        msg_p->comp_fn = mkdir_lost_and_found_comp_fn;

        ret = PINT_cached_config_map_to_server(&msg_p->svr_addr,
                                               msg_p->handle,
                                               msg_p->fs_id);
        if (ret)
        {
            gossip_err("Failed to map server address\n");
            js_p->error_code = ret;
            return SM_ACTION_COMPLETE;
        }

        PINT_sm_push_frame(smcb, REMOTE_OPERATION, &s_op->msgarray_op);
        js_p->error_code = REMOTE_OPERATION;
    }
    return SM_ACTION_COMPLETE;
}

static int mkdir_lost_and_found_comp_fn(void *v_p,
                                        struct PVFS_server_resp *resp_p,
                                        int index)
{
    PINT_smcb *smcb = v_p;
    PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_MSGPAIR_PARENT_SM);
    
    gossip_debug(GOSSIP_SERVER_DEBUG, "mkdir_lost_and_found_comp_fn\n");

    assert(resp_p->op == PVFS_SERV_MKDIR);

    if (resp_p->status != 0)
    {
	return resp_p->status;
    }

    /* otherwise, just stash the newly created meta handle */
    /* this one is for doing a remote crdirent */
    s_op->u.mgmt_create_root_dir.lost_and_found_handle =
                                          resp_p->u.mkdir.handle;

    gossip_debug(
        GOSSIP_SERVER_DEBUG,
        "*** Got newly created dir handle %llu for lost+found dir.\n",
        llu(s_op->u.mgmt_create_root_dir.lost_and_found_handle));

    return 0;
}

static PINT_sm_action mgmt_create_root_dir_local_mkdir_cleanup(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *mkdir_op = NULL;
    struct PINT_server_op *s_op = NULL;
    int task_id = 0;
    int remaining;

    /* clean up stack after mkdir */
    mkdir_op = PINT_sm_pop_frame(smcb,
                                 &task_id,
                                 &js_p->error_code,
                                 &remaining);

    s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    /* Save the newly created meta handle */
    /* this one is for doing a local crdirent */
    s_op->u.mgmt_create_root_dir.lost_and_found_handle =
                                          mkdir_op->resp.u.mkdir.handle;

    /* Clean up memory that was allocated by the mkdir state machine. */
    mkdir_free(mkdir_op);
    PINT_cleanup_capability(&mkdir_op->req->capability);

    free(mkdir_op->req);
    free(mkdir_op);

    if (js_p->error_code)
    {
        gossip_debug(GOSSIP_SERVER_DEBUG,
                     "Failed to create lost+found directory\n");
    }
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action crdirent_lost_and_found_setup_msgpair(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    server_configuration_s *config = PINT_server_config_mgr_get_config();
    char server_name[1024];
    PVFS_dist_dir_hash_type dirdata_hash;
    int dirdata_server_index;
    int num_handles;

    gossip_debug(GOSSIP_SERVER_DEBUG,
                 "mgmt-create-root-dir state: crdirent_lost_and_found_setup_msgpair\n");

    js_p->error_code = 0;
    
    /* find the hash value and the dist dir bucket */
    dirdata_hash = PINT_encrypt_dirdata(lost_and_found_string);
    gossip_debug(GOSSIP_SERVER_DEBUG, "mgmt-create-root-dir: encrypt dirent %s into hash value %llu.\n",
            lost_and_found_string,
            llu(dirdata_hash));

    dirdata_server_index = 
        PINT_find_dist_dir_bucket(dirdata_hash,
                                  &s_op->attr.dist_dir_attr,
                                  s_op->attr.dist_dir_bitmap);

    gossip_debug(GOSSIP_SERVER_DEBUG, "mgmt-create-root-dir: selecting bucket No.%d from dist_dir_bitmap.\n",
            dirdata_server_index);

    PINT_cached_config_get_server_name(
                            server_name,
                            1024,
                            s_op->attr.dirdata_handles[dirdata_server_index],
                            s_op->target_fs_id);

    if (! strcmp(server_name, config->host_id))
    {   /* local */
        struct PVFS_server_req *crdirent_req = NULL;
        struct PINT_server_op *crdirent_op = NULL;

        crdirent_req = malloc(sizeof(struct PVFS_server_req));
        if (! crdirent_req)
        {
            gossip_err("Unable to allocate crdirent_req\n");
            js_p->error_code = -PVFS_ENOMEM;
            return SM_ACTION_COMPLETE;
        }
        memset(crdirent_req, 0, sizeof(*crdirent_req));

        PINT_SERVREQ_CRDIRENT_FILL(
                    *crdirent_req,
                    s_op->u.mgmt_create_root_dir.capability,
                    s_op->u.mgmt_create_root_dir.credential,
                    lost_and_found_string,
                    s_op->u.mgmt_create_root_dir.lost_and_found_handle,
                    s_op->target_handle,
                    s_op->attr.dirdata_handles[dirdata_server_index],
                    s_op->target_fs_id,
                    NULL);

        crdirent_op = malloc(sizeof(struct PINT_server_op));
        if (! crdirent_op)
        {
            gossip_err("Unable to allocate crdirent_op\n");
            js_p->error_code = -PVFS_ENOMEM;
            return SM_ACTION_COMPLETE;
        }
        memset(crdirent_op, 0, sizeof(*crdirent_op));
        crdirent_op->req = crdirent_req;
        crdirent_op->op = PVFS_SERV_CRDIRENT;
        crdirent_op->target_fs_id = s_op->target_fs_id;
        PINT_sm_push_frame(smcb, LOCAL_OPERATION, crdirent_op);
        js_p->error_code = LOCAL_OPERATION;
    }
    else
    {   /* remote */
        PINT_sm_msgpair_state *msg_p = NULL;
        PVFS_handle *handle_array = NULL;

        /* Update capability to send with request. */
        /* first, free the one we have already been using */
        PINT_cleanup_capability(&s_op->u.mgmt_create_root_dir.capability);

        /* create new handle array with target handle, metadata handle,
         * and dirdata handles */
        num_handles = s_op->attr.dist_dir_attr.num_servers + 2;
        handle_array = (PVFS_handle *) malloc(num_handles *
                                              sizeof(PVFS_handle));
        if (handle_array == NULL)
        {
            gossip_err("mgmt-create-root-dir: out of memory in %s\n", __func__);
            js_p->error_code = -PVFS_ENOMEM;
            return SM_ACTION_COMPLETE;
        }
        handle_array[0] = s_op->target_handle;
        handle_array[1] = s_op->u.mgmt_create_root_dir.lost_and_found_handle;
        memcpy((handle_array + 2),
               s_op->attr.dirdata_handles,
               s_op->attr.dist_dir_attr.num_servers * sizeof(PVFS_handle));

        /* create new capability -- note that handle_array will be freed by 
           PINT_cleanup_capability when the SM completes */
        ret = PINT_server_to_server_capability(
                             &s_op->u.mgmt_create_root_dir.capability, 
                             s_op->target_fs_id,
                             num_handles,
                             handle_array);
        if (ret != 0)
        {
            gossip_err("mgmt-create-root-dir: unable to retrieve server-to-server "
                       "capability in %s\n", __func__);
            js_p->error_code = -PVFS_EACCES;
            return SM_ACTION_COMPLETE;
        }

        gossip_debug(GOSSIP_SERVER_DEBUG,
                     " mgmt-create-root-dir: posting crdirent req\n");

        gossip_debug(GOSSIP_SERVER_DEBUG, "hooking dirent %s (%llu) under "
                     "parent handle %llu, dirdata_handle %llu with server_no=%d\n",
                     lost_and_found_string,
                     llu(s_op->u.mgmt_create_root_dir.lost_and_found_handle),
                     llu(s_op->target_handle),
                     llu(s_op->attr.dirdata_handles[dirdata_server_index]),
                     dirdata_server_index);

        PINT_msgpair_init(&s_op->msgarray_op);
        msg_p = &s_op->msgarray_op.msgpair;
        PINT_serv_init_msgarray_params(s_op, s_op->target_fs_id);

        PINT_SERVREQ_CRDIRENT_FILL(
                    msg_p->req,
                    s_op->u.mgmt_create_root_dir.capability,
                    s_op->u.mgmt_create_root_dir.credential,
                    lost_and_found_string,
                    s_op->u.mgmt_create_root_dir.lost_and_found_handle,
                    s_op->target_handle,
                    s_op->attr.dirdata_handles[dirdata_server_index],
                    s_op->target_fs_id,
                    NULL);

        msg_p->fs_id = s_op->target_fs_id;
        /* send to dirdata server */
        msg_p->handle = s_op->attr.dirdata_handles[dirdata_server_index];
        msg_p->retry_flag = PVFS_MSGPAIR_RETRY;
        msg_p->comp_fn = crdirent_lost_and_found_comp_fn;

        ret = PINT_cached_config_map_to_server(&msg_p->svr_addr,
                                               msg_p->handle,
                                               s_op->target_fs_id);

        if (ret)
        {
            gossip_err("Failed to map dirdata server address\n");
            js_p->error_code = ret;
            return SM_ACTION_COMPLETE;
        }

        PINT_sm_push_frame(smcb, REMOTE_OPERATION, &s_op->msgarray_op);
        js_p->error_code = REMOTE_OPERATION;
    }
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action mgmt_create_root_dir_local_crdirent_cleanup(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *crdirent_op = NULL;
    int task_id = 0;
    int remaining;

    crdirent_op = PINT_sm_pop_frame(smcb,
                                    &task_id,
                                    &js_p->error_code,
                                    &remaining);

    free(crdirent_op->req);
    free(crdirent_op);

    if (js_p->error_code)
    {
        gossip_debug(GOSSIP_SERVER_DEBUG,
                     "Failed to create lost+found directory\n");
    }
    return SM_ACTION_COMPLETE;
}

static int crdirent_lost_and_found_comp_fn(void *v_p,
                                  struct PVFS_server_resp *resp_p,
                                  int index)
{
    gossip_debug(GOSSIP_SERVER_DEBUG, "%s: enter\n", __func__);

    assert(resp_p->op == PVFS_SERV_CRDIRENT);
    return resp_p->status;
}

static PINT_sm_action delete_lost_and_found_handle_setup_msgpair(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    server_configuration_s *config = PINT_server_config_mgr_get_config();
    char server_name[1024];

    gossip_debug(GOSSIP_SERVER_DEBUG, "mgmt-create-root-dir state: "
                 "delete_lost_and_found_handle_setup_msgpair_array\n");
    gossip_debug(GOSSIP_SERVER_DEBUG, " Preparing to remove "
                 "lost+found directory handle %llu\n",
                 llu(s_op->u.mgmt_create_root_dir.lost_and_found_handle));

    js_p->error_code = 0;

    PINT_cached_config_get_server_name(
                       server_name,
                       1024,
                       s_op->u.mgmt_create_root_dir.lost_and_found_handle,
                       s_op->target_fs_id);

    if (! strcmp(server_name, config->host_id))
    {   /* local */
        struct PVFS_server_req *remove_req = NULL;
        struct PINT_server_op *remove_op = NULL;

        remove_req = malloc(sizeof(struct PVFS_server_req));
        if (! remove_req)
        {
            gossip_err("Unable to allocate remove_req\n");
            js_p->error_code = -PVFS_ENOMEM;
            return SM_ACTION_COMPLETE;
        }
        memset(remove_req, 0, sizeof(*remove_req));

        PINT_SERVREQ_REMOVE_FILL(
                     *remove_req,
                     s_op->u.mgmt_create_root_dir.capability,
                     s_op->u.mgmt_create_root_dir.credential,
                     s_op->target_fs_id,
                     s_op->u.mgmt_create_root_dir.lost_and_found_handle,
                     NULL);

        remove_op = malloc(sizeof(struct PINT_server_op));
        if (! remove_op)
        {
            gossip_err("Unable to allocate remove_op\n");
            js_p->error_code = -PVFS_ENOMEM;
            return SM_ACTION_COMPLETE;
        }
        memset(remove_op, 0, sizeof(*remove_op));
        remove_op->req = remove_req;
        remove_op->op = PVFS_SERV_REMOVE;
        PINT_sm_push_frame(smcb, LOCAL_OPERATION, remove_op);
        js_p->error_code = LOCAL_OPERATION;
    }
    else
    {   /* remote */
        PINT_sm_msgpair_state *msg_p = NULL;

        PINT_msgpair_init(&s_op->msgarray_op);
        msg_p = &s_op->msgarray_op.msgpair;
        PINT_serv_init_msgarray_params(s_op, s_op->target_fs_id);

        PINT_SERVREQ_REMOVE_FILL(
                     msg_p->req,
                     s_op->u.mgmt_create_root_dir.capability,
                     s_op->u.mgmt_create_root_dir.credential,
                     s_op->target_fs_id,
                     s_op->u.mgmt_create_root_dir.lost_and_found_handle,
                     NULL);

        msg_p->fs_id = s_op->target_fs_id;
        msg_p->handle = s_op->u.mgmt_create_root_dir.lost_and_found_handle;
        msg_p->retry_flag = PVFS_MSGPAIR_RETRY;
        msg_p->comp_fn = delete_lost_and_found_handle_comp_fn;

        ret = PINT_cached_config_map_to_server(
                          &msg_p->svr_addr, 
                          s_op->u.mgmt_create_root_dir.lost_and_found_handle,
                          s_op->target_fs_id);

        if (ret)
        {
            gossip_err("Failed to map meta server address\n");
            js_p->error_code = ret;
            return SM_ACTION_COMPLETE;
        }

        PINT_sm_push_frame(smcb, REMOTE_OPERATION, &s_op->msgarray_op);
        js_p->error_code = REMOTE_OPERATION;
    }
    return SM_ACTION_COMPLETE;
}

static int delete_lost_and_found_handle_comp_fn(
                                       void *v_p,
                                       struct PVFS_server_resp *resp_p,
                                       int index)
{
    gossip_debug(GOSSIP_SERVER_DEBUG,
                 "delete_lost_and_found_handle_comp_fn\n");

    assert(resp_p->op == PVFS_SERV_REMOVE);
    return resp_p->status;
}

static PINT_sm_action mgmt_create_root_dir_local_delete_cleanup(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *remove_op = NULL;
    int task_id = 0;
    int remaining;

    remove_op = PINT_sm_pop_frame(smcb,
                                  &task_id,
                                  &js_p->error_code,
                                  &remaining);
    free(remove_op->req);
    free(remove_op);

    if (js_p->error_code)
    {
        gossip_debug(GOSSIP_SERVER_DEBUG,
                     "Failed to remove lost+found directory\n");
    }
    return SM_ACTION_COMPLETE;
}

/*
 * Function: mgmt_create_root_dir_cleanup_noreq
 *
 * Params:   server_op *b,
 *           job_status_s *js_p
 *
 * Returns:  int
 *
 * Synopsis: free memory and return
 *
 */
static PINT_sm_action mgmt_create_root_dir_cleanup_noreq( struct PINT_smcb *smcb, 
        job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    assert(s_op);

    if (js_p->error_code != 0)
    {
        char errstr[256];
        PVFS_strerror_r(js_p->error_code, errstr, sizeof(errstr));
        gossip_err("Warning: unable to create root dir due to error: %s\n", 
                   errstr);
        gossip_err("         Your FS may be in an inconsistent state\n");
    }

    if(s_op->key_a)
    {
        free(s_op->key_a);
    }

    if(s_op->val_a)
    {
        free(s_op->val_a);
    }

    PINT_free_object_attr(&s_op->attr);

    if(s_op->u.mgmt_create_root_dir.handle_array_local)
    {
        free(s_op->u.mgmt_create_root_dir.handle_array_local);
    }

    if(s_op->u.mgmt_create_root_dir.handle_array_remote)
    {
        free(s_op->u.mgmt_create_root_dir.handle_array_remote);
    }

    PINT_cleanup_credential(&s_op->u.mgmt_create_root_dir.credential);
    PINT_cleanup_capability(&s_op->u.mgmt_create_root_dir.capability);

    return(server_state_machine_complete_noreq(smcb));
}


PINT_GET_OBJECT_REF_DEFINE(mgmt_create_root_dir);

static int perm_mgmt_create_root_dir(PINT_server_op *s_op)
{
    int ret;

    /* permission not required */
    ret = 0;

    return ret;
}

struct PINT_server_req_params pvfs2_mgmt_create_root_dir_params =
{
    .string_name = "mgmt-create-root-dir",
    .get_object_ref = PINT_get_object_ref_mgmt_create_root_dir,
    .perm = perm_mgmt_create_root_dir,
    .access_type = PINT_server_req_modify,
    .sched_policy = PINT_SERVER_REQ_SCHEDULE,
    .state_machine = &pvfs2_mgmt_create_root_dir_sm
};

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */

