/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will certainly be overwritten.
 */

/* 
 * (C) 2001 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */

#include <string.h>
#include <assert.h>

#include "server-config.h"
#include "pvfs2-storage.h"
#include "pvfs2-server.h"
#include "pvfs2-attr.h"
#include "gossip.h"
#include "pvfs2-internal.h"
#include "pint-security.h"

static struct PINT_state_s ST_prelude;
static struct PINT_tran_tbl_s ST_prelude_trtbl[];

static PINT_sm_action mgmt_remove_dspace(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_remove_dspace;
static struct PINT_tran_tbl_s ST_remove_dspace_trtbl[];
static struct PINT_state_s ST_final_response;
static struct PINT_tran_tbl_s ST_final_response_trtbl[];

static PINT_sm_action mgmt_remove_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_cleanup;
static struct PINT_tran_tbl_s ST_cleanup_trtbl[];

struct PINT_state_machine_s pvfs2_mgmt_remove_object_sm = {
	.name = "pvfs2_mgmt_remove_object_sm",
	.first_state = &ST_prelude
};

static struct PINT_state_s ST_prelude = {
	 .state_name = "prelude" ,
	 .parent_machine = &pvfs2_mgmt_remove_object_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_prelude_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_prelude_trtbl 
};

static struct PINT_tran_tbl_s ST_prelude_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_remove_dspace },
	{ .return_value = -1 ,
	 .next_state = &ST_final_response }
};

static struct PINT_state_s ST_remove_dspace = {
	 .state_name = "remove_dspace" ,
	 .parent_machine = &pvfs2_mgmt_remove_object_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_remove_dspace ,
	 .pjtbl = NULL ,
	 .trtbl = ST_remove_dspace_trtbl 
};

static struct PINT_tran_tbl_s ST_remove_dspace_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_final_response }
};

static struct PINT_state_s ST_final_response = {
	 .state_name = "final_response" ,
	 .parent_machine = &pvfs2_mgmt_remove_object_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_final_response_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_final_response_trtbl 
};

static struct PINT_tran_tbl_s ST_final_response_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_cleanup = {
	 .state_name = "cleanup" ,
	 .parent_machine = &pvfs2_mgmt_remove_object_sm ,
	 .flag = SM_RUN ,
	 .action.func = mgmt_remove_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_cleanup_trtbl[] = {
	{ .return_value = -1 ,

	 .flag = SM_TERM }
};

#ifndef WIN32
# 47 "src/server/mgmt-remove-object.sm"
#endif


static PINT_sm_action mgmt_remove_dspace(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    job_id_t j_id;
    
    gossip_debug(
        GOSSIP_SERVER_DEBUG, "Trying to mgmt_remove object %llu,%d\n",
        llu(s_op->req->u.mgmt_remove_object.handle),
        s_op->req->u.mgmt_remove_object.fs_id);

    ret = job_trove_dspace_remove(
        s_op->req->u.mgmt_remove_object.fs_id,
        s_op->req->u.mgmt_remove_object.handle,
        TROVE_SYNC,
        smcb,
        0,
        js_p,
        &j_id,
        server_job_context, s_op->req->hints);

    return ret;
}

static PINT_sm_action mgmt_remove_cleanup(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    return(server_state_machine_complete(smcb));
}

PINT_GET_OBJECT_REF_DEFINE(mgmt_remove_object);

static int perm_mgmt_remove_object(PINT_server_op *s_op)
{
    int ret;

    ret = 0;

    return ret;
}

struct PINT_server_req_params pvfs2_mgmt_remove_object_params =
{
    .string_name = "mgmt-remove-object",
    .perm = perm_mgmt_remove_object,
    .access_type = PINT_server_req_modify,
    .sched_policy = PINT_SERVER_REQ_SCHEDULE,
    .get_object_ref = PINT_get_object_ref_mgmt_remove_object,
    .state_machine = &pvfs2_mgmt_remove_object_sm
};

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */
