/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will certainly be overwritten.
 */

/* 
 * (C) 2001 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */

#include <string.h>
#include <assert.h>

#include "server-config.h"
#include "pvfs2-storage.h"
#include "pvfs2-server.h"
#include "pvfs2-attr.h"
#include "gossip.h"
#include "pvfs2-internal.h"
#include "pint-perf-counter.h"
#include "pint-security.h"
#include "security-util.h"
#include "pint-cached-config.h"
#include "pint-util.h"

/* Implementation notes
 *
 * This is a complicated machine.  It is capable of removing the three
 * externally visible PVFS2 object types: datafiles, metafiles, and
 * directories.
 *
 * For a datafile, the path through the state machine looks like:
 * 1) prelude
 * 2) check_object_type
 * 3) verify_object_metadata
 * 4) remove_dspace
 * 5) final_response
 * 6) cleanup
 *
 * For metafiles and symlinks, the path is:
 * 1) prelude
 * 2) check_object_type
 * 3) verify_object_metadata
 * 4) remove_dspace
 * 5) final_response
 * 6) cleanup
 *
 * For dirdata, the path is:
 * 1) prelude
 * 2) check_object_type
 * 3) getattr_of_dirdata_handle
 * 4) check_dirdata_entries
 * 5) remove_dspace
 * 5) final_response
 * 7) cleanup
 *
 * For a directory, the path is:
 * 1) prelude
 * 2) check_object_type
 * 3) verify_object_metadata
 * 4) nested machine: remove_dirdata_handles
 *    (remove_dirdata_handles can rebuild dirdata handles if any dirdata_remove fails.)
 * 5) remove_dspace
 * 6) final_response
 * 7) cleanup
 *
 * A directory that never had entries will skip step (5), as there
 * would be no dirdata dspace.
 */

enum
{
    STATE_TYPE_DIRECTORY = 1,
    STATE_TYPE_DATAFILE = 2,
    STATE_TYPE_DIRDATA = 3,
    LOCAL_OPERATION = 4,
    REMOTE_OPERATION = 5,
    REBUILD_DONE
};


static PINT_sm_action remove_dirdata_init(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_remove_dirdata_init;
static struct PINT_tran_tbl_s ST_remove_dirdata_init_trtbl[];

static PINT_sm_action remove_get_dist_dir_attr(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_get_dist_dir_attr;
static struct PINT_tran_tbl_s ST_get_dist_dir_attr_trtbl[];

static PINT_sm_action remove_get_dirdata_bitmap_and_handles(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_get_dirdata_bitmap_and_handles;
static struct PINT_tran_tbl_s ST_get_dirdata_bitmap_and_handles_trtbl[];

static PINT_sm_action remove_get_dirent_count_setup_tree_getattr(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_get_dirent_count_setup_tree_getattr;
static struct PINT_tran_tbl_s ST_get_dirent_count_setup_tree_getattr_trtbl[];
static struct PINT_state_s ST_get_dirent_count_call_tree_getattr;
static struct PINT_tran_tbl_s ST_get_dirent_count_call_tree_getattr_trtbl[];

static PINT_sm_action remove_get_dirent_count_examine_tree_getattr(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_get_dirent_count_examine_tree_getattr;
static struct PINT_tran_tbl_s ST_get_dirent_count_examine_tree_getattr_trtbl[];

static PINT_sm_action remove_get_dirent_count_cleanup_tree_getattr(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_get_dirent_count_cleanup_tree_getattr;
static struct PINT_tran_tbl_s ST_get_dirent_count_cleanup_tree_getattr_trtbl[];

static PINT_sm_action remove_dirdata_handles_setup_tree_remove(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_remove_dirdata_handles_setup_tree_remove;
static struct PINT_tran_tbl_s ST_remove_dirdata_handles_setup_tree_remove_trtbl[];
static struct PINT_state_s ST_remove_dirdata_handles_call_tree_remove;
static struct PINT_tran_tbl_s ST_remove_dirdata_handles_call_tree_remove_trtbl[];

static PINT_sm_action remove_dirdata_handles_check_remove_success(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_remove_dirdata_handles_check_remove_success;
static struct PINT_tran_tbl_s ST_remove_dirdata_handles_check_remove_success_trtbl[];

static PINT_sm_action remove_dirdata_handles_cleanup_tree_remove(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_remove_dirdata_handles_cleanup_tree_remove;
static struct PINT_tran_tbl_s ST_remove_dirdata_handles_cleanup_tree_remove_trtbl[];

static PINT_sm_action remove_rebuild_dirdata_handle_local(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_rebuild_dirdata_handle_local;
static struct PINT_tran_tbl_s ST_rebuild_dirdata_handle_local_trtbl[];

static PINT_sm_action remove_rebuild_dirdata_handle_remote(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_rebuild_dirdata_handle_remote;
static struct PINT_tran_tbl_s ST_rebuild_dirdata_handle_remote_trtbl[];

static PINT_sm_action remove_rebuild_remote_dirdata_keyval_setup_msgpair(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_remote_dirdata_keyval_setup_msgpair;
static struct PINT_tran_tbl_s ST_remote_dirdata_keyval_setup_msgpair_trtbl[];

static PINT_sm_action remove_rebuild_done(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_rebuild_done;
static struct PINT_tran_tbl_s ST_rebuild_done_trtbl[];
static struct PINT_state_s ST_remote_dirdata_keyval_xfer_msgpair;
static struct PINT_tran_tbl_s ST_remote_dirdata_keyval_xfer_msgpair_trtbl[];

static PINT_sm_action remove_rebuild_write_dirdata_keyval(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_write_dirdata_keyval;
static struct PINT_tran_tbl_s ST_write_dirdata_keyval_trtbl[];

static PINT_sm_action remove_remove_dirdata_handles_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_remove_dirdata_handles_cleanup;
static struct PINT_tran_tbl_s ST_remove_dirdata_handles_cleanup_trtbl[];

struct PINT_state_machine_s pvfs2_remove_dirdata_handles_work_sm = {
	.name = "pvfs2_remove_dirdata_handles_work_sm",
	.first_state = &ST_remove_dirdata_init
};

static struct PINT_state_s ST_remove_dirdata_init = {
	 .state_name = "remove_dirdata_init" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_dirdata_init ,
	 .pjtbl = NULL ,
	 .trtbl = ST_remove_dirdata_init_trtbl 
};

static struct PINT_tran_tbl_s ST_remove_dirdata_init_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_get_dist_dir_attr }
};

static struct PINT_state_s ST_get_dist_dir_attr = {
	 .state_name = "get_dist_dir_attr" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_get_dist_dir_attr ,
	 .pjtbl = NULL ,
	 .trtbl = ST_get_dist_dir_attr_trtbl 
};

static struct PINT_tran_tbl_s ST_get_dist_dir_attr_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_get_dirdata_bitmap_and_handles },
	{ .return_value = -1 ,
	 .flag = SM_RETURN }
};

static struct PINT_state_s ST_get_dirdata_bitmap_and_handles = {
	 .state_name = "get_dirdata_bitmap_and_handles" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_get_dirdata_bitmap_and_handles ,
	 .pjtbl = NULL ,
	 .trtbl = ST_get_dirdata_bitmap_and_handles_trtbl 
};

static struct PINT_tran_tbl_s ST_get_dirdata_bitmap_and_handles_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_get_dirent_count_setup_tree_getattr },
	{ .return_value = -1 ,
	 .next_state = &ST_remove_dirdata_handles_cleanup }
};

static struct PINT_state_s ST_get_dirent_count_setup_tree_getattr = {
	 .state_name = "get_dirent_count_setup_tree_getattr" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_get_dirent_count_setup_tree_getattr ,
	 .pjtbl = NULL ,
	 .trtbl = ST_get_dirent_count_setup_tree_getattr_trtbl 
};

static struct PINT_tran_tbl_s ST_get_dirent_count_setup_tree_getattr_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_get_dirent_count_call_tree_getattr },
	{ .return_value = -1 ,
	 .next_state = &ST_get_dirent_count_cleanup_tree_getattr }
};

static struct PINT_state_s ST_get_dirent_count_call_tree_getattr = {
	 .state_name = "get_dirent_count_call_tree_getattr" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_tree_getattr_work_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_get_dirent_count_call_tree_getattr_trtbl 
};

static struct PINT_tran_tbl_s ST_get_dirent_count_call_tree_getattr_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_get_dirent_count_examine_tree_getattr },
	{ .return_value = -1 ,
	 .next_state = &ST_remove_dirdata_handles_cleanup }
};

static struct PINT_state_s ST_get_dirent_count_examine_tree_getattr = {
	 .state_name = "get_dirent_count_examine_tree_getattr" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_get_dirent_count_examine_tree_getattr ,
	 .pjtbl = NULL ,
	 .trtbl = ST_get_dirent_count_examine_tree_getattr_trtbl 
};

static struct PINT_tran_tbl_s ST_get_dirent_count_examine_tree_getattr_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_remove_dirdata_handles_setup_tree_remove },
	{ .return_value = -1 ,
	 .next_state = &ST_remove_dirdata_handles_cleanup }
};

static struct PINT_state_s ST_get_dirent_count_cleanup_tree_getattr = {
	 .state_name = "get_dirent_count_cleanup_tree_getattr" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_get_dirent_count_cleanup_tree_getattr ,
	 .pjtbl = NULL ,
	 .trtbl = ST_get_dirent_count_cleanup_tree_getattr_trtbl 
};

static struct PINT_tran_tbl_s ST_get_dirent_count_cleanup_tree_getattr_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_remove_dirdata_handles_cleanup }
};

static struct PINT_state_s ST_remove_dirdata_handles_setup_tree_remove = {
	 .state_name = "remove_dirdata_handles_setup_tree_remove" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_dirdata_handles_setup_tree_remove ,
	 .pjtbl = NULL ,
	 .trtbl = ST_remove_dirdata_handles_setup_tree_remove_trtbl 
};

static struct PINT_tran_tbl_s ST_remove_dirdata_handles_setup_tree_remove_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_remove_dirdata_handles_call_tree_remove },
	{ .return_value = -1 ,
	 .next_state = &ST_remove_dirdata_handles_cleanup_tree_remove }
};

static struct PINT_state_s ST_remove_dirdata_handles_call_tree_remove = {
	 .state_name = "remove_dirdata_handles_call_tree_remove" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_tree_remove_work_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_remove_dirdata_handles_call_tree_remove_trtbl 
};

static struct PINT_tran_tbl_s ST_remove_dirdata_handles_call_tree_remove_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_remove_dirdata_handles_check_remove_success },
	{ .return_value = -1 ,
	 .next_state = &ST_rebuild_dirdata_handle_local }
};

static struct PINT_state_s ST_remove_dirdata_handles_check_remove_success = {
	 .state_name = "remove_dirdata_handles_check_remove_success" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_dirdata_handles_check_remove_success ,
	 .pjtbl = NULL ,
	 .trtbl = ST_remove_dirdata_handles_check_remove_success_trtbl 
};

static struct PINT_tran_tbl_s ST_remove_dirdata_handles_check_remove_success_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_remove_dirdata_handles_cleanup },
	{ .return_value = -1 ,
	 .next_state = &ST_rebuild_dirdata_handle_local }
};

static struct PINT_state_s ST_remove_dirdata_handles_cleanup_tree_remove = {
	 .state_name = "remove_dirdata_handles_cleanup_tree_remove" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_dirdata_handles_cleanup_tree_remove ,
	 .pjtbl = NULL ,
	 .trtbl = ST_remove_dirdata_handles_cleanup_tree_remove_trtbl 
};

static struct PINT_tran_tbl_s ST_remove_dirdata_handles_cleanup_tree_remove_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_remove_dirdata_handles_cleanup }
};

static struct PINT_state_s ST_rebuild_dirdata_handle_local = {
	 .state_name = "rebuild_dirdata_handle_local" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_rebuild_dirdata_handle_local ,
	 .pjtbl = NULL ,
	 .trtbl = ST_rebuild_dirdata_handle_local_trtbl 
};

static struct PINT_tran_tbl_s ST_rebuild_dirdata_handle_local_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_rebuild_dirdata_handle_remote },
	{ .return_value = -1 ,
	 .next_state = &ST_remove_dirdata_handles_cleanup }
};

static struct PINT_state_s ST_rebuild_dirdata_handle_remote = {
	 .state_name = "rebuild_dirdata_handle_remote" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_rebuild_dirdata_handle_remote ,
	 .pjtbl = NULL ,
	 .trtbl = ST_rebuild_dirdata_handle_remote_trtbl 
};

static struct PINT_tran_tbl_s ST_rebuild_dirdata_handle_remote_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_remote_dirdata_keyval_setup_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_remove_dirdata_handles_cleanup }
};

static struct PINT_state_s ST_remote_dirdata_keyval_setup_msgpair = {
	 .state_name = "remote_dirdata_keyval_setup_msgpair" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_rebuild_remote_dirdata_keyval_setup_msgpair ,
	 .pjtbl = NULL ,
	 .trtbl = ST_remote_dirdata_keyval_setup_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_remote_dirdata_keyval_setup_msgpair_trtbl[] = {
	{ .return_value = REBUILD_DONE ,
	 .next_state = &ST_rebuild_done },
	{ .return_value = 0 ,
	 .next_state = &ST_remote_dirdata_keyval_xfer_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_remove_dirdata_handles_cleanup }
};

static struct PINT_state_s ST_rebuild_done = {
	 .state_name = "rebuild_done" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_rebuild_done ,
	 .pjtbl = NULL ,
	 .trtbl = ST_rebuild_done_trtbl 
};

static struct PINT_tran_tbl_s ST_rebuild_done_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_remove_dirdata_handles_cleanup }
};

static struct PINT_state_s ST_remote_dirdata_keyval_xfer_msgpair = {
	 .state_name = "remote_dirdata_keyval_xfer_msgpair" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_msgpairarray_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_remote_dirdata_keyval_xfer_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_remote_dirdata_keyval_xfer_msgpair_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_write_dirdata_keyval },
	{ .return_value = -1 ,
	 .next_state = &ST_remove_dirdata_handles_cleanup }
};

static struct PINT_state_s ST_write_dirdata_keyval = {
	 .state_name = "write_dirdata_keyval" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_rebuild_write_dirdata_keyval ,
	 .pjtbl = NULL ,
	 .trtbl = ST_write_dirdata_keyval_trtbl 
};

static struct PINT_tran_tbl_s ST_write_dirdata_keyval_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_remove_dirdata_handles_cleanup }
};

static struct PINT_state_s ST_remove_dirdata_handles_cleanup = {
	 .state_name = "remove_dirdata_handles_cleanup" ,
	 .parent_machine = &pvfs2_remove_dirdata_handles_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_remove_dirdata_handles_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_remove_dirdata_handles_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_remove_dirdata_handles_cleanup_trtbl[] = {
	{ .return_value = -1 ,
	 .flag = SM_RETURN }
};


static PINT_sm_action remove_check_object_type(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_check_object_type;
static struct PINT_tran_tbl_s ST_check_object_type_trtbl[];

static PINT_sm_action remove_verify_object_metadata(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_verify_object_metadata;
static struct PINT_tran_tbl_s ST_verify_object_metadata_trtbl[];

static PINT_sm_action remove_remove_dspace(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_remove_dspace;
static struct PINT_tran_tbl_s ST_remove_dspace_trtbl[];

static PINT_sm_action remove_get_dirent_count(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_getattr_of_dirdata_handle;
static struct PINT_tran_tbl_s ST_getattr_of_dirdata_handle_trtbl[];

static PINT_sm_action remove_check_dirdata_entries(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_check_dirdata_entries;
static struct PINT_tran_tbl_s ST_check_dirdata_entries_trtbl[];
static struct PINT_state_s ST_remove_dirdata_handles;
static struct PINT_tran_tbl_s ST_remove_dirdata_handles_trtbl[];

struct PINT_state_machine_s pvfs2_remove_work_sm = {
	.name = "pvfs2_remove_work_sm",
	.first_state = &ST_check_object_type
};

static struct PINT_state_s ST_check_object_type = {
	 .state_name = "check_object_type" ,
	 .parent_machine = &pvfs2_remove_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_check_object_type ,
	 .pjtbl = NULL ,
	 .trtbl = ST_check_object_type_trtbl 
};

static struct PINT_tran_tbl_s ST_check_object_type_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_verify_object_metadata },
	{ .return_value = STATE_TYPE_DATAFILE ,
	 .next_state = &ST_remove_dspace },
	{ .return_value = STATE_TYPE_DIRDATA ,
	 .next_state = &ST_getattr_of_dirdata_handle },
	{ .return_value = -1 ,
	 .flag = SM_RETURN }
};

static struct PINT_state_s ST_verify_object_metadata = {
	 .state_name = "verify_object_metadata" ,
	 .parent_machine = &pvfs2_remove_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_verify_object_metadata ,
	 .pjtbl = NULL ,
	 .trtbl = ST_verify_object_metadata_trtbl 
};

static struct PINT_tran_tbl_s ST_verify_object_metadata_trtbl[] = {
	{ .return_value = STATE_TYPE_DIRECTORY ,
	 .next_state = &ST_remove_dirdata_handles },
	{ .return_value = 0 ,
	 .next_state = &ST_remove_dspace },
	{ .return_value = -1 ,
	 .flag = SM_RETURN }
};

static struct PINT_state_s ST_remove_dspace = {
	 .state_name = "remove_dspace" ,
	 .parent_machine = &pvfs2_remove_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_remove_dspace ,
	 .pjtbl = NULL ,
	 .trtbl = ST_remove_dspace_trtbl 
};

static struct PINT_tran_tbl_s ST_remove_dspace_trtbl[] = {
	{ .return_value = -1 ,
	 .flag = SM_RETURN }
};

static struct PINT_state_s ST_getattr_of_dirdata_handle = {
	 .state_name = "getattr_of_dirdata_handle" ,
	 .parent_machine = &pvfs2_remove_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_get_dirent_count ,
	 .pjtbl = NULL ,
	 .trtbl = ST_getattr_of_dirdata_handle_trtbl 
};

static struct PINT_tran_tbl_s ST_getattr_of_dirdata_handle_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_check_dirdata_entries }
};

static struct PINT_state_s ST_check_dirdata_entries = {
	 .state_name = "check_dirdata_entries" ,
	 .parent_machine = &pvfs2_remove_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_check_dirdata_entries ,
	 .pjtbl = NULL ,
	 .trtbl = ST_check_dirdata_entries_trtbl 
};

static struct PINT_tran_tbl_s ST_check_dirdata_entries_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_remove_dspace },
	{ .return_value = -1 ,
	 .flag = SM_RETURN }
};

static struct PINT_state_s ST_remove_dirdata_handles = {
	 .state_name = "remove_dirdata_handles" ,
	 .parent_machine = &pvfs2_remove_work_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_remove_dirdata_handles_work_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_remove_dirdata_handles_trtbl 
};

static struct PINT_tran_tbl_s ST_remove_dirdata_handles_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_remove_dspace },
	{ .return_value = -1 ,
	 .flag = SM_RETURN }
};

static struct PINT_state_s ST_prelude;
static struct PINT_tran_tbl_s ST_prelude_trtbl[];
static struct PINT_state_s ST_do_work;
static struct PINT_tran_tbl_s ST_do_work_trtbl[];

struct PINT_state_machine_s pvfs2_remove_with_prelude_sm = {
	.name = "pvfs2_remove_with_prelude_sm",
	.first_state = &ST_prelude
};

static struct PINT_state_s ST_prelude = {
	 .state_name = "prelude" ,
	 .parent_machine = &pvfs2_remove_with_prelude_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_prelude_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_prelude_trtbl 
};

static struct PINT_tran_tbl_s ST_prelude_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_do_work },
	{ .return_value = -1 ,
	 .flag = SM_RETURN }
};

static struct PINT_state_s ST_do_work = {
	 .state_name = "do_work" ,
	 .parent_machine = &pvfs2_remove_with_prelude_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_remove_work_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_do_work_trtbl 
};

static struct PINT_tran_tbl_s ST_do_work_trtbl[] = {
	{ .return_value = -1 ,
	 .flag = SM_RETURN }
};

static struct PINT_state_s ST_work;
static struct PINT_tran_tbl_s ST_work_trtbl[];
static struct PINT_state_s ST_final_response;
static struct PINT_tran_tbl_s ST_final_response_trtbl[];

static PINT_sm_action remove_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_cleanup;
static struct PINT_tran_tbl_s ST_cleanup_trtbl[];

struct PINT_state_machine_s pvfs2_remove_sm = {
	.name = "pvfs2_remove_sm",
	.first_state = &ST_work
};

static struct PINT_state_s ST_work = {
	 .state_name = "work" ,
	 .parent_machine = &pvfs2_remove_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_remove_with_prelude_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_work_trtbl 
};

static struct PINT_tran_tbl_s ST_work_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_final_response }
};

static struct PINT_state_s ST_final_response = {
	 .state_name = "final_response" ,
	 .parent_machine = &pvfs2_remove_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_final_response_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_final_response_trtbl 
};

static struct PINT_tran_tbl_s ST_final_response_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_cleanup = {
	 .state_name = "cleanup" ,
	 .parent_machine = &pvfs2_remove_sm ,
	 .flag = SM_RUN ,
	 .action.func = remove_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_cleanup_trtbl[] = {
	{ .return_value = -1 ,

	 .flag = SM_TERM }
};

#ifndef WIN32
# 288 "src/server/remove.sm"
#endif


/*
 * Function: remove_check_object_type
 *
 * decides whether to follow the path for datafile removal or
 * non-datafile removal, based on whether we were able to successfully
 * retrive object attributes earlier
 *
 */
static PINT_sm_action remove_check_object_type(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    if(s_op->attr.objtype == PVFS_TYPE_DATAFILE)
    {
	/* it must be a datafile, transition to try reading datafile 
	 * attribs with dspace_getattr()
	 */
	js_p->error_code = STATE_TYPE_DATAFILE;
	return SM_ACTION_COMPLETE;
    }

    if (s_op->attr.objtype == PVFS_TYPE_DIRDATA)
    {
        js_p->error_code = STATE_TYPE_DIRDATA;

        gossip_debug(
            GOSSIP_SERVER_DEBUG, "  type is dirdata; checking "
            "dirent_count before removing dirdata itself.\n");
        return SM_ACTION_COMPLETE;
    }

    js_p->error_code = 0;
    return SM_ACTION_COMPLETE;
}

/*
 * Function: remove_verify_object_metadata
 *
 * Verifies that the user has permission to access the file (not yet
 * implemented).  Also directs removal of dirdata dspace in the case
 * of a directory.
 *
 * This state has changed some over time; it might need a new name.
 *
 * Note: errors from the previous state are redirected elsewhere, so
 * we know that we have metadata if we make it here.
 */
static PINT_sm_action remove_verify_object_metadata(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PVFS_object_attr *a_p;

    a_p = &s_op->attr;

    js_p->error_code = 0;
    
    gossip_debug(GOSSIP_SERVER_DEBUG,
		 "  attrs read from keyval = (owner = %d, "
                 "group = %d, perms = %o, type = %d)\n",
		 a_p->owner,
		 a_p->group,
		 a_p->perms,
		 a_p->objtype);

    if (a_p->objtype == PVFS_TYPE_DIRECTORY)
    {
        /* This is the first point we know this is a rmdir so
         * increment the counter for rmdir requests
         */

	js_p->error_code = STATE_TYPE_DIRECTORY;

	gossip_debug(
            GOSSIP_SERVER_DEBUG, "  type is directory; removing "
            "dirdata object before removing directory itself.\n");
    }

    return SM_ACTION_COMPLETE;
}

static PINT_sm_action remove_get_dirent_count(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret;
    job_id_t tmp_id;

    if (js_p->error_code < 0)
    {
        return SM_ACTION_COMPLETE;
    }
    js_p->error_code = 0;

    gossip_debug(
            GOSSIP_SERVER_DEBUG,
            "remove: getting dirdata dirent_count...\n");

    ret = job_trove_keyval_iterate_keys(
        s_op->req->u.remove.fs_id,
        s_op->req->u.remove.handle, /* it's a dirdata handle */
        PVFS_ITERATE_START,
        &s_op->u.remove.key,
        1,
        TROVE_KEYVAL_DIRECTORY_ENTRY,
        NULL,
        smcb,
        0,
        js_p,
        &tmp_id,
        server_job_context, s_op->req->hints);

    return ret;
}

static PINT_sm_action remove_check_dirdata_entries(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op __attribute__((unused)) =
        PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    gossip_debug(
            GOSSIP_SERVER_DEBUG,
            "remove: dirdata returning error_code = %d, count = %d\n",
            js_p->error_code, js_p->count);

    if (js_p->error_code == 0)
    {
        if(js_p->count > 0)
        {
            gossip_debug(GOSSIP_SERVER_DEBUG, 
                         " detected non-empty "
                         "directory (fsid: %u, handle: %llu) "
                         "-- returning error\n",
                         s_op->req->u.remove.fs_id,
                         llu(s_op->req->u.remove.handle));
            js_p->error_code = -PVFS_ENOTEMPTY;
        }
    }
    else if(js_p->error_code == -TROVE_ENOENT)
    {
        /* no entries because count is 0 */
        js_p->error_code = 0;
    }

    /* setup position for next state (remove[_dirdata]_keyvals) */
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action remove_dirdata_init(
        struct PINT_smcb *smcb, job_status_s *js_p)
{       
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    
    s_op->u.remove.saved_error_code = 0;
    s_op->u.remove.need_rebuild_dirdata_local = 0;
    s_op->u.remove.local_dirdata_index = -1;
    s_op->u.remove.num_rebuild_dirdata_remote = 0;
    s_op->u.remove.rebuild_dirdata_index_array_remote = NULL;
    s_op->u.remove.handle_array_remote = NULL;

    js_p->error_code = 0;
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action remove_get_dist_dir_attr(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret;
    job_id_t j_id;

    /* set up key and value structures for reading the dist_dir_attr */
    s_op->key.buffer = Trove_Common_Keys[DIST_DIR_ATTR_KEY].key;
    s_op->key.buffer_sz = Trove_Common_Keys[DIST_DIR_ATTR_KEY].size;
    if(s_op->free_val)
    {
        free(s_op->val.buffer);
    }

    s_op->val.buffer = &s_op->attr.dist_dir_attr;
    s_op->val.buffer_sz = sizeof(PVFS_dist_dir_attr);
    s_op->free_val = 0;

    js_p->error_code = 0;
    gossip_debug(GOSSIP_SERVER_DEBUG,
		 "  trying to read dist_dir_attr (coll_id = %d, "
                 "handle = %llu, key = %s (%d), val_buf = %p (%d))\n",
		 s_op->req->u.remove.fs_id, llu(s_op->req->u.remove.handle),
		 (char *)s_op->key.buffer, s_op->key.buffer_sz,
		 s_op->val.buffer, s_op->val.buffer_sz);

    ret = job_trove_keyval_read(
        s_op->req->u.remove.fs_id, s_op->req->u.remove.handle,
        &s_op->key, &s_op->val,
        0,
        NULL, smcb, 0, js_p,
        &j_id, server_job_context, s_op->req->hints);

    return ret;
}


static PINT_sm_action remove_get_dirdata_bitmap_and_handles(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret;
    PVFS_object_attr *attr_p;
    job_id_t j_id;

    attr_p = &s_op->attr;

    if(js_p->error_code == -TROVE_ENOENT)
    {
        gossip_debug(GOSSIP_SERVER_DEBUG, "remove: no DIST_DIR_ATTR key present in directory meta handle!!\n");
        attr_p->dist_dir_bitmap = NULL;
        attr_p->dirdata_handles = NULL;
        return SM_ACTION_COMPLETE;
    }

    assert(attr_p->dist_dir_attr.num_servers > 0);
    
    gossip_debug(GOSSIP_SERVER_DEBUG, 
            "remove: get dist-dir-attr for dir meta handle %llu "
            "with tree_height=%d, num_servers=%d, bitmap_size=%d, "
            "split_size=%d, server_no=%d and branch_level=%d\n",
            llu(s_op->u.remove.handle),
            attr_p->dist_dir_attr.tree_height,
            attr_p->dist_dir_attr.num_servers,
            attr_p->dist_dir_attr.bitmap_size,
            attr_p->dist_dir_attr.split_size,
            attr_p->dist_dir_attr.server_no,
            attr_p->dist_dir_attr.branch_level);

    /* allocate space for dirdata handles */
    attr_p->dist_dir_bitmap = 
        malloc(attr_p->dist_dir_attr.bitmap_size *
                sizeof(PVFS_dist_dir_bitmap_basetype));
    attr_p->dirdata_handles = 
        malloc(attr_p->dist_dir_attr.num_servers *
                sizeof(PVFS_handle));
    if(!attr_p->dirdata_handles || 
            !attr_p->dist_dir_bitmap)
    {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }

    /* set up attr->mask */
    attr_p->mask |= PVFS_ATTR_DISTDIR_ATTR;

    /* will read bitmap and dirdata handles in keyval */
    int keyval_count = 2;

    s_op->key_a = malloc(sizeof(PVFS_ds_keyval) * keyval_count);
    s_op->val_a = malloc(sizeof(PVFS_ds_keyval) * keyval_count);
    s_op->error_a = calloc(keyval_count, sizeof(PVFS_error));
    if(!s_op->key_a || !s_op->val_a || !s_op->error_a)
    {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }

    memset(s_op->val_a, 0, sizeof(PVFS_ds_keyval) * keyval_count);
    memset(s_op->error_a, 0, sizeof(PVFS_error) * keyval_count);


    /* set up key and value structures for reading dirdata handles */
    s_op->key_a[0].buffer = Trove_Common_Keys[DIST_DIRDATA_HANDLES_KEY].key;
    s_op->key_a[0].buffer_sz = Trove_Common_Keys[DIST_DIRDATA_HANDLES_KEY].size;

    s_op->val_a[0].buffer = attr_p->dirdata_handles;
    s_op->val_a[0].buffer_sz = attr_p->dist_dir_attr.num_servers *
                sizeof(PVFS_handle);

    /* !!! set bitmap keyval field */
    s_op->key_a[1].buffer = Trove_Common_Keys[DIST_DIRDATA_BITMAP_KEY].key;
    s_op->key_a[1].buffer_sz = Trove_Common_Keys[DIST_DIRDATA_BITMAP_KEY].size;

    s_op->val_a[1].buffer_sz =
        attr_p->dist_dir_attr.bitmap_size * 
        sizeof(PVFS_dist_dir_bitmap_basetype);
    s_op->val_a[1].buffer = attr_p->dist_dir_bitmap;

    js_p->error_code = 0;
    gossip_debug(GOSSIP_SERVER_DEBUG,
		 "remove: trying to read dirdata handles (coll_id = %d, "
                 "handle = %llu, key = %s (%d), val_buf = %p (%d)) and dirdata bitmap ( "
                 "key = %s (%d), val_buf = %p (%d))\n",
		 s_op->req->u.remove.fs_id, llu(s_op->req->u.remove.handle),
		 (char *)s_op->key_a[0].buffer, s_op->key_a[0].buffer_sz,
		 s_op->val_a[0].buffer, s_op->val_a[0].buffer_sz,
		 (char *)s_op->key_a[1].buffer, s_op->key_a[1].buffer_sz,
		 s_op->val_a[1].buffer, s_op->val_a[1].buffer_sz);

    ret = job_trove_keyval_read_list(
        s_op->req->u.remove.fs_id, s_op->req->u.remove.handle,
        s_op->key_a, s_op->val_a, s_op->error_a,
        keyval_count,
        0,
        NULL, smcb, 0, js_p,
        &j_id, server_job_context, s_op->req->hints);

    return ret;
}

static PINT_sm_action remove_get_dirent_count_setup_tree_getattr(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    struct PINT_server_op *getattr_op = NULL;
    struct PVFS_server_req *req = NULL;
    PVFS_object_attr *attr_p = NULL;
    PVFS_capability capability;
    int location = 0;

    attr_p = &s_op->attr;
    /* This pushes a frame for the getattr */
    PINT_CREATE_SUBORDINATE_SERVER_FRAME(smcb, getattr_op,
        attr_p->dirdata_handles[0], s_op->req->u.remove.fs_id,
        location, req, LOCAL_OPERATION);

    PINT_null_capability(&capability);

    PINT_SERVREQ_TREE_GETATTR_FILL(*req,
        capability,
        s_op->req->u.remove.credential,
        s_op->req->u.remove.fs_id,
        0,
        attr_p->dist_dir_attr.num_servers,
        attr_p->dirdata_handles,
        PVFS_ATTR_DIR_DIRENT_COUNT, /* only interested in dirent_count */
        0,
        s_op->req->hints);

    PINT_cleanup_capability(&capability);

    return SM_ACTION_COMPLETE;
}

static PINT_sm_action remove_get_dirent_count_cleanup_tree_getattr(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *getattr_op = NULL;
    int task_id = 0, error_code = 0;

    /* Clean up the frame that was created for tree_getattr. */
    getattr_op = PINT_sm_pop_frame(smcb, &task_id, &error_code, NULL);
    tree_getattr_free(getattr_op);
    PINT_CLEANUP_SUBORDINATE_SERVER_FRAME(getattr_op);
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action remove_get_dirent_count_examine_tree_getattr(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = NULL;
    struct PINT_server_op *getattr_op = NULL;
    PVFS_object_attr *attr_p = NULL;
    int task_id = 0, error_code = 0;
    int i = 0;

    /* Make sure the count of directory entries that we retrieved was 0. */
    /* This pops the frame for the getattr */
    getattr_op = PINT_sm_pop_frame(smcb, &task_id, &error_code, NULL);
    s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    attr_p = &s_op->attr;
    if (error_code != 0)
    {
        js_p->error_code = error_code;
        tree_getattr_free(getattr_op);
        PINT_CLEANUP_SUBORDINATE_SERVER_FRAME(getattr_op);
        return SM_ACTION_COMPLETE;
    }
    for (i = 0; i < attr_p->dist_dir_attr.num_servers; i++)
    {
        if (getattr_op->resp.u.tree_getattr.attr[i].u.dir.dirent_count > 0)
        {
            js_p->error_code = -PVFS_ENOTEMPTY;
            tree_getattr_free(getattr_op);
            PINT_CLEANUP_SUBORDINATE_SERVER_FRAME(getattr_op);
            return SM_ACTION_COMPLETE;
        }
    }
    js_p->error_code = 0;

    /* perform cleanup routine and free getattr_op (allocated as
      subordinate frame) */
    tree_getattr_free(getattr_op);
    PINT_CLEANUP_SUBORDINATE_SERVER_FRAME(getattr_op);

    return SM_ACTION_COMPLETE;
}

static PINT_sm_action remove_dirdata_handles_setup_tree_remove(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    struct PINT_server_op *remove_op = NULL;
    struct PVFS_server_req *req = NULL;
    PVFS_object_attr *attr_p = NULL;
    int location = 0;

    attr_p = &s_op->attr;
    assert(attr_p);

    /* initialize rebuild array */
    s_op->u.remove.rebuild_dirdata_index_array_remote = 
            malloc(sizeof(int) * attr_p->dist_dir_attr.num_servers);

    if(!s_op->u.remove.rebuild_dirdata_index_array_remote )
    {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }

    /* This pushes a frame for the tree remove */
    PINT_CREATE_SUBORDINATE_SERVER_FRAME(smcb, remove_op,
        attr_p->dirdata_handles[0], s_op->req->u.remove.fs_id,
        location, req, LOCAL_OPERATION);

    PINT_SERVREQ_TREE_REMOVE_FILL(*req,
        s_op->req->capability,
        s_op->req->u.remove.credential,
        s_op->req->u.remove.fs_id,
        0,
        attr_p->dist_dir_attr.num_servers,
        attr_p->dirdata_handles,
        s_op->req->hints);

    return SM_ACTION_COMPLETE;
}

static PINT_sm_action remove_dirdata_handles_cleanup_tree_remove(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *remove_op = NULL;
    int task_id = 0, error_code = 0;

    /* Clean up the frame that was created for tree_remove. */
    remove_op = PINT_sm_pop_frame(smcb, &task_id, &error_code, NULL);
    tree_remove_free(remove_op);
    PINT_CLEANUP_SUBORDINATE_SERVER_FRAME(remove_op);
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action remove_dirdata_handles_check_remove_success(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = NULL;
    struct PINT_server_op *remove_op = NULL;
    PVFS_object_attr *attr_p = NULL;
    int task_id = 0, error_code = 0;
    int i = 0;

    /* This pops the frame for the tree remove - success */
    remove_op = PINT_sm_pop_frame(smcb, &task_id, &error_code, NULL);
    s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    if (error_code != 0)
    {
        js_p->error_code = error_code;
        tree_remove_free(remove_op);
        PINT_CLEANUP_SUBORDINATE_SERVER_FRAME(remove_op);
        return SM_ACTION_COMPLETE;
    }
    attr_p = &s_op->attr;
    for (i = 0; i < attr_p->dist_dir_attr.num_servers; i++)
    {
        if (remove_op->resp.u.tree_remove.status != 0)
        {
            js_p->error_code = error_code;
            tree_remove_free(remove_op);
            PINT_CLEANUP_SUBORDINATE_SERVER_FRAME(remove_op);
            return SM_ACTION_COMPLETE;
        }
    }

    /* free remove_op (allocated as subordinate frame) */
    tree_remove_free(remove_op);
    PINT_CLEANUP_SUBORDINATE_SERVER_FRAME(remove_op);

    return SM_ACTION_COMPLETE;
}

static PINT_sm_action remove_rebuild_dirdata_handle_local(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_ENOMEM;
    job_id_t tmp_id;
    PVFS_handle_extent_array extent_array;
    server_configuration_s *user_opts = PINT_server_config_mgr_get_config();

    /* save error_code */
    gossip_debug(
            GOSSIP_SERVER_DEBUG, "  remove_rebuild_dirdata: saving error_code %d\n",
            js_p->error_code);
    s_op->u.remove.saved_error_code = js_p->error_code;
    js_p->error_code = 0;

    if(!s_op->u.remove.need_rebuild_dirdata_local)
    {
        gossip_debug(
                GOSSIP_SERVER_DEBUG, "  No need to rebuild local dirdata handle! "
                "move to remote dirdata rebuild !\n");
        return SM_ACTION_COMPLETE;
    }

    gossip_debug( GOSSIP_SERVER_DEBUG, 
            "  remove_rebuild_dirdata: rebuilding local dirdata handle! \n");

    ret = PINT_config_get_meta_handle_extent_array(
        user_opts, s_op->req->u.remove.fs_id, &extent_array);
    assert(ret == 0);
    assert(extent_array.extent_count > 0);

    gossip_debug(GOSSIP_SERVER_DEBUG, " local dirdata handle(s) will "
                 "be in starting hrange[0] %llu-%llu\n",
                 llu(extent_array.extent_array[0].first),
                 llu(extent_array.extent_array[0].last));

    ret = job_trove_dspace_create_list(
        s_op->req->u.remove.fs_id,
        &extent_array,
        &s_op->u.remove.handle_local,
        1, /* dirdata_count_local = 1 */
        PVFS_TYPE_DIRDATA, 
        NULL,
        TROVE_SYNC,
        smcb,
        0,
        js_p,
        &tmp_id,
        server_job_context, 
        s_op->req->hints);

    free(extent_array.extent_array);

    return(ret);
}


static PINT_sm_action remove_rebuild_dirdata_handle_remote(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    job_id_t j_id;
    int ret = -PVFS_ENOMEM, i;
    char **io_servers_remote = NULL;
    char *string_buffer = NULL;

    if(s_op->u.remove.need_rebuild_dirdata_local)
    {
        gossip_debug(
                GOSSIP_SERVER_DEBUG, "  rebuilt local dirdata handle (%llu)\n",
                llu(s_op->u.remove.handle_local));
    }

    if(s_op->u.remove.num_rebuild_dirdata_remote == 0)
    {
        gossip_debug(
                GOSSIP_SERVER_DEBUG, "  No need to rebuild remote dirdata handle! "
                "move to write keyval !\n");
        return SM_ACTION_COMPLETE;
    }

    /* allocate space */
    io_servers_remote =
        malloc( sizeof(char*) *
                s_op->u.remove.num_rebuild_dirdata_remote);
    string_buffer = malloc(sizeof(char) * 1024 * 
                s_op->u.remove.num_rebuild_dirdata_remote);
    s_op->u.remove.handle_array_remote =
        malloc( sizeof(PVFS_handle) *
                s_op->u.remove.num_rebuild_dirdata_remote);
    if(!io_servers_remote || !string_buffer ||
            !s_op->u.remove.handle_array_remote)
    {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }

    /* find server strings */
    for(i = 0; i < s_op->u.remove.num_rebuild_dirdata_remote; i++)
    {
        io_servers_remote[i] = string_buffer + i * 1024;
        PINT_cached_config_get_server_name(io_servers_remote[i], 1024, 
                s_op->attr.dirdata_handles[s_op->u.remove.rebuild_dirdata_index_array_remote[i]], 
                s_op->req->u.remove.fs_id);
    }

    /* request remote dirdata handles */
    gossip_debug(
            GOSSIP_SERVER_DEBUG, "  rebuilding local %d remote dirdata handles! \n",
            s_op->u.remove.num_rebuild_dirdata_remote);

    ret = job_precreate_pool_get_handles(
        s_op->req->u.remove.fs_id,
        s_op->u.remove.num_rebuild_dirdata_remote,
        PVFS_TYPE_DIRDATA,
        (const char **)io_servers_remote, 
        s_op->u.remove.handle_array_remote,
        0,
        smcb,
        0,
        js_p,
        &j_id,
        server_job_context,
        s_op->req->hints);

    free(string_buffer);
    free(io_servers_remote);

    return ret;
}


static PINT_sm_action remove_rebuild_remote_dirdata_keyval_setup_msgpair(struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PINT_sm_msgpair_state *msg_p = NULL;
    PVFS_object_attr attr;
    int ret,i;

    gossip_debug(
        GOSSIP_SERVER_DEBUG, "  remove_rebuild_remote_dirdata_keyval_setup_msgpair: \n");

    if(!s_op->u.remove.need_rebuild_dirdata_local && 
            (s_op->u.remove.num_rebuild_dirdata_remote == 0))
    {
        gossip_debug(
                GOSSIP_SERVER_DEBUG, "  no dirdata handles got rebuilt! "
                "no need to write keyval.  "
                "move to dirdata cleanup !\n");
        js_p->error_code = REBUILD_DONE;
        return SM_ACTION_COMPLETE;
    }

    gossip_debug(GOSSIP_SERVER_DEBUG, 
            "\t remove_rebuild: ORIGINAL dirdata handles array of directory %llu.\n",
            llu(s_op->req->u.remove.handle));

    for(i = 0; i < s_op->attr.dist_dir_attr.num_servers; i++)
    {
        gossip_debug(GOSSIP_SERVER_DEBUG, 
                "\t\tdirdata server [%d]: %llu.\n",
                i, llu(s_op->attr.dirdata_handles[i]));
    }

    /* fill in rebuilt dirdata handles */
    if(s_op->u.remove.need_rebuild_dirdata_local)
    {
        s_op->attr.dirdata_handles[0] = s_op->u.remove.handle_local;
    }

    for(i = 0; i < s_op->u.remove.num_rebuild_dirdata_remote; i++)
    {
        s_op->attr.dirdata_handles[s_op->u.remove.rebuild_dirdata_index_array_remote[i]] = 
            s_op->u.remove.handle_array_remote[i];
    }

    gossip_debug(GOSSIP_SERVER_DEBUG, 
            "\t remove_rebuild: REBUILT dirdata handles array of directory %llu.\n",
            llu(s_op->req->u.remove.handle));

    for(i = 0; i < s_op->attr.dist_dir_attr.num_servers; i++)
    {
        gossip_debug(GOSSIP_SERVER_DEBUG, 
                "\t\tdirdata server [%d]: %llu.\n",
                i, llu(s_op->attr.dirdata_handles[i]));
    }

    /* start sending distdir attrs */
    gossip_debug(GOSSIP_SERVER_DEBUG, "remove_rebuild: send_remote_dir_data\n");

    /* !!! set dirdata attr, set all the static component */
    memcpy(&attr, &s_op->attr, sizeof(attr));
    attr.objtype = PVFS_TYPE_DIRDATA;
    attr.mask = PVFS_ATTR_COMMON_ALL;
    attr.mask |= PVFS_ATTR_DISTDIR_ATTR;

    gossip_debug(
        GOSSIP_SERVER_DEBUG,
        "remove_rebuild: SENDING attrs: [owner = %d, group = %d\n\t"
        "perms = %o, type = %d, atime = %llu, mtime = %llu\n\t"
        "ctime = %llu ]\n",
        attr.owner, attr.group, attr.perms,
        attr.objtype, llu(attr.atime),
        llu(PINT_util_mkversion_time(attr.mtime)), llu(attr.ctime));

    /* msgpair_init already does cleanup */
    PINT_msgpair_init(&s_op->msgarray_op);
    msg_p = &s_op->msgarray_op.msgpair;
    PINT_serv_init_msgarray_params(s_op, s_op->req->u.remove.fs_id);

    PINT_SERVREQ_TREE_SETATTR_FILL(
        msg_p->req,
        s_op->req->capability,
        s_op->req->u.remove.credential,
        s_op->req->u.remove.fs_id,
        PVFS_TYPE_DIRDATA,
        attr,
        0,
        s_op->attr.dist_dir_attr.num_servers,
        s_op->attr.dirdata_handles,
        s_op->req->hints);

    msg_p->fs_id = s_op->req->u.remove.fs_id;
    msg_p->handle = s_op->attr.dirdata_handles[0];
    msg_p->retry_flag = PVFS_MSGPAIR_RETRY;
    msg_p->comp_fn = NULL;

    ret = PINT_cached_config_map_to_server(
        &msg_p->svr_addr, msg_p->handle, msg_p->fs_id);

    if (ret)
    {
        gossip_err("Failed to map dirdata server address\n");
        js_p->error_code = ret;
        return SM_ACTION_COMPLETE;
    }

    PINT_sm_push_frame(smcb, 0, &s_op->msgarray_op);
    js_p->error_code = 0;
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action remove_rebuild_done(struct PINT_smcb *smcb, job_status_s *js_p)
{
    js_p->error_code = 0;
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action remove_rebuild_write_dirdata_keyval(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_ENOMEM;
    job_id_t j_id;


    /* set up key and value structures for writing dirdata handles */
    s_op->key.buffer = Trove_Common_Keys[DIST_DIRDATA_HANDLES_KEY].key;
    s_op->key.buffer_sz = Trove_Common_Keys[DIST_DIRDATA_HANDLES_KEY].size;
    if(s_op->free_val)
    {
        free(s_op->val.buffer);
    }

    s_op->val.buffer = s_op->attr.dirdata_handles;
    s_op->val.buffer_sz = s_op->attr.dist_dir_attr.num_servers *
                sizeof(PVFS_handle);
    s_op->free_val = 0; /* will be freed in PINT_free_object_attr*/

    js_p->error_code = 0;
    gossip_debug(GOSSIP_SERVER_DEBUG,
		 "  trying to write dirdata handles (coll_id = %d, "
                 "handle = %llu, key = %s (%d), val_buf = %p (%d))\n",
		 s_op->req->u.remove.fs_id, llu(s_op->req->u.remove.handle),
		 (char *)s_op->key.buffer, s_op->key.buffer_sz,
		 s_op->val.buffer, s_op->val.buffer_sz);

    ret = job_trove_keyval_write(
        s_op->req->u.remove.fs_id, s_op->req->u.remove.handle,
        &s_op->key, &s_op->val,
        0,
        NULL, smcb, 0, js_p,
        &j_id, server_job_context, s_op->req->hints);

    return ret;

}


static PINT_sm_action remove_remove_dirdata_handles_cleanup(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    PINT_msgpairarray_destroy(&s_op->msgarray_op);

    if(s_op->u.remove.rebuild_dirdata_index_array_remote)
    {
        free(s_op->u.remove.rebuild_dirdata_index_array_remote);
    }
    if(s_op->u.remove.handle_array_remote)
    {
        free(s_op->u.remove.handle_array_remote);
    }
    if(s_op->key_a)
    {
        free(s_op->key_a);
        s_op->key_a = NULL;
    }
    if(s_op->val_a)
    {
        free(s_op->val_a);
        s_op->val_a = NULL;
    }
    if(s_op->error_a)
    {
        free(s_op->error_a);
        s_op->error_a = NULL;
    }

    /* restoring js_p->error_code  */
    if(s_op->u.remove.saved_error_code)
    {
        js_p->error_code = s_op->u.remove.saved_error_code;
    }

    return SM_ACTION_COMPLETE;
}

/*
 * Function: remove_remove_dspace
 *
 * Remove the dspace using the handle from the incoming request
 * (which was verified in previous states).
 */
static PINT_sm_action remove_remove_dspace(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    job_id_t j_id;
    gossip_debug(GOSSIP_SERVER_DEBUG, "(%p) remove: removing dspace "
                 "object %llu,%d\n", s_op, llu(s_op->req->u.remove.handle),
                 s_op->req->u.remove.fs_id);

    ret = job_trove_dspace_remove(
        s_op->req->u.remove.fs_id, s_op->req->u.remove.handle,
        TROVE_SYNC,
        smcb, 0, js_p,
        &j_id, server_job_context, s_op->req->hints);

    return ret;
}

/*
 * Function: remove_cleanup
 *
 * Free all memory associated with this request and return 0, indicating
 * we're done processing.
 */
static PINT_sm_action remove_cleanup(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    if (s_op->attr.objtype == PVFS_TYPE_DIRECTORY)
    {
        PINT_perf_count(PINT_server_pc, PINT_PERF_RMDIR, 1, PINT_PERF_ADD);
        PINT_perf_timer_end(PINT_server_tpc,
                            PINT_PERF_TRMDIR,
                            &s_op->start_time);
    }
    else if (s_op->attr.objtype == PVFS_TYPE_METAFILE)
    {
        PINT_perf_count(PINT_server_pc, PINT_PERF_REMOVE, 1, PINT_PERF_ADD);
        PINT_perf_timer_end(PINT_server_tpc,
                            PINT_PERF_TREMOVE,
                            &s_op->start_time);
    }

    PINT_free_object_attr(&s_op->attr);
    return(server_state_machine_complete(smcb));
}

static int perm_remove(PINT_server_op *s_op)
{
    int ret;

    /* this capability is for the parent of the target object */
    if (s_op->req->capability.op_mask & PINT_CAP_REMOVE)
    {
        ret = 0;
    }
    else
    {
        ret = -PVFS_EACCES;
    }

    return ret;
}

PINT_GET_OBJECT_REF_DEFINE(remove);

struct PINT_server_req_params pvfs2_remove_params =
{
    .string_name = "remove",
    .get_object_ref = PINT_get_object_ref_remove,
    .perm = perm_remove,
    .access_type = PINT_server_req_modify,
    .sched_policy = PINT_SERVER_REQ_SCHEDULE,
    .state_machine = &pvfs2_remove_sm
};


/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */
