/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will certainly be overwritten.
 */

/* 
 * (C) 2003 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include "server-config.h"
#include "pvfs2-server.h"
#include "pint-security.h"
#include "pvfs2-internal.h"

static struct PINT_state_s ST_prelude;
static struct PINT_tran_tbl_s ST_prelude_trtbl[];

static PINT_sm_action truncate_resize(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_resize;
static struct PINT_tran_tbl_s ST_resize_trtbl[];

static PINT_sm_action truncate_check_error(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_check_error;
static struct PINT_tran_tbl_s ST_check_error_trtbl[];
static struct PINT_state_s ST_final_response;
static struct PINT_tran_tbl_s ST_final_response_trtbl[];

static PINT_sm_action truncate_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_cleanup;
static struct PINT_tran_tbl_s ST_cleanup_trtbl[];

struct PINT_state_machine_s pvfs2_truncate_sm = {
	.name = "pvfs2_truncate_sm",
	.first_state = &ST_prelude
};

static struct PINT_state_s ST_prelude = {
	 .state_name = "prelude" ,
	 .parent_machine = &pvfs2_truncate_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_prelude_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_prelude_trtbl 
};

static struct PINT_tran_tbl_s ST_prelude_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_resize },
	{ .return_value = -1 ,
	 .next_state = &ST_final_response }
};

static struct PINT_state_s ST_resize = {
	 .state_name = "resize" ,
	 .parent_machine = &pvfs2_truncate_sm ,
	 .flag = SM_RUN ,
	 .action.func = truncate_resize ,
	 .pjtbl = NULL ,
	 .trtbl = ST_resize_trtbl 
};

static struct PINT_tran_tbl_s ST_resize_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_check_error }
};

static struct PINT_state_s ST_check_error = {
	 .state_name = "check_error" ,
	 .parent_machine = &pvfs2_truncate_sm ,
	 .flag = SM_RUN ,
	 .action.func = truncate_check_error ,
	 .pjtbl = NULL ,
	 .trtbl = ST_check_error_trtbl 
};

static struct PINT_tran_tbl_s ST_check_error_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_final_response }
};

static struct PINT_state_s ST_final_response = {
	 .state_name = "final_response" ,
	 .parent_machine = &pvfs2_truncate_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_final_response_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_final_response_trtbl 
};

static struct PINT_tran_tbl_s ST_final_response_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_cleanup = {
	 .state_name = "cleanup" ,
	 .parent_machine = &pvfs2_truncate_sm ,
	 .flag = SM_RUN ,
	 .action.func = truncate_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_cleanup_trtbl[] = {
	{ .return_value = -1 ,

	 .flag = SM_TERM }
};

#ifndef WIN32
# 54 "src/server/truncate.sm"
#endif


static PINT_sm_action truncate_resize(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    job_id_t i;

    ret = job_trove_bstream_resize(
        s_op->req->u.truncate.fs_id, s_op->req->u.truncate.handle,
        s_op->req->u.truncate.size, s_op->req->u.truncate.flags,
        NULL, smcb, 0, js_p, &i, server_job_context,
        s_op->req->hints);

    return ret;
}

static PINT_sm_action truncate_check_error(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action truncate_cleanup(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    return (server_state_machine_complete(smcb));
}

static int perm_truncate(PINT_server_op *s_op)
{
    int ret;

    if (s_op->req->capability.op_mask & PINT_CAP_WRITE)
    {
        ret = 0;
    }
    else
    {
        ret = -PVFS_EACCES;
    }

    return ret;
}

PINT_GET_OBJECT_REF_DEFINE(truncate);

struct PINT_server_req_params pvfs2_truncate_params =
{
    .string_name = "truncate",
    .perm = perm_truncate,
    .access_type = PINT_server_req_modify,
    .sched_policy = PINT_SERVER_REQ_SCHEDULE,
    .get_object_ref = PINT_get_object_ref_truncate,
    .state_machine = &pvfs2_truncate_sm
};

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */
