/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will certainly be overwritten.
 */

/* 
 * (C) 2001 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include "pvfs2-server.h"
#include "pvfs2-internal.h"
#include "quicklist.h"


static PINT_sm_action unexpected_post(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_post_unexpected;
static struct PINT_tran_tbl_s ST_post_unexpected_trtbl[];

static PINT_sm_action unexpected_map(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_map_request;
static struct PINT_tran_tbl_s ST_map_request_trtbl[];

struct PINT_state_machine_s pvfs2_unexpected_sm = {
	.name = "pvfs2_unexpected_sm",
	.first_state = &ST_post_unexpected
};

static struct PINT_state_s ST_post_unexpected = {
	 .state_name = "post_unexpected" ,
	 .parent_machine = &pvfs2_unexpected_sm ,
	 .flag = SM_RUN ,
	 .action.func = unexpected_post ,
	 .pjtbl = NULL ,
	 .trtbl = ST_post_unexpected_trtbl 
};

static struct PINT_tran_tbl_s ST_post_unexpected_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_map_request }
};

static struct PINT_state_s ST_map_request = {
	 .state_name = "map_request" ,
	 .parent_machine = &pvfs2_unexpected_sm ,
	 .flag = SM_RUN ,
	 .action.func = unexpected_map ,
	 .pjtbl = NULL ,
	 .trtbl = ST_map_request_trtbl 
};

static struct PINT_tran_tbl_s ST_map_request_trtbl[] = {
	{ .return_value = -1 ,

	 .flag = SM_TERM }
};

#ifndef WIN32
# 33 "src/server/unexpected.sm"
#endif


/* unexpected_post()
 *
 * Post an unexpected receive
 */
static PINT_sm_action unexpected_post(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    int ret = -PVFS_EINVAL;
    struct PINT_server_op *s_op =
            (struct PINT_server_op *)PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    /*
       TODO: Consider the optimization of enabling immediate
       completion in this part of the code (see the mailing list
       thread from Feb. 2003 on pvfs2-internal).
                                                                                
       note: unexp_bmi_buff is really a struct that describes an
       unexpected message (it is an output parameter).
     */
    ret = job_bmi_unexp(&s_op->unexp_bmi_buff, smcb, 0,
                        js_p, &s_op->unexp_id, JOB_NO_IMMED_COMPLETE,
                        server_job_context);
    if(ret == SM_ACTION_COMPLETE)
    {
        PVFS_perror_gossip("Error: job_bmi_unexp failure", ret);
        return SM_ACTION_TERMINATE;
    }
    return SM_ACTION_DEFERRED;
}

/* unexpected_map()
 *
 * Change the state machine OP to that of the received request
 * This instance will continue execution in another state machine
 * Set up another unexpected receive
 */
static PINT_sm_action unexpected_map(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    int ret = 0;
    PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    /* Remove s_op from posted_sop_list */
    qlist_del(&s_op->next);
    /* If op was cancelled, kill the SM */
    if (s_op->op_cancelled)
    {
        return SM_ACTION_TERMINATE;
    }
    /* Else move it to the inprogress_sop_list */
    qlist_add_tail(&s_op->next, &inprogress_sop_list);

    /* start replacement unexpected recv */
    ret = server_post_unexpected_recv();
    if (ret < 0)
    {
        /* TODO: do something here, the return value was
         * not being checked for failure before.  I just
         * put something here to make it exit for the
         * moment.  -Phil
         */
        PVFS_perror_gossip("pvfs2_unexpected_sm.unexpected_map: server_post_unexpected_recv() returned an error: ",ret);
    }

    /* restart as new request state machine */
    memset(js_p, 0, sizeof(job_status_s));
    ret = server_state_machine_start(smcb, js_p);
    if (ret < 0)
    {
        PVFS_perror_gossip("Error: server_state_machine_start", ret);
        /* TODO: tell BMI to drop this address? */
        /* set return code to let this SM end
         */
        ret = SM_ACTION_TERMINATE;
    }

    return ret;
}


/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */

